// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/api/servicemanagement/v1/servicemanager.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fapi_2fservicemanagement_2fv1_2fservicemanager_2eproto__INCLUDED
#define GRPC_google_2fapi_2fservicemanagement_2fv1_2fservicemanager_2eproto__INCLUDED

#include "google/api/servicemanagement/v1/servicemanager.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace api {
namespace servicemanagement {
namespace v1 {

// [Google Service Management
// API](https://cloud.google.com/service-infrastructure/docs/overview)
class ServiceManager final {
 public:
  static constexpr char const* service_full_name() {
    return "google.api.servicemanagement.v1.ServiceManager";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists managed services.
    //
    // Returns all public services. For authenticated users, also returns all
    // services the calling user has "servicemanagement.services.get" permission
    // for.
    virtual ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::google::api::servicemanagement::v1::ListServicesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    // Gets a managed service. Authentication is required unless the service is
    // public.
    virtual ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::google::api::servicemanagement::v1::ManagedService* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ManagedService>> AsyncGetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ManagedService>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ManagedService>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ManagedService>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    // Creates a new managed service.
    //
    // A managed service is immutable, and is subject to mandatory 30-day
    // data retention. You cannot move a service or recreate it within 30 days
    // after deletion.
    //
    // One producer project can own no more than 500 services. For security and
    // reliability purposes, a production service should be hosted in a
    // dedicated producer project.
    //
    // Operation<response: ManagedService>
    virtual ::grpc::Status CreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateServiceRaw(context, request, cq));
    }
    // Deletes a managed service. This method will change the service to the
    // `Soft-Delete` state for 30 days. Within this period, service producers may
    // call
    // [UndeleteService][google.api.servicemanagement.v1.ServiceManager.UndeleteService]
    // to restore the service. After 30 days, the service will be permanently
    // deleted.
    //
    // Operation<response: google.protobuf.Empty>
    virtual ::grpc::Status DeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteServiceRaw(context, request, cq));
    }
    // Revives a previously deleted managed service. The method restores the
    // service using the configuration at the time the service was deleted.
    // The target service must exist and must have been deleted within the
    // last 30 days.
    //
    // Operation<response: UndeleteServiceResponse>
    virtual ::grpc::Status UndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeleteServiceRaw(context, request, cq));
    }
    // Lists the history of the service configuration for a managed service,
    // from the newest to the oldest.
    virtual ::grpc::Status ListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>> AsyncListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>>(AsyncListServiceConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>> PrepareAsyncListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>>(PrepareAsyncListServiceConfigsRaw(context, request, cq));
    }
    // Gets a service configuration (version) for a managed service.
    virtual ::grpc::Status GetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::google::api::Service* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>> AsyncGetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>>(AsyncGetServiceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>> PrepareAsyncGetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>>(PrepareAsyncGetServiceConfigRaw(context, request, cq));
    }
    // Creates a new service configuration (version) for a managed service.
    // This method only stores the service configuration. To roll out the service
    // configuration to backend systems please call
    // [CreateServiceRollout][google.api.servicemanagement.v1.ServiceManager.CreateServiceRollout].
    //
    // Only the 100 most recent service configurations and ones referenced by
    // existing rollouts are kept for each service. The rest will be deleted
    // eventually.
    virtual ::grpc::Status CreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::google::api::Service* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>> AsyncCreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>>(AsyncCreateServiceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>> PrepareAsyncCreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>>(PrepareAsyncCreateServiceConfigRaw(context, request, cq));
    }
    // Creates a new service configuration (version) for a managed service based
    // on
    // user-supplied configuration source files (for example: OpenAPI
    // Specification). This method stores the source configurations as well as the
    // generated service configuration. To rollout the service configuration to
    // other services,
    // please call
    // [CreateServiceRollout][google.api.servicemanagement.v1.ServiceManager.CreateServiceRollout].
    //
    // Only the 100 most recent configuration sources and ones referenced by
    // existing service configurtions are kept for each service. The rest will be
    // deleted eventually.
    //
    // Operation<response: SubmitConfigSourceResponse>
    virtual ::grpc::Status SubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSubmitConfigSourceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSubmitConfigSourceRaw(context, request, cq));
    }
    // Lists the history of the service configuration rollouts for a managed
    // service, from the newest to the oldest.
    virtual ::grpc::Status ListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>> AsyncListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>>(AsyncListServiceRolloutsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>> PrepareAsyncListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>>(PrepareAsyncListServiceRolloutsRaw(context, request, cq));
    }
    // Gets a service configuration
    // [rollout][google.api.servicemanagement.v1.Rollout].
    virtual ::grpc::Status GetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::google::api::servicemanagement::v1::Rollout* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::Rollout>> AsyncGetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::Rollout>>(AsyncGetServiceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::Rollout>> PrepareAsyncGetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::Rollout>>(PrepareAsyncGetServiceRolloutRaw(context, request, cq));
    }
    // Creates a new service configuration rollout. Based on rollout, the
    // Google Service Management will roll out the service configurations to
    // different backend services. For example, the logging configuration will be
    // pushed to Google Cloud Logging.
    //
    // Please note that any previous pending and running Rollouts and associated
    // Operations will be automatically cancelled so that the latest Rollout will
    // not be blocked by previous Rollouts.
    //
    // Only the 100 most recent (in any state) and the last 10 successful (if not
    // already part of the set of 100 most recent) rollouts are kept for each
    // service. The rest will be deleted eventually.
    //
    // Operation<response: Rollout>
    virtual ::grpc::Status CreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateServiceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateServiceRolloutRaw(context, request, cq));
    }
    // Generates and returns a report (errors, warnings and changes from
    // existing configurations) associated with
    // GenerateConfigReportRequest.new_value
    //
    // If GenerateConfigReportRequest.old_value is specified,
    // GenerateConfigReportRequest will contain a single ChangeReport based on the
    // comparison between GenerateConfigReportRequest.new_value and
    // GenerateConfigReportRequest.old_value.
    // If GenerateConfigReportRequest.old_value is not specified, this method
    // will compare GenerateConfigReportRequest.new_value with the last pushed
    // service configuration.
    virtual ::grpc::Status GenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>> AsyncGenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>>(AsyncGenerateConfigReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>> PrepareAsyncGenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>>(PrepareAsyncGenerateConfigReportRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists managed services.
      //
      // Returns all public services. For authenticated users, also returns all
      // services the calling user has "servicemanagement.services.get" permission
      // for.
      virtual void ListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest* request, ::google::api::servicemanagement::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest* request, ::google::api::servicemanagement::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a managed service. Authentication is required unless the service is
      // public.
      virtual void GetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest* request, ::google::api::servicemanagement::v1::ManagedService* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest* request, ::google::api::servicemanagement::v1::ManagedService* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new managed service.
      //
      // A managed service is immutable, and is subject to mandatory 30-day
      // data retention. You cannot move a service or recreate it within 30 days
      // after deletion.
      //
      // One producer project can own no more than 500 services. For security and
      // reliability purposes, a production service should be hosted in a
      // dedicated producer project.
      //
      // Operation<response: ManagedService>
      virtual void CreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a managed service. This method will change the service to the
      // `Soft-Delete` state for 30 days. Within this period, service producers may
      // call
      // [UndeleteService][google.api.servicemanagement.v1.ServiceManager.UndeleteService]
      // to restore the service. After 30 days, the service will be permanently
      // deleted.
      //
      // Operation<response: google.protobuf.Empty>
      virtual void DeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Revives a previously deleted managed service. The method restores the
      // service using the configuration at the time the service was deleted.
      // The target service must exist and must have been deleted within the
      // last 30 days.
      //
      // Operation<response: UndeleteServiceResponse>
      virtual void UndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the history of the service configuration for a managed service,
      // from the newest to the oldest.
      virtual void ListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a service configuration (version) for a managed service.
      virtual void GetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::google::api::Service* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::google::api::Service* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new service configuration (version) for a managed service.
      // This method only stores the service configuration. To roll out the service
      // configuration to backend systems please call
      // [CreateServiceRollout][google.api.servicemanagement.v1.ServiceManager.CreateServiceRollout].
      //
      // Only the 100 most recent service configurations and ones referenced by
      // existing rollouts are kept for each service. The rest will be deleted
      // eventually.
      virtual void CreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::google::api::Service* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::google::api::Service* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new service configuration (version) for a managed service based
      // on
      // user-supplied configuration source files (for example: OpenAPI
      // Specification). This method stores the source configurations as well as the
      // generated service configuration. To rollout the service configuration to
      // other services,
      // please call
      // [CreateServiceRollout][google.api.servicemanagement.v1.ServiceManager.CreateServiceRollout].
      //
      // Only the 100 most recent configuration sources and ones referenced by
      // existing service configurtions are kept for each service. The rest will be
      // deleted eventually.
      //
      // Operation<response: SubmitConfigSourceResponse>
      virtual void SubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the history of the service configuration rollouts for a managed
      // service, from the newest to the oldest.
      virtual void ListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a service configuration
      // [rollout][google.api.servicemanagement.v1.Rollout].
      virtual void GetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::google::api::servicemanagement::v1::Rollout* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::google::api::servicemanagement::v1::Rollout* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new service configuration rollout. Based on rollout, the
      // Google Service Management will roll out the service configurations to
      // different backend services. For example, the logging configuration will be
      // pushed to Google Cloud Logging.
      //
      // Please note that any previous pending and running Rollouts and associated
      // Operations will be automatically cancelled so that the latest Rollout will
      // not be blocked by previous Rollouts.
      //
      // Only the 100 most recent (in any state) and the last 10 successful (if not
      // already part of the set of 100 most recent) rollouts are kept for each
      // service. The rest will be deleted eventually.
      //
      // Operation<response: Rollout>
      virtual void CreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generates and returns a report (errors, warnings and changes from
      // existing configurations) associated with
      // GenerateConfigReportRequest.new_value
      //
      // If GenerateConfigReportRequest.old_value is specified,
      // GenerateConfigReportRequest will contain a single ChangeReport based on the
      // comparison between GenerateConfigReportRequest.new_value and
      // GenerateConfigReportRequest.old_value.
      // If GenerateConfigReportRequest.old_value is not specified, this method
      // will compare GenerateConfigReportRequest.new_value with the last pushed
      // service configuration.
      virtual void GenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ManagedService>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ManagedService>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* AsyncListServiceConfigsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* PrepareAsyncListServiceConfigsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>* AsyncGetServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>* PrepareAsyncGetServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>* AsyncCreateServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::Service>* PrepareAsyncCreateServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSubmitConfigSourceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSubmitConfigSourceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* AsyncListServiceRolloutsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* PrepareAsyncListServiceRolloutsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::Rollout>* AsyncGetServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::Rollout>* PrepareAsyncGetServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* AsyncGenerateConfigReportRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* PrepareAsyncGenerateConfigReportRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::google::api::servicemanagement::v1::ListServicesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::google::api::servicemanagement::v1::ManagedService* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ManagedService>> AsyncGetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ManagedService>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ManagedService>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ManagedService>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    ::grpc::Status CreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateServiceRaw(context, request, cq));
    }
    ::grpc::Status DeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteServiceRaw(context, request, cq));
    }
    ::grpc::Status UndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeleteServiceRaw(context, request, cq));
    }
    ::grpc::Status ListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>> AsyncListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>>(AsyncListServiceConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>> PrepareAsyncListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>>(PrepareAsyncListServiceConfigsRaw(context, request, cq));
    }
    ::grpc::Status GetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::google::api::Service* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>> AsyncGetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>>(AsyncGetServiceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>> PrepareAsyncGetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>>(PrepareAsyncGetServiceConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::google::api::Service* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>> AsyncCreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>>(AsyncCreateServiceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>> PrepareAsyncCreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::Service>>(PrepareAsyncCreateServiceConfigRaw(context, request, cq));
    }
    ::grpc::Status SubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSubmitConfigSourceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSubmitConfigSourceRaw(context, request, cq));
    }
    ::grpc::Status ListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>> AsyncListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>>(AsyncListServiceRolloutsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>> PrepareAsyncListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>>(PrepareAsyncListServiceRolloutsRaw(context, request, cq));
    }
    ::grpc::Status GetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::google::api::servicemanagement::v1::Rollout* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::Rollout>> AsyncGetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::Rollout>>(AsyncGetServiceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::Rollout>> PrepareAsyncGetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::Rollout>>(PrepareAsyncGetServiceRolloutRaw(context, request, cq));
    }
    ::grpc::Status CreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateServiceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateServiceRolloutRaw(context, request, cq));
    }
    ::grpc::Status GenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>> AsyncGenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>>(AsyncGenerateConfigReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>> PrepareAsyncGenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>>(PrepareAsyncGenerateConfigReportRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest* request, ::google::api::servicemanagement::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServices(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest* request, ::google::api::servicemanagement::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest* request, ::google::api::servicemanagement::v1::ManagedService* response, std::function<void(::grpc::Status)>) override;
      void GetService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest* request, ::google::api::servicemanagement::v1::ManagedService* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeleteService(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServiceConfigs(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::google::api::Service* response, std::function<void(::grpc::Status)>) override;
      void GetServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::google::api::Service* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::google::api::Service* response, std::function<void(::grpc::Status)>) override;
      void CreateServiceConfig(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::google::api::Service* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SubmitConfigSource(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServiceRollouts(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::google::api::servicemanagement::v1::Rollout* response, std::function<void(::grpc::Status)>) override;
      void GetServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::google::api::servicemanagement::v1::Rollout* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateServiceRollout(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateConfigReport(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ManagedService>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ManagedService>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeleteServiceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* AsyncListServiceConfigsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* PrepareAsyncListServiceConfigsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::Service>* AsyncGetServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::Service>* PrepareAsyncGetServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::Service>* AsyncCreateServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::Service>* PrepareAsyncCreateServiceConfigRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSubmitConfigSourceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSubmitConfigSourceRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* AsyncListServiceRolloutsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* PrepareAsyncListServiceRolloutsRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::Rollout>* AsyncGetServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::Rollout>* PrepareAsyncGetServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateServiceRolloutRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* AsyncGenerateConfigReportRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* PrepareAsyncGenerateConfigReportRaw(::grpc::ClientContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListServices_;
    const ::grpc::internal::RpcMethod rpcmethod_GetService_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateService_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteService_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeleteService_;
    const ::grpc::internal::RpcMethod rpcmethod_ListServiceConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetServiceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateServiceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_SubmitConfigSource_;
    const ::grpc::internal::RpcMethod rpcmethod_ListServiceRollouts_;
    const ::grpc::internal::RpcMethod rpcmethod_GetServiceRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateServiceRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateConfigReport_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists managed services.
    //
    // Returns all public services. For authenticated users, also returns all
    // services the calling user has "servicemanagement.services.get" permission
    // for.
    virtual ::grpc::Status ListServices(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest* request, ::google::api::servicemanagement::v1::ListServicesResponse* response);
    // Gets a managed service. Authentication is required unless the service is
    // public.
    virtual ::grpc::Status GetService(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest* request, ::google::api::servicemanagement::v1::ManagedService* response);
    // Creates a new managed service.
    //
    // A managed service is immutable, and is subject to mandatory 30-day
    // data retention. You cannot move a service or recreate it within 30 days
    // after deletion.
    //
    // One producer project can own no more than 500 services. For security and
    // reliability purposes, a production service should be hosted in a
    // dedicated producer project.
    //
    // Operation<response: ManagedService>
    virtual ::grpc::Status CreateService(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response);
    // Deletes a managed service. This method will change the service to the
    // `Soft-Delete` state for 30 days. Within this period, service producers may
    // call
    // [UndeleteService][google.api.servicemanagement.v1.ServiceManager.UndeleteService]
    // to restore the service. After 30 days, the service will be permanently
    // deleted.
    //
    // Operation<response: google.protobuf.Empty>
    virtual ::grpc::Status DeleteService(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response);
    // Revives a previously deleted managed service. The method restores the
    // service using the configuration at the time the service was deleted.
    // The target service must exist and must have been deleted within the
    // last 30 days.
    //
    // Operation<response: UndeleteServiceResponse>
    virtual ::grpc::Status UndeleteService(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::google::longrunning::Operation* response);
    // Lists the history of the service configuration for a managed service,
    // from the newest to the oldest.
    virtual ::grpc::Status ListServiceConfigs(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response);
    // Gets a service configuration (version) for a managed service.
    virtual ::grpc::Status GetServiceConfig(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::google::api::Service* response);
    // Creates a new service configuration (version) for a managed service.
    // This method only stores the service configuration. To roll out the service
    // configuration to backend systems please call
    // [CreateServiceRollout][google.api.servicemanagement.v1.ServiceManager.CreateServiceRollout].
    //
    // Only the 100 most recent service configurations and ones referenced by
    // existing rollouts are kept for each service. The rest will be deleted
    // eventually.
    virtual ::grpc::Status CreateServiceConfig(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::google::api::Service* response);
    // Creates a new service configuration (version) for a managed service based
    // on
    // user-supplied configuration source files (for example: OpenAPI
    // Specification). This method stores the source configurations as well as the
    // generated service configuration. To rollout the service configuration to
    // other services,
    // please call
    // [CreateServiceRollout][google.api.servicemanagement.v1.ServiceManager.CreateServiceRollout].
    //
    // Only the 100 most recent configuration sources and ones referenced by
    // existing service configurtions are kept for each service. The rest will be
    // deleted eventually.
    //
    // Operation<response: SubmitConfigSourceResponse>
    virtual ::grpc::Status SubmitConfigSource(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::google::longrunning::Operation* response);
    // Lists the history of the service configuration rollouts for a managed
    // service, from the newest to the oldest.
    virtual ::grpc::Status ListServiceRollouts(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response);
    // Gets a service configuration
    // [rollout][google.api.servicemanagement.v1.Rollout].
    virtual ::grpc::Status GetServiceRollout(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::google::api::servicemanagement::v1::Rollout* response);
    // Creates a new service configuration rollout. Based on rollout, the
    // Google Service Management will roll out the service configurations to
    // different backend services. For example, the logging configuration will be
    // pushed to Google Cloud Logging.
    //
    // Please note that any previous pending and running Rollouts and associated
    // Operations will be automatically cancelled so that the latest Rollout will
    // not be blocked by previous Rollouts.
    //
    // Only the 100 most recent (in any state) and the last 10 successful (if not
    // already part of the set of 100 most recent) rollouts are kept for each
    // service. The rest will be deleted eventually.
    //
    // Operation<response: Rollout>
    virtual ::grpc::Status CreateServiceRollout(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::google::longrunning::Operation* response);
    // Generates and returns a report (errors, warnings and changes from
    // existing configurations) associated with
    // GenerateConfigReportRequest.new_value
    //
    // If GenerateConfigReportRequest.old_value is specified,
    // GenerateConfigReportRequest will contain a single ChangeReport based on the
    // comparison between GenerateConfigReportRequest.new_value and
    // GenerateConfigReportRequest.old_value.
    // If GenerateConfigReportRequest.old_value is not specified, this method
    // will compare GenerateConfigReportRequest.new_value with the last pushed
    // service configuration.
    virtual ::grpc::Status GenerateConfigReport(::grpc::ServerContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServices() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::ListServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicemanagement::v1::ListServicesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetService() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::GetServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicemanagement::v1::ManagedService>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateService() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateService(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteService() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteService(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeleteService() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UndeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteService(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServiceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServiceConfigs() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListServiceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceConfigs(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServiceConfigs(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetServiceConfig() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetServiceConfig(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::Service>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateServiceConfig() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateServiceConfig(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::Service>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SubmitConfigSource : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SubmitConfigSource() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_SubmitConfigSource() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitConfigSource(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitConfigSource(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServiceRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServiceRollouts() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListServiceRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceRollouts(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServiceRollouts(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetServiceRollout() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetServiceRollout(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicemanagement::v1::Rollout>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateServiceRollout() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_CreateServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateServiceRollout(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateConfigReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateConfigReport() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GenerateConfigReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConfigReport(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateConfigReport(::grpc::ServerContext* context, ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListServices<WithAsyncMethod_GetService<WithAsyncMethod_CreateService<WithAsyncMethod_DeleteService<WithAsyncMethod_UndeleteService<WithAsyncMethod_ListServiceConfigs<WithAsyncMethod_GetServiceConfig<WithAsyncMethod_CreateServiceConfig<WithAsyncMethod_SubmitConfigSource<WithAsyncMethod_ListServiceRollouts<WithAsyncMethod_GetServiceRollout<WithAsyncMethod_CreateServiceRollout<WithAsyncMethod_GenerateConfigReport<Service > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::ListServicesRequest, ::google::api::servicemanagement::v1::ListServicesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::ListServicesRequest* request, ::google::api::servicemanagement::v1::ListServicesResponse* response) { return this->ListServices(context, request, response); }));}
    void SetMessageAllocatorFor_ListServices(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::ListServicesRequest, ::google::api::servicemanagement::v1::ListServicesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::ListServicesRequest, ::google::api::servicemanagement::v1::ListServicesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GetServiceRequest, ::google::api::servicemanagement::v1::ManagedService>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::GetServiceRequest* request, ::google::api::servicemanagement::v1::ManagedService* response) { return this->GetService(context, request, response); }));}
    void SetMessageAllocatorFor_GetService(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::GetServiceRequest, ::google::api::servicemanagement::v1::ManagedService>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GetServiceRequest, ::google::api::servicemanagement::v1::ManagedService>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateService() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::CreateServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::CreateServiceRequest* request, ::google::longrunning::Operation* response) { return this->CreateService(context, request, response); }));}
    void SetMessageAllocatorFor_CreateService(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::CreateServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::CreateServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteService() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::DeleteServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteService(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteService(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::DeleteServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::DeleteServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeleteService() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::UndeleteServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* request, ::google::longrunning::Operation* response) { return this->UndeleteService(context, request, response); }));}
    void SetMessageAllocatorFor_UndeleteService(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::UndeleteServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::UndeleteServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListServiceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServiceConfigs() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::ListServiceConfigsRequest, ::google::api::servicemanagement::v1::ListServiceConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* request, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* response) { return this->ListServiceConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListServiceConfigs(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::ListServiceConfigsRequest, ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::ListServiceConfigsRequest, ::google::api::servicemanagement::v1::ListServiceConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServiceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceConfigs(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServiceConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetServiceConfig() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GetServiceConfigRequest, ::google::api::Service>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* request, ::google::api::Service* response) { return this->GetServiceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetServiceConfig(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::GetServiceConfigRequest, ::google::api::Service>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GetServiceConfigRequest, ::google::api::Service>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetServiceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateServiceConfig() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::CreateServiceConfigRequest, ::google::api::Service>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* request, ::google::api::Service* response) { return this->CreateServiceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateServiceConfig(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::CreateServiceConfigRequest, ::google::api::Service>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::CreateServiceConfigRequest, ::google::api::Service>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateServiceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SubmitConfigSource : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SubmitConfigSource() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::SubmitConfigSourceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* request, ::google::longrunning::Operation* response) { return this->SubmitConfigSource(context, request, response); }));}
    void SetMessageAllocatorFor_SubmitConfigSource(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::SubmitConfigSourceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::SubmitConfigSourceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SubmitConfigSource() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitConfigSource(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitConfigSource(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListServiceRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServiceRollouts() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::ListServiceRolloutsRequest, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* request, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* response) { return this->ListServiceRollouts(context, request, response); }));}
    void SetMessageAllocatorFor_ListServiceRollouts(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::ListServiceRolloutsRequest, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::ListServiceRolloutsRequest, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServiceRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceRollouts(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServiceRollouts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetServiceRollout() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GetServiceRolloutRequest, ::google::api::servicemanagement::v1::Rollout>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* request, ::google::api::servicemanagement::v1::Rollout* response) { return this->GetServiceRollout(context, request, response); }));}
    void SetMessageAllocatorFor_GetServiceRollout(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::GetServiceRolloutRequest, ::google::api::servicemanagement::v1::Rollout>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GetServiceRolloutRequest, ::google::api::servicemanagement::v1::Rollout>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetServiceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateServiceRollout() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::CreateServiceRolloutRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* request, ::google::longrunning::Operation* response) { return this->CreateServiceRollout(context, request, response); }));}
    void SetMessageAllocatorFor_CreateServiceRollout(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::CreateServiceRolloutRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::CreateServiceRolloutRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateServiceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateConfigReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateConfigReport() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GenerateConfigReportRequest, ::google::api::servicemanagement::v1::GenerateConfigReportResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* request, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* response) { return this->GenerateConfigReport(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateConfigReport(
        ::grpc::MessageAllocator< ::google::api::servicemanagement::v1::GenerateConfigReportRequest, ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicemanagement::v1::GenerateConfigReportRequest, ::google::api::servicemanagement::v1::GenerateConfigReportResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateConfigReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConfigReport(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateConfigReport(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListServices<WithCallbackMethod_GetService<WithCallbackMethod_CreateService<WithCallbackMethod_DeleteService<WithCallbackMethod_UndeleteService<WithCallbackMethod_ListServiceConfigs<WithCallbackMethod_GetServiceConfig<WithCallbackMethod_CreateServiceConfig<WithCallbackMethod_SubmitConfigSource<WithCallbackMethod_ListServiceRollouts<WithCallbackMethod_GetServiceRollout<WithCallbackMethod_CreateServiceRollout<WithCallbackMethod_GenerateConfigReport<Service > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServices() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetService() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateService() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteService() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeleteService() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UndeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListServiceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServiceConfigs() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListServiceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceConfigs(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetServiceConfig() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateServiceConfig() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SubmitConfigSource : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SubmitConfigSource() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_SubmitConfigSource() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitConfigSource(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListServiceRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServiceRollouts() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListServiceRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceRollouts(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetServiceRollout() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateServiceRollout() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_CreateServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateConfigReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateConfigReport() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GenerateConfigReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConfigReport(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServices() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetService() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateService() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteService() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeleteService() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UndeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServiceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServiceConfigs() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListServiceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceConfigs(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServiceConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetServiceConfig() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetServiceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateServiceConfig() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateServiceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SubmitConfigSource : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SubmitConfigSource() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_SubmitConfigSource() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitConfigSource(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitConfigSource(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServiceRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServiceRollouts() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListServiceRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceRollouts(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServiceRollouts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetServiceRollout() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetServiceRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateServiceRollout() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_CreateServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateServiceRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateConfigReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateConfigReport() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GenerateConfigReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConfigReport(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateConfigReport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetService(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateService() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateService(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteService() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteService(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeleteService() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeleteService(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServiceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServiceConfigs() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServiceConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServiceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceConfigs(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServiceConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetServiceConfig() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetServiceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetServiceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateServiceConfig() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateServiceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateServiceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SubmitConfigSource : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SubmitConfigSource() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SubmitConfigSource(context, request, response); }));
    }
    ~WithRawCallbackMethod_SubmitConfigSource() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitConfigSource(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitConfigSource(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServiceRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServiceRollouts() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServiceRollouts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServiceRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServiceRollouts(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServiceRollouts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetServiceRollout() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetServiceRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetServiceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateServiceRollout() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateServiceRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateServiceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateConfigReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateConfigReport() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateConfigReport(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateConfigReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConfigReport(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateConfigReport(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServices() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::ListServicesRequest, ::google::api::servicemanagement::v1::ListServicesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::ListServicesRequest, ::google::api::servicemanagement::v1::ListServicesResponse>* streamer) {
                       return this->StreamedListServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServicesRequest* /*request*/, ::google::api::servicemanagement::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::ListServicesRequest,::google::api::servicemanagement::v1::ListServicesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetService() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::GetServiceRequest, ::google::api::servicemanagement::v1::ManagedService>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::GetServiceRequest, ::google::api::servicemanagement::v1::ManagedService>* streamer) {
                       return this->StreamedGetService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRequest* /*request*/, ::google::api::servicemanagement::v1::ManagedService* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::GetServiceRequest,::google::api::servicemanagement::v1::ManagedService>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateService() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::CreateServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::CreateServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::CreateServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteService() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::DeleteServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::DeleteServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::DeleteServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeleteService() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::UndeleteServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::UndeleteServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeleteService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeleteService(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::UndeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeleteService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::UndeleteServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServiceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServiceConfigs() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::ListServiceConfigsRequest, ::google::api::servicemanagement::v1::ListServiceConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::ListServiceConfigsRequest, ::google::api::servicemanagement::v1::ListServiceConfigsResponse>* streamer) {
                       return this->StreamedListServiceConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServiceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServiceConfigs(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceConfigsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServiceConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::ListServiceConfigsRequest,::google::api::servicemanagement::v1::ListServiceConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetServiceConfig() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::GetServiceConfigRequest, ::google::api::Service>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::GetServiceConfigRequest, ::google::api::Service>* streamer) {
                       return this->StreamedGetServiceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetServiceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::GetServiceConfigRequest,::google::api::Service>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateServiceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateServiceConfig() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::CreateServiceConfigRequest, ::google::api::Service>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::CreateServiceConfigRequest, ::google::api::Service>* streamer) {
                       return this->StreamedCreateServiceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateServiceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateServiceConfig(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceConfigRequest* /*request*/, ::google::api::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateServiceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::CreateServiceConfigRequest,::google::api::Service>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SubmitConfigSource : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SubmitConfigSource() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::SubmitConfigSourceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::SubmitConfigSourceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSubmitConfigSource(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SubmitConfigSource() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SubmitConfigSource(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::SubmitConfigSourceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSubmitConfigSource(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::SubmitConfigSourceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServiceRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServiceRollouts() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::ListServiceRolloutsRequest, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::ListServiceRolloutsRequest, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* streamer) {
                       return this->StreamedListServiceRollouts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServiceRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServiceRollouts(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::ListServiceRolloutsRequest* /*request*/, ::google::api::servicemanagement::v1::ListServiceRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServiceRollouts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::ListServiceRolloutsRequest,::google::api::servicemanagement::v1::ListServiceRolloutsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetServiceRollout() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::GetServiceRolloutRequest, ::google::api::servicemanagement::v1::Rollout>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::GetServiceRolloutRequest, ::google::api::servicemanagement::v1::Rollout>* streamer) {
                       return this->StreamedGetServiceRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GetServiceRolloutRequest* /*request*/, ::google::api::servicemanagement::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetServiceRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::GetServiceRolloutRequest,::google::api::servicemanagement::v1::Rollout>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateServiceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateServiceRollout() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::CreateServiceRolloutRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::CreateServiceRolloutRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateServiceRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateServiceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateServiceRollout(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::CreateServiceRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateServiceRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::CreateServiceRolloutRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateConfigReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateConfigReport() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicemanagement::v1::GenerateConfigReportRequest, ::google::api::servicemanagement::v1::GenerateConfigReportResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicemanagement::v1::GenerateConfigReportRequest, ::google::api::servicemanagement::v1::GenerateConfigReportResponse>* streamer) {
                       return this->StreamedGenerateConfigReport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateConfigReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateConfigReport(::grpc::ServerContext* /*context*/, const ::google::api::servicemanagement::v1::GenerateConfigReportRequest* /*request*/, ::google::api::servicemanagement::v1::GenerateConfigReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateConfigReport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicemanagement::v1::GenerateConfigReportRequest,::google::api::servicemanagement::v1::GenerateConfigReportResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_CreateService<WithStreamedUnaryMethod_DeleteService<WithStreamedUnaryMethod_UndeleteService<WithStreamedUnaryMethod_ListServiceConfigs<WithStreamedUnaryMethod_GetServiceConfig<WithStreamedUnaryMethod_CreateServiceConfig<WithStreamedUnaryMethod_SubmitConfigSource<WithStreamedUnaryMethod_ListServiceRollouts<WithStreamedUnaryMethod_GetServiceRollout<WithStreamedUnaryMethod_CreateServiceRollout<WithStreamedUnaryMethod_GenerateConfigReport<Service > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_CreateService<WithStreamedUnaryMethod_DeleteService<WithStreamedUnaryMethod_UndeleteService<WithStreamedUnaryMethod_ListServiceConfigs<WithStreamedUnaryMethod_GetServiceConfig<WithStreamedUnaryMethod_CreateServiceConfig<WithStreamedUnaryMethod_SubmitConfigSource<WithStreamedUnaryMethod_ListServiceRollouts<WithStreamedUnaryMethod_GetServiceRollout<WithStreamedUnaryMethod_CreateServiceRollout<WithStreamedUnaryMethod_GenerateConfigReport<Service > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace servicemanagement
}  // namespace api
}  // namespace google


#endif  // GRPC_google_2fapi_2fservicemanagement_2fv1_2fservicemanager_2eproto__INCLUDED
