// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/beyondcorp/appconnections/v1/app_connections_service.proto
// Original file comments:
// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbeyondcorp_2fappconnections_2fv1_2fapp_5fconnections_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbeyondcorp_2fappconnections_2fv1_2fapp_5fconnections_5fservice_2eproto__INCLUDED

#include "google/cloud/beyondcorp/appconnections/v1/app_connections_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace beyondcorp {
namespace appconnections {
namespace v1 {

// API Overview:
//
// The `beyondcorp.googleapis.com` service implements the Google Cloud
// BeyondCorp API.
//
// Data Model:
//
// The AppConnectionsService exposes the following resources:
//
// * AppConnections, named as follows:
//   `projects/{project_id}/locations/{location_id}/appConnections/{app_connection_id}`.
//
// The AppConnectionsService service provides methods to manage
// (create/read/update/delete) BeyondCorp AppConnections.
class AppConnectionsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.beyondcorp.appconnections.v1.AppConnectionsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists AppConnections in a given project and location.
    virtual ::grpc::Status ListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>> AsyncListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>>(AsyncListAppConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>> PrepareAsyncListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>>(PrepareAsyncListAppConnectionsRaw(context, request, cq));
    }
    // Gets details of a single AppConnection.
    virtual ::grpc::Status GetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>> AsyncGetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>>(AsyncGetAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>> PrepareAsyncGetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>>(PrepareAsyncGetAppConnectionRaw(context, request, cq));
    }
    // Creates a new AppConnection in a given project and location.
    virtual ::grpc::Status CreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAppConnectionRaw(context, request, cq));
    }
    // Updates the parameters of a single AppConnection.
    virtual ::grpc::Status UpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAppConnectionRaw(context, request, cq));
    }
    // Deletes a single AppConnection.
    virtual ::grpc::Status DeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAppConnectionRaw(context, request, cq));
    }
    // Resolves AppConnections details for a given AppConnector.
    // An internal method called by a connector to find AppConnections to connect
    // to.
    virtual ::grpc::Status ResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>> AsyncResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>>(AsyncResolveAppConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>> PrepareAsyncResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>>(PrepareAsyncResolveAppConnectionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists AppConnections in a given project and location.
      virtual void ListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single AppConnection.
      virtual void GetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new AppConnection in a given project and location.
      virtual void CreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single AppConnection.
      virtual void UpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single AppConnection.
      virtual void DeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resolves AppConnections details for a given AppConnector.
      // An internal method called by a connector to find AppConnections to connect
      // to.
      virtual void ResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* AsyncListAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* PrepareAsyncListAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* AsyncGetAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* PrepareAsyncGetAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* AsyncResolveAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* PrepareAsyncResolveAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>> AsyncListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>>(AsyncListAppConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>> PrepareAsyncListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>>(PrepareAsyncListAppConnectionsRaw(context, request, cq));
    }
    ::grpc::Status GetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>> AsyncGetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>>(AsyncGetAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>> PrepareAsyncGetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>>(PrepareAsyncGetAppConnectionRaw(context, request, cq));
    }
    ::grpc::Status CreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAppConnectionRaw(context, request, cq));
    }
    ::grpc::Status UpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAppConnectionRaw(context, request, cq));
    }
    ::grpc::Status DeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAppConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAppConnectionRaw(context, request, cq));
    }
    ::grpc::Status ResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>> AsyncResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>>(AsyncResolveAppConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>> PrepareAsyncResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>>(PrepareAsyncResolveAppConnectionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response, std::function<void(::grpc::Status)>) override;
      void GetAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAppConnection(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ResolveAppConnections(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* AsyncListAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* PrepareAsyncListAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* AsyncGetAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* PrepareAsyncGetAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAppConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* AsyncResolveAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* PrepareAsyncResolveAppConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAppConnections_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAppConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAppConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAppConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAppConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_ResolveAppConnections_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists AppConnections in a given project and location.
    virtual ::grpc::Status ListAppConnections(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response);
    // Gets details of a single AppConnection.
    virtual ::grpc::Status GetAppConnection(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response);
    // Creates a new AppConnection in a given project and location.
    virtual ::grpc::Status CreateAppConnection(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single AppConnection.
    virtual ::grpc::Status UpdateAppConnection(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single AppConnection.
    virtual ::grpc::Status DeleteAppConnection(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::google::longrunning::Operation* response);
    // Resolves AppConnections details for a given AppConnector.
    // An internal method called by a connector to find AppConnections to connect
    // to.
    virtual ::grpc::Status ResolveAppConnections(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAppConnections() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAppConnections(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAppConnection() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAppConnection(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAppConnection() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAppConnection(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAppConnection() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAppConnection(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAppConnection() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAppConnection(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResolveAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResolveAppConnections() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ResolveAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResolveAppConnections(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAppConnections<WithAsyncMethod_GetAppConnection<WithAsyncMethod_CreateAppConnection<WithAsyncMethod_UpdateAppConnection<WithAsyncMethod_DeleteAppConnection<WithAsyncMethod_ResolveAppConnections<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAppConnections() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* response) { return this->ListAppConnections(context, request, response); }));}
    void SetMessageAllocatorFor_ListAppConnections(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAppConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAppConnection() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest, ::google::cloud::beyondcorp::appconnections::v1::AppConnection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* request, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* response) { return this->GetAppConnection(context, request, response); }));}
    void SetMessageAllocatorFor_GetAppConnection(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest, ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest, ::google::cloud::beyondcorp::appconnections::v1::AppConnection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAppConnection() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* request, ::google::longrunning::Operation* response) { return this->CreateAppConnection(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAppConnection(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAppConnection() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAppConnection(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAppConnection(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAppConnection() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAppConnection(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAppConnection(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResolveAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResolveAppConnections() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* request, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* response) { return this->ResolveAppConnections(context, request, response); }));}
    void SetMessageAllocatorFor_ResolveAppConnections(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResolveAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResolveAppConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListAppConnections<WithCallbackMethod_GetAppConnection<WithCallbackMethod_CreateAppConnection<WithCallbackMethod_UpdateAppConnection<WithCallbackMethod_DeleteAppConnection<WithCallbackMethod_ResolveAppConnections<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAppConnections() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAppConnection() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAppConnection() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAppConnection() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAppConnection() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResolveAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResolveAppConnections() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ResolveAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAppConnections() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAppConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAppConnection() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAppConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAppConnection() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAppConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAppConnection() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAppConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAppConnection() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAppConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResolveAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResolveAppConnections() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ResolveAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResolveAppConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAppConnections() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAppConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAppConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAppConnection() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAppConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAppConnection() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAppConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAppConnection() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAppConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAppConnection() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAppConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAppConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResolveAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResolveAppConnections() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResolveAppConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResolveAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResolveAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResolveAppConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAppConnections() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* streamer) {
                       return this->StreamedListAppConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAppConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest,::google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAppConnection() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest, ::google::cloud::beyondcorp::appconnections::v1::AppConnection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest, ::google::cloud::beyondcorp::appconnections::v1::AppConnection>* streamer) {
                       return this->StreamedGetAppConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::AppConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAppConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnections::v1::GetAppConnectionRequest,::google::cloud::beyondcorp::appconnections::v1::AppConnection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAppConnection() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAppConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAppConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnections::v1::CreateAppConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAppConnection() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAppConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAppConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnections::v1::UpdateAppConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAppConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAppConnection() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAppConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAppConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAppConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAppConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnections::v1::DeleteAppConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResolveAppConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResolveAppConnections() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* streamer) {
                       return this->StreamedResolveAppConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResolveAppConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResolveAppConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest* /*request*/, ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResolveAppConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsRequest,::google::cloud::beyondcorp::appconnections::v1::ResolveAppConnectionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAppConnections<WithStreamedUnaryMethod_GetAppConnection<WithStreamedUnaryMethod_CreateAppConnection<WithStreamedUnaryMethod_UpdateAppConnection<WithStreamedUnaryMethod_DeleteAppConnection<WithStreamedUnaryMethod_ResolveAppConnections<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAppConnections<WithStreamedUnaryMethod_GetAppConnection<WithStreamedUnaryMethod_CreateAppConnection<WithStreamedUnaryMethod_UpdateAppConnection<WithStreamedUnaryMethod_DeleteAppConnection<WithStreamedUnaryMethod_ResolveAppConnections<Service > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace appconnections
}  // namespace beyondcorp
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fbeyondcorp_2fappconnections_2fv1_2fapp_5fconnections_5fservice_2eproto__INCLUDED
