// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/billing/budgets/v1/budget_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbilling_2fbudgets_2fv1_2fbudget_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbilling_2fbudgets_2fv1_2fbudget_5fservice_2eproto__INCLUDED

#include "google/cloud/billing/budgets/v1/budget_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace billing {
namespace budgets {
namespace v1 {

// BudgetService stores Cloud Billing budgets, which define a
// budget plan and rules to execute as we track spend against that plan.
class BudgetService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.billing.budgets.v1.BudgetService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new budget. See
    // [Quotas and limits](https://cloud.google.com/billing/quotas)
    // for more information on the limits of the number of budgets you can create.
    virtual ::grpc::Status CreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::google::cloud::billing::budgets::v1::Budget* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>> AsyncCreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>>(AsyncCreateBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>> PrepareAsyncCreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>>(PrepareAsyncCreateBudgetRaw(context, request, cq));
    }
    // Updates a budget and returns the updated budget.
    //
    // WARNING: There are some fields exposed on the Google Cloud Console that
    // aren't available on this API. Budget fields that are not exposed in
    // this API will not be changed by this method.
    virtual ::grpc::Status UpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::google::cloud::billing::budgets::v1::Budget* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>> AsyncUpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>>(AsyncUpdateBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>> PrepareAsyncUpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>>(PrepareAsyncUpdateBudgetRaw(context, request, cq));
    }
    // Returns a budget.
    //
    // WARNING: There are some fields exposed on the Google Cloud Console that
    // aren't available on this API. When reading from the API, you will not
    // see these fields in the return value, though they may have been set
    // in the Cloud Console.
    virtual ::grpc::Status GetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::google::cloud::billing::budgets::v1::Budget* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>> AsyncGetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>>(AsyncGetBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>> PrepareAsyncGetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>>(PrepareAsyncGetBudgetRaw(context, request, cq));
    }
    // Returns a list of budgets for a billing account.
    //
    // WARNING: There are some fields exposed on the Google Cloud Console that
    // aren't available on this API. When reading from the API, you will not
    // see these fields in the return value, though they may have been set
    // in the Cloud Console.
    virtual ::grpc::Status ListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>> AsyncListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>>(AsyncListBudgetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>> PrepareAsyncListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>>(PrepareAsyncListBudgetsRaw(context, request, cq));
    }
    // Deletes a budget. Returns successfully if already deleted.
    virtual ::grpc::Status DeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteBudgetRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new budget. See
      // [Quotas and limits](https://cloud.google.com/billing/quotas)
      // for more information on the limits of the number of budgets you can create.
      virtual void CreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a budget and returns the updated budget.
      //
      // WARNING: There are some fields exposed on the Google Cloud Console that
      // aren't available on this API. Budget fields that are not exposed in
      // this API will not be changed by this method.
      virtual void UpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a budget.
      //
      // WARNING: There are some fields exposed on the Google Cloud Console that
      // aren't available on this API. When reading from the API, you will not
      // see these fields in the return value, though they may have been set
      // in the Cloud Console.
      virtual void GetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of budgets for a billing account.
      //
      // WARNING: There are some fields exposed on the Google Cloud Console that
      // aren't available on this API. When reading from the API, you will not
      // see these fields in the return value, though they may have been set
      // in the Cloud Console.
      virtual void ListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a budget. Returns successfully if already deleted.
      virtual void DeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>* AsyncCreateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>* PrepareAsyncCreateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>* AsyncUpdateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>* PrepareAsyncUpdateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>* AsyncGetBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::Budget>* PrepareAsyncGetBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* AsyncListBudgetsRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* PrepareAsyncListBudgetsRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::google::cloud::billing::budgets::v1::Budget* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>> AsyncCreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>>(AsyncCreateBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>> PrepareAsyncCreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>>(PrepareAsyncCreateBudgetRaw(context, request, cq));
    }
    ::grpc::Status UpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::google::cloud::billing::budgets::v1::Budget* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>> AsyncUpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>>(AsyncUpdateBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>> PrepareAsyncUpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>>(PrepareAsyncUpdateBudgetRaw(context, request, cq));
    }
    ::grpc::Status GetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::google::cloud::billing::budgets::v1::Budget* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>> AsyncGetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>>(AsyncGetBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>> PrepareAsyncGetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>>(PrepareAsyncGetBudgetRaw(context, request, cq));
    }
    ::grpc::Status ListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>> AsyncListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>>(AsyncListBudgetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>> PrepareAsyncListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>>(PrepareAsyncListBudgetsRaw(context, request, cq));
    }
    ::grpc::Status DeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteBudgetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteBudgetRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, std::function<void(::grpc::Status)>) override;
      void CreateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, std::function<void(::grpc::Status)>) override;
      void UpdateBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, std::function<void(::grpc::Status)>) override;
      void GetBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBudgets(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteBudget(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>* AsyncCreateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>* PrepareAsyncCreateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>* AsyncUpdateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>* PrepareAsyncUpdateBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>* AsyncGetBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::Budget>* PrepareAsyncGetBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* AsyncListBudgetsRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* PrepareAsyncListBudgetsRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteBudgetRaw(::grpc::ClientContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBudget_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateBudget_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBudget_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBudgets_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBudget_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new budget. See
    // [Quotas and limits](https://cloud.google.com/billing/quotas)
    // for more information on the limits of the number of budgets you can create.
    virtual ::grpc::Status CreateBudget(::grpc::ServerContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response);
    // Updates a budget and returns the updated budget.
    //
    // WARNING: There are some fields exposed on the Google Cloud Console that
    // aren't available on this API. Budget fields that are not exposed in
    // this API will not be changed by this method.
    virtual ::grpc::Status UpdateBudget(::grpc::ServerContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response);
    // Returns a budget.
    //
    // WARNING: There are some fields exposed on the Google Cloud Console that
    // aren't available on this API. When reading from the API, you will not
    // see these fields in the return value, though they may have been set
    // in the Cloud Console.
    virtual ::grpc::Status GetBudget(::grpc::ServerContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response);
    // Returns a list of budgets for a billing account.
    //
    // WARNING: There are some fields exposed on the Google Cloud Console that
    // aren't available on this API. When reading from the API, you will not
    // see these fields in the return value, though they may have been set
    // in the Cloud Console.
    virtual ::grpc::Status ListBudgets(::grpc::ServerContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response);
    // Deletes a budget. Returns successfully if already deleted.
    virtual ::grpc::Status DeleteBudget(::grpc::ServerContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBudget() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBudget(::grpc::ServerContext* context, ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::billing::budgets::v1::Budget>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateBudget() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBudget(::grpc::ServerContext* context, ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::billing::budgets::v1::Budget>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBudget() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBudget(::grpc::ServerContext* context, ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::billing::budgets::v1::Budget>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBudgets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBudgets() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListBudgets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBudgets(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBudgets(::grpc::ServerContext* context, ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBudget() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBudget(::grpc::ServerContext* context, ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateBudget<WithAsyncMethod_UpdateBudget<WithAsyncMethod_GetBudget<WithAsyncMethod_ListBudgets<WithAsyncMethod_DeleteBudget<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBudget() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::CreateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response) { return this->CreateBudget(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBudget(
        ::grpc::MessageAllocator< ::google::cloud::billing::budgets::v1::CreateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::CreateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateBudget() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::UpdateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response) { return this->UpdateBudget(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateBudget(
        ::grpc::MessageAllocator< ::google::cloud::billing::budgets::v1::UpdateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::UpdateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBudget() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::GetBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* request, ::google::cloud::billing::budgets::v1::Budget* response) { return this->GetBudget(context, request, response); }));}
    void SetMessageAllocatorFor_GetBudget(
        ::grpc::MessageAllocator< ::google::cloud::billing::budgets::v1::GetBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::GetBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBudgets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBudgets() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::ListBudgetsRequest, ::google::cloud::billing::budgets::v1::ListBudgetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* request, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* response) { return this->ListBudgets(context, request, response); }));}
    void SetMessageAllocatorFor_ListBudgets(
        ::grpc::MessageAllocator< ::google::cloud::billing::budgets::v1::ListBudgetsRequest, ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::ListBudgetsRequest, ::google::cloud::billing::budgets::v1::ListBudgetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBudgets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBudgets(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBudgets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBudget() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::DeleteBudgetRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* request, ::google::protobuf::Empty* response) { return this->DeleteBudget(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBudget(
        ::grpc::MessageAllocator< ::google::cloud::billing::budgets::v1::DeleteBudgetRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::billing::budgets::v1::DeleteBudgetRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateBudget<WithCallbackMethod_UpdateBudget<WithCallbackMethod_GetBudget<WithCallbackMethod_ListBudgets<WithCallbackMethod_DeleteBudget<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBudget() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateBudget() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBudget() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBudgets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBudgets() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListBudgets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBudgets(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBudget() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBudget() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBudget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateBudget() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBudget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBudget() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBudget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBudgets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBudgets() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListBudgets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBudgets(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBudgets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBudget() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBudget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBudget() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBudget(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateBudget() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateBudget(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBudget() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBudget(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBudgets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBudgets() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBudgets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBudgets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBudgets(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBudgets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBudget() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBudget(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBudget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBudget() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::budgets::v1::CreateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::budgets::v1::CreateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>* streamer) {
                       return this->StreamedCreateBudget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::CreateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBudget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::budgets::v1::CreateBudgetRequest,::google::cloud::billing::budgets::v1::Budget>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateBudget() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::budgets::v1::UpdateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::budgets::v1::UpdateBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>* streamer) {
                       return this->StreamedUpdateBudget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::UpdateBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateBudget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::budgets::v1::UpdateBudgetRequest,::google::cloud::billing::budgets::v1::Budget>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBudget() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::budgets::v1::GetBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::budgets::v1::GetBudgetRequest, ::google::cloud::billing::budgets::v1::Budget>* streamer) {
                       return this->StreamedGetBudget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::GetBudgetRequest* /*request*/, ::google::cloud::billing::budgets::v1::Budget* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBudget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::budgets::v1::GetBudgetRequest,::google::cloud::billing::budgets::v1::Budget>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBudgets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBudgets() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::budgets::v1::ListBudgetsRequest, ::google::cloud::billing::budgets::v1::ListBudgetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::budgets::v1::ListBudgetsRequest, ::google::cloud::billing::budgets::v1::ListBudgetsResponse>* streamer) {
                       return this->StreamedListBudgets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBudgets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBudgets(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::ListBudgetsRequest* /*request*/, ::google::cloud::billing::budgets::v1::ListBudgetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBudgets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::budgets::v1::ListBudgetsRequest,::google::cloud::billing::budgets::v1::ListBudgetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBudget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBudget() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::billing::budgets::v1::DeleteBudgetRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::billing::budgets::v1::DeleteBudgetRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteBudget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBudget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBudget(::grpc::ServerContext* /*context*/, const ::google::cloud::billing::budgets::v1::DeleteBudgetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBudget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::billing::budgets::v1::DeleteBudgetRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateBudget<WithStreamedUnaryMethod_UpdateBudget<WithStreamedUnaryMethod_GetBudget<WithStreamedUnaryMethod_ListBudgets<WithStreamedUnaryMethod_DeleteBudget<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateBudget<WithStreamedUnaryMethod_UpdateBudget<WithStreamedUnaryMethod_GetBudget<WithStreamedUnaryMethod_ListBudgets<WithStreamedUnaryMethod_DeleteBudget<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace budgets
}  // namespace billing
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fbilling_2fbudgets_2fv1_2fbudget_5fservice_2eproto__INCLUDED
