// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/binaryauthorization/v1/service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BINARYAUTHORIZATION_V1_INTERNAL_VALIDATION_HELPER_V1_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BINARYAUTHORIZATION_V1_INTERNAL_VALIDATION_HELPER_V1_CONNECTION_IMPL_H

#include "google/cloud/binaryauthorization/v1/internal/validation_helper_v1_retry_traits.h"
#include "google/cloud/binaryauthorization/v1/internal/validation_helper_v1_stub.h"
#include "google/cloud/binaryauthorization/v1/validation_helper_v1_connection.h"
#include "google/cloud/binaryauthorization/v1/validation_helper_v1_connection_idempotency_policy.h"
#include "google/cloud/binaryauthorization/v1/validation_helper_v1_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace binaryauthorization_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class ValidationHelperV1ConnectionImpl
    : public binaryauthorization_v1::ValidationHelperV1Connection {
 public:
  ~ValidationHelperV1ConnectionImpl() override = default;

  ValidationHelperV1ConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<binaryauthorization_v1_internal::ValidationHelperV1Stub>
          stub,
      Options options);

  Options options() override { return options_; }

  StatusOr<google::cloud::binaryauthorization::v1::
               ValidateAttestationOccurrenceResponse>
  ValidateAttestationOccurrence(
      google::cloud::binaryauthorization::v1::
          ValidateAttestationOccurrenceRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<binaryauthorization_v1_internal::ValidationHelperV1Stub>
      stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace binaryauthorization_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BINARYAUTHORIZATION_V1_INTERNAL_VALIDATION_HELPER_V1_CONNECTION_IMPL_H
