// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/ssl_certificates/v1/ssl_certificates.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_CERTIFICATES_V1_INTERNAL_SSL_CERTIFICATES_REST_METADATA_DECORATOR_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_CERTIFICATES_V1_INTERNAL_SSL_CERTIFICATES_REST_METADATA_DECORATOR_H

#include "google/cloud/compute/ssl_certificates/v1/internal/ssl_certificates_rest_stub.h"
#include "google/cloud/future.h"
#include "google/cloud/rest_options.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/global_operations/v1/global_operations.pb.h>
#include <google/cloud/compute/ssl_certificates/v1/ssl_certificates.pb.h>
#include <memory>
#include <string>

namespace google {
namespace cloud {
namespace compute_ssl_certificates_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class SslCertificatesRestMetadata : public SslCertificatesRestStub {
 public:
  ~SslCertificatesRestMetadata() override = default;
  explicit SslCertificatesRestMetadata(
      std::shared_ptr<SslCertificatesRestStub> child,
      std::string api_client_header = "");

  StatusOr<google::cloud::cpp::compute::v1::SslCertificateAggregatedList>
  AggregatedListSslCertificates(
      google::cloud::rest_internal::RestContext& rest_context,
      google::cloud::cpp::compute::ssl_certificates::v1::
          AggregatedListSslCertificatesRequest const& request) override;

  google::cloud::future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  AsyncDeleteSslCertificate(
      google::cloud::CompletionQueue& cq,
      std::unique_ptr<google::cloud::rest_internal::RestContext> rest_context,
      google::cloud::cpp::compute::ssl_certificates::v1::
          DeleteSslCertificateRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::SslCertificate> GetSslCertificate(
      google::cloud::rest_internal::RestContext& rest_context,
      google::cloud::cpp::compute::ssl_certificates::v1::
          GetSslCertificateRequest const& request) override;

  google::cloud::future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  AsyncInsertSslCertificate(
      google::cloud::CompletionQueue& cq,
      std::unique_ptr<google::cloud::rest_internal::RestContext> rest_context,
      google::cloud::cpp::compute::ssl_certificates::v1::
          InsertSslCertificateRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::SslCertificateList>
  ListSslCertificates(google::cloud::rest_internal::RestContext& rest_context,
                      google::cloud::cpp::compute::ssl_certificates::v1::
                          ListSslCertificatesRequest const& request) override;

  google::cloud::future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::unique_ptr<google::cloud::rest_internal::RestContext> rest_context,
      google::cloud::cpp::compute::global_operations::v1::
          GetOperationRequest const& request) override;

  google::cloud::future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::unique_ptr<google::cloud::rest_internal::RestContext> rest_context,
      google::cloud::cpp::compute::global_operations::v1::
          DeleteOperationRequest const& request) override;

 private:
  void SetMetadata(rest_internal::RestContext& rest_context,
                   std::vector<std::string> const& params = {});

  std::shared_ptr<SslCertificatesRestStub> child_;
  std::string api_client_header_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_ssl_certificates_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_CERTIFICATES_V1_INTERNAL_SSL_CERTIFICATES_REST_METADATA_DECORATOR_H
