// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dataplex/v1/metadata.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATAPLEX_V1_INTERNAL_METADATA_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATAPLEX_V1_INTERNAL_METADATA_STUB_H

#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/dataplex/v1/metadata.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace dataplex_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class MetadataServiceStub {
 public:
  virtual ~MetadataServiceStub() = 0;

  virtual StatusOr<google::cloud::dataplex::v1::Entity> CreateEntity(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::CreateEntityRequest const& request) = 0;

  virtual StatusOr<google::cloud::dataplex::v1::Entity> UpdateEntity(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::UpdateEntityRequest const& request) = 0;

  virtual Status DeleteEntity(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::DeleteEntityRequest const& request) = 0;

  virtual StatusOr<google::cloud::dataplex::v1::Entity> GetEntity(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::GetEntityRequest const& request) = 0;

  virtual StatusOr<google::cloud::dataplex::v1::ListEntitiesResponse>
  ListEntities(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::ListEntitiesRequest const& request) = 0;

  virtual StatusOr<google::cloud::dataplex::v1::Partition> CreatePartition(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::CreatePartitionRequest const& request) = 0;

  virtual Status DeletePartition(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::DeletePartitionRequest const& request) = 0;

  virtual StatusOr<google::cloud::dataplex::v1::Partition> GetPartition(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::GetPartitionRequest const& request) = 0;

  virtual StatusOr<google::cloud::dataplex::v1::ListPartitionsResponse>
  ListPartitions(
      grpc::ClientContext& context,
      google::cloud::dataplex::v1::ListPartitionsRequest const& request) = 0;
};

class DefaultMetadataServiceStub : public MetadataServiceStub {
 public:
  explicit DefaultMetadataServiceStub(
      std::unique_ptr<
          google::cloud::dataplex::v1::MetadataService::StubInterface>
          grpc_stub)
      : grpc_stub_(std::move(grpc_stub)) {}

  StatusOr<google::cloud::dataplex::v1::Entity> CreateEntity(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::CreateEntityRequest const& request) override;

  StatusOr<google::cloud::dataplex::v1::Entity> UpdateEntity(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::UpdateEntityRequest const& request) override;

  Status DeleteEntity(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::DeleteEntityRequest const& request) override;

  StatusOr<google::cloud::dataplex::v1::Entity> GetEntity(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::GetEntityRequest const& request) override;

  StatusOr<google::cloud::dataplex::v1::ListEntitiesResponse> ListEntities(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::ListEntitiesRequest const& request) override;

  StatusOr<google::cloud::dataplex::v1::Partition> CreatePartition(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::CreatePartitionRequest const& request)
      override;

  Status DeletePartition(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::DeletePartitionRequest const& request)
      override;

  StatusOr<google::cloud::dataplex::v1::Partition> GetPartition(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::GetPartitionRequest const& request) override;

  StatusOr<google::cloud::dataplex::v1::ListPartitionsResponse> ListPartitions(
      grpc::ClientContext& client_context,
      google::cloud::dataplex::v1::ListPartitionsRequest const& request)
      override;

 private:
  std::unique_ptr<google::cloud::dataplex::v1::MetadataService::StubInterface>
      grpc_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dataplex_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATAPLEX_V1_INTERNAL_METADATA_STUB_H
