// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dataproc/v1/workflow_templates.proto
// Original file comments:
// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdataproc_2fv1_2fworkflow_5ftemplates_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdataproc_2fv1_2fworkflow_5ftemplates_2eproto__INCLUDED

#include "google/cloud/dataproc/v1/workflow_templates.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dataproc {
namespace v1 {

// The API interface for managing Workflow Templates in the
// Dataproc API.
class WorkflowTemplateService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dataproc.v1.WorkflowTemplateService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates new workflow template.
    virtual ::grpc::Status CreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>> AsyncCreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>>(AsyncCreateWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>> PrepareAsyncCreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>>(PrepareAsyncCreateWorkflowTemplateRaw(context, request, cq));
    }
    // Retrieves the latest workflow template.
    //
    // Can retrieve previously instantiated template by specifying optional
    // version parameter.
    virtual ::grpc::Status GetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>> AsyncGetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>>(AsyncGetWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>> PrepareAsyncGetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>>(PrepareAsyncGetWorkflowTemplateRaw(context, request, cq));
    }
    // Instantiates a template and begins execution.
    //
    // The returned Operation can be used to track execution of
    // workflow by polling
    // [operations.get][google.longrunning.Operations.GetOperation].
    // The Operation will complete when entire workflow is finished.
    //
    // The running workflow can be aborted via
    // [operations.cancel][google.longrunning.Operations.CancelOperation].
    // This will cause any inflight jobs to be cancelled and workflow-owned
    // clusters to be deleted.
    //
    // The [Operation.metadata][google.longrunning.Operation.metadata] will be
    // [WorkflowMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#workflowmetadata).
    // Also see [Using
    // WorkflowMetadata](https://cloud.google.com/dataproc/docs/concepts/workflows/debugging#using_workflowmetadata).
    //
    // On successful completion,
    // [Operation.response][google.longrunning.Operation.response] will be
    // [Empty][google.protobuf.Empty].
    virtual ::grpc::Status InstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncInstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncInstantiateWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncInstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncInstantiateWorkflowTemplateRaw(context, request, cq));
    }
    // Instantiates a template and begins execution.
    //
    // This method is equivalent to executing the sequence
    // [CreateWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.CreateWorkflowTemplate],
    // [InstantiateWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.InstantiateWorkflowTemplate],
    // [DeleteWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.DeleteWorkflowTemplate].
    //
    // The returned Operation can be used to track execution of
    // workflow by polling
    // [operations.get][google.longrunning.Operations.GetOperation].
    // The Operation will complete when entire workflow is finished.
    //
    // The running workflow can be aborted via
    // [operations.cancel][google.longrunning.Operations.CancelOperation].
    // This will cause any inflight jobs to be cancelled and workflow-owned
    // clusters to be deleted.
    //
    // The [Operation.metadata][google.longrunning.Operation.metadata] will be
    // [WorkflowMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#workflowmetadata).
    // Also see [Using
    // WorkflowMetadata](https://cloud.google.com/dataproc/docs/concepts/workflows/debugging#using_workflowmetadata).
    //
    // On successful completion,
    // [Operation.response][google.longrunning.Operation.response] will be
    // [Empty][google.protobuf.Empty].
    virtual ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncInstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncInstantiateInlineWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncInstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncInstantiateInlineWorkflowTemplateRaw(context, request, cq));
    }
    // Updates (replaces) workflow template. The updated template
    // must contain version that matches the current server version.
    virtual ::grpc::Status UpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>> AsyncUpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>>(AsyncUpdateWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>> PrepareAsyncUpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>>(PrepareAsyncUpdateWorkflowTemplateRaw(context, request, cq));
    }
    // Lists workflows that match the specified filter in the request.
    virtual ::grpc::Status ListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>> AsyncListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>>(AsyncListWorkflowTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>> PrepareAsyncListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>>(PrepareAsyncListWorkflowTemplatesRaw(context, request, cq));
    }
    // Deletes a workflow template. It does not cancel in-progress workflows.
    virtual ::grpc::Status DeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteWorkflowTemplateRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates new workflow template.
      virtual void CreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the latest workflow template.
      //
      // Can retrieve previously instantiated template by specifying optional
      // version parameter.
      virtual void GetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Instantiates a template and begins execution.
      //
      // The returned Operation can be used to track execution of
      // workflow by polling
      // [operations.get][google.longrunning.Operations.GetOperation].
      // The Operation will complete when entire workflow is finished.
      //
      // The running workflow can be aborted via
      // [operations.cancel][google.longrunning.Operations.CancelOperation].
      // This will cause any inflight jobs to be cancelled and workflow-owned
      // clusters to be deleted.
      //
      // The [Operation.metadata][google.longrunning.Operation.metadata] will be
      // [WorkflowMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#workflowmetadata).
      // Also see [Using
      // WorkflowMetadata](https://cloud.google.com/dataproc/docs/concepts/workflows/debugging#using_workflowmetadata).
      //
      // On successful completion,
      // [Operation.response][google.longrunning.Operation.response] will be
      // [Empty][google.protobuf.Empty].
      virtual void InstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Instantiates a template and begins execution.
      //
      // This method is equivalent to executing the sequence
      // [CreateWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.CreateWorkflowTemplate],
      // [InstantiateWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.InstantiateWorkflowTemplate],
      // [DeleteWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.DeleteWorkflowTemplate].
      //
      // The returned Operation can be used to track execution of
      // workflow by polling
      // [operations.get][google.longrunning.Operations.GetOperation].
      // The Operation will complete when entire workflow is finished.
      //
      // The running workflow can be aborted via
      // [operations.cancel][google.longrunning.Operations.CancelOperation].
      // This will cause any inflight jobs to be cancelled and workflow-owned
      // clusters to be deleted.
      //
      // The [Operation.metadata][google.longrunning.Operation.metadata] will be
      // [WorkflowMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#workflowmetadata).
      // Also see [Using
      // WorkflowMetadata](https://cloud.google.com/dataproc/docs/concepts/workflows/debugging#using_workflowmetadata).
      //
      // On successful completion,
      // [Operation.response][google.longrunning.Operation.response] will be
      // [Empty][google.protobuf.Empty].
      virtual void InstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates (replaces) workflow template. The updated template
      // must contain version that matches the current server version.
      virtual void UpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists workflows that match the specified filter in the request.
      virtual void ListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a workflow template. It does not cancel in-progress workflows.
      virtual void DeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>* AsyncCreateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>* PrepareAsyncCreateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>* AsyncGetWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>* PrepareAsyncGetWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncInstantiateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncInstantiateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncInstantiateInlineWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncInstantiateInlineWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>* AsyncUpdateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::WorkflowTemplate>* PrepareAsyncUpdateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* AsyncListWorkflowTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* PrepareAsyncListWorkflowTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>> AsyncCreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>>(AsyncCreateWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>> PrepareAsyncCreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>>(PrepareAsyncCreateWorkflowTemplateRaw(context, request, cq));
    }
    ::grpc::Status GetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>> AsyncGetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>>(AsyncGetWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>> PrepareAsyncGetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>>(PrepareAsyncGetWorkflowTemplateRaw(context, request, cq));
    }
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncInstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncInstantiateWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncInstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncInstantiateWorkflowTemplateRaw(context, request, cq));
    }
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncInstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncInstantiateInlineWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncInstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncInstantiateInlineWorkflowTemplateRaw(context, request, cq));
    }
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>> AsyncUpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>>(AsyncUpdateWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>> PrepareAsyncUpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>>(PrepareAsyncUpdateWorkflowTemplateRaw(context, request, cq));
    }
    ::grpc::Status ListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>> AsyncListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>>(AsyncListWorkflowTemplatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>> PrepareAsyncListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>>(PrepareAsyncListWorkflowTemplatesRaw(context, request, cq));
    }
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteWorkflowTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteWorkflowTemplateRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, std::function<void(::grpc::Status)>) override;
      void CreateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, std::function<void(::grpc::Status)>) override;
      void GetWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void InstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void InstantiateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void InstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void InstantiateInlineWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, std::function<void(::grpc::Status)>) override;
      void UpdateWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListWorkflowTemplates(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteWorkflowTemplate(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>* AsyncCreateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>* PrepareAsyncCreateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>* AsyncGetWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>* PrepareAsyncGetWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncInstantiateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncInstantiateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncInstantiateInlineWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncInstantiateInlineWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>* AsyncUpdateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::WorkflowTemplate>* PrepareAsyncUpdateWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* AsyncListWorkflowTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* PrepareAsyncListWorkflowTemplatesRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteWorkflowTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateWorkflowTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_GetWorkflowTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_InstantiateWorkflowTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_InstantiateInlineWorkflowTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateWorkflowTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_ListWorkflowTemplates_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteWorkflowTemplate_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates new workflow template.
    virtual ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response);
    // Retrieves the latest workflow template.
    //
    // Can retrieve previously instantiated template by specifying optional
    // version parameter.
    virtual ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response);
    // Instantiates a template and begins execution.
    //
    // The returned Operation can be used to track execution of
    // workflow by polling
    // [operations.get][google.longrunning.Operations.GetOperation].
    // The Operation will complete when entire workflow is finished.
    //
    // The running workflow can be aborted via
    // [operations.cancel][google.longrunning.Operations.CancelOperation].
    // This will cause any inflight jobs to be cancelled and workflow-owned
    // clusters to be deleted.
    //
    // The [Operation.metadata][google.longrunning.Operation.metadata] will be
    // [WorkflowMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#workflowmetadata).
    // Also see [Using
    // WorkflowMetadata](https://cloud.google.com/dataproc/docs/concepts/workflows/debugging#using_workflowmetadata).
    //
    // On successful completion,
    // [Operation.response][google.longrunning.Operation.response] will be
    // [Empty][google.protobuf.Empty].
    virtual ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::google::longrunning::Operation* response);
    // Instantiates a template and begins execution.
    //
    // This method is equivalent to executing the sequence
    // [CreateWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.CreateWorkflowTemplate],
    // [InstantiateWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.InstantiateWorkflowTemplate],
    // [DeleteWorkflowTemplate][google.cloud.dataproc.v1.WorkflowTemplateService.DeleteWorkflowTemplate].
    //
    // The returned Operation can be used to track execution of
    // workflow by polling
    // [operations.get][google.longrunning.Operations.GetOperation].
    // The Operation will complete when entire workflow is finished.
    //
    // The running workflow can be aborted via
    // [operations.cancel][google.longrunning.Operations.CancelOperation].
    // This will cause any inflight jobs to be cancelled and workflow-owned
    // clusters to be deleted.
    //
    // The [Operation.metadata][google.longrunning.Operation.metadata] will be
    // [WorkflowMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#workflowmetadata).
    // Also see [Using
    // WorkflowMetadata](https://cloud.google.com/dataproc/docs/concepts/workflows/debugging#using_workflowmetadata).
    //
    // On successful completion,
    // [Operation.response][google.longrunning.Operation.response] will be
    // [Empty][google.protobuf.Empty].
    virtual ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::google::longrunning::Operation* response);
    // Updates (replaces) workflow template. The updated template
    // must contain version that matches the current server version.
    virtual ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response);
    // Lists workflows that match the specified filter in the request.
    virtual ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response);
    // Deletes a workflow template. It does not cancel in-progress workflows.
    virtual ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateWorkflowTemplate() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkflowTemplate(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::WorkflowTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetWorkflowTemplate() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkflowTemplate(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::WorkflowTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_InstantiateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InstantiateWorkflowTemplate() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_InstantiateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInstantiateWorkflowTemplate(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_InstantiateInlineWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InstantiateInlineWorkflowTemplate() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_InstantiateInlineWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInstantiateInlineWorkflowTemplate(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateWorkflowTemplate() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkflowTemplate(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::WorkflowTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListWorkflowTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListWorkflowTemplates() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListWorkflowTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkflowTemplates(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteWorkflowTemplate() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeleteWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkflowTemplate(::grpc::ServerContext* context, ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateWorkflowTemplate<WithAsyncMethod_GetWorkflowTemplate<WithAsyncMethod_InstantiateWorkflowTemplate<WithAsyncMethod_InstantiateInlineWorkflowTemplate<WithAsyncMethod_UpdateWorkflowTemplate<WithAsyncMethod_ListWorkflowTemplates<WithAsyncMethod_DeleteWorkflowTemplate<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateWorkflowTemplate() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) { return this->CreateWorkflowTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateWorkflowTemplate(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetWorkflowTemplate() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) { return this->GetWorkflowTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_GetWorkflowTemplate(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_InstantiateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InstantiateWorkflowTemplate() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* request, ::google::longrunning::Operation* response) { return this->InstantiateWorkflowTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_InstantiateWorkflowTemplate(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InstantiateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InstantiateWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_InstantiateInlineWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InstantiateInlineWorkflowTemplate() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* request, ::google::longrunning::Operation* response) { return this->InstantiateInlineWorkflowTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_InstantiateInlineWorkflowTemplate(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InstantiateInlineWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InstantiateInlineWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateWorkflowTemplate() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* request, ::google::cloud::dataproc::v1::WorkflowTemplate* response) { return this->UpdateWorkflowTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateWorkflowTemplate(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListWorkflowTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListWorkflowTemplates() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* request, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* response) { return this->ListWorkflowTemplates(context, request, response); }));}
    void SetMessageAllocatorFor_ListWorkflowTemplates(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListWorkflowTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkflowTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteWorkflowTemplate() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* request, ::google::protobuf::Empty* response) { return this->DeleteWorkflowTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteWorkflowTemplate(
        ::grpc::MessageAllocator< ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateWorkflowTemplate<WithCallbackMethod_GetWorkflowTemplate<WithCallbackMethod_InstantiateWorkflowTemplate<WithCallbackMethod_InstantiateInlineWorkflowTemplate<WithCallbackMethod_UpdateWorkflowTemplate<WithCallbackMethod_ListWorkflowTemplates<WithCallbackMethod_DeleteWorkflowTemplate<Service > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateWorkflowTemplate() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetWorkflowTemplate() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_InstantiateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InstantiateWorkflowTemplate() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_InstantiateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_InstantiateInlineWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InstantiateInlineWorkflowTemplate() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_InstantiateInlineWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateWorkflowTemplate() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListWorkflowTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListWorkflowTemplates() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListWorkflowTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteWorkflowTemplate() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeleteWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateWorkflowTemplate() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetWorkflowTemplate() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_InstantiateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InstantiateWorkflowTemplate() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_InstantiateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInstantiateWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_InstantiateInlineWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InstantiateInlineWorkflowTemplate() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_InstantiateInlineWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInstantiateInlineWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateWorkflowTemplate() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListWorkflowTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListWorkflowTemplates() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListWorkflowTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkflowTemplates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteWorkflowTemplate() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeleteWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateWorkflowTemplate() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateWorkflowTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetWorkflowTemplate() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetWorkflowTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InstantiateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InstantiateWorkflowTemplate() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InstantiateWorkflowTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_InstantiateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InstantiateWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InstantiateInlineWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InstantiateInlineWorkflowTemplate() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InstantiateInlineWorkflowTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_InstantiateInlineWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InstantiateInlineWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateWorkflowTemplate() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateWorkflowTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListWorkflowTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListWorkflowTemplates() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListWorkflowTemplates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListWorkflowTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkflowTemplates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteWorkflowTemplate() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteWorkflowTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkflowTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateWorkflowTemplate() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>* streamer) {
                       return this->StreamedCreateWorkflowTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::CreateWorkflowTemplateRequest,::google::cloud::dataproc::v1::WorkflowTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetWorkflowTemplate() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>* streamer) {
                       return this->StreamedGetWorkflowTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::GetWorkflowTemplateRequest,::google::cloud::dataproc::v1::WorkflowTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InstantiateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InstantiateWorkflowTemplate() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedInstantiateWorkflowTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InstantiateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InstantiateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInstantiateWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::InstantiateWorkflowTemplateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InstantiateInlineWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InstantiateInlineWorkflowTemplate() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedInstantiateInlineWorkflowTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InstantiateInlineWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InstantiateInlineWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInstantiateInlineWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::InstantiateInlineWorkflowTemplateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateWorkflowTemplate() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest, ::google::cloud::dataproc::v1::WorkflowTemplate>* streamer) {
                       return this->StreamedUpdateWorkflowTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest* /*request*/, ::google::cloud::dataproc::v1::WorkflowTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::UpdateWorkflowTemplateRequest,::google::cloud::dataproc::v1::WorkflowTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListWorkflowTemplates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListWorkflowTemplates() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* streamer) {
                       return this->StreamedListWorkflowTemplates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListWorkflowTemplates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListWorkflowTemplates(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest* /*request*/, ::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListWorkflowTemplates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::ListWorkflowTemplatesRequest,::google::cloud::dataproc::v1::ListWorkflowTemplatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteWorkflowTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteWorkflowTemplate() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteWorkflowTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteWorkflowTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteWorkflowTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteWorkflowTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataproc::v1::DeleteWorkflowTemplateRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateWorkflowTemplate<WithStreamedUnaryMethod_GetWorkflowTemplate<WithStreamedUnaryMethod_InstantiateWorkflowTemplate<WithStreamedUnaryMethod_InstantiateInlineWorkflowTemplate<WithStreamedUnaryMethod_UpdateWorkflowTemplate<WithStreamedUnaryMethod_ListWorkflowTemplates<WithStreamedUnaryMethod_DeleteWorkflowTemplate<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateWorkflowTemplate<WithStreamedUnaryMethod_GetWorkflowTemplate<WithStreamedUnaryMethod_InstantiateWorkflowTemplate<WithStreamedUnaryMethod_InstantiateInlineWorkflowTemplate<WithStreamedUnaryMethod_UpdateWorkflowTemplate<WithStreamedUnaryMethod_ListWorkflowTemplates<WithStreamedUnaryMethod_DeleteWorkflowTemplate<Service > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace dataproc
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdataproc_2fv1_2fworkflow_5ftemplates_2eproto__INCLUDED
