// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/cx/v3/session.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fcx_2fv3_2fsession_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fcx_2fv3_2fsession_2eproto__INCLUDED

#include "google/cloud/dialogflow/cx/v3/session.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dialogflow {
namespace cx {
namespace v3 {

// A session represents an interaction with a user. You retrieve user input
// and pass it to the
// [DetectIntent][google.cloud.dialogflow.cx.v3.Sessions.DetectIntent] method to
// determine user intent and respond.
class Sessions final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.cx.v3.Sessions";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Processes a natural language query and returns structured, actionable data
    // as a result. This method is not idempotent, because it may cause session
    // entity types to be updated, which in turn might affect results of future
    // queries.
    //
    // Note: Always use agent versions for production traffic.
    // See [Versions and
    // environments](https://cloud.google.com/dialogflow/cx/docs/concept/version).
    virtual ::grpc::Status DetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>> AsyncDetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>>(AsyncDetectIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>> PrepareAsyncDetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>>(PrepareAsyncDetectIntentRaw(context, request, cq));
    }
    // Processes a natural language query in audio format in a streaming fashion
    // and returns structured, actionable data as a result. This method is only
    // available via the gRPC API (not REST).
    //
    // Note: Always use agent versions for production traffic.
    // See [Versions and
    // environments](https://cloud.google.com/dialogflow/cx/docs/concept/version).
    std::unique_ptr< ::grpc::ClientReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>> StreamingDetectIntent(::grpc::ClientContext* context) {
      return std::unique_ptr< ::grpc::ClientReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>>(StreamingDetectIntentRaw(context));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>> AsyncStreamingDetectIntent(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>>(AsyncStreamingDetectIntentRaw(context, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>> PrepareAsyncStreamingDetectIntent(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>>(PrepareAsyncStreamingDetectIntentRaw(context, cq));
    }
    // Returns preliminary intent match results, doesn't change the session
    // status.
    virtual ::grpc::Status MatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>> AsyncMatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>>(AsyncMatchIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>> PrepareAsyncMatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>>(PrepareAsyncMatchIntentRaw(context, request, cq));
    }
    // Fulfills a matched intent returned by
    // [MatchIntent][google.cloud.dialogflow.cx.v3.Sessions.MatchIntent]. Must be
    // called after
    // [MatchIntent][google.cloud.dialogflow.cx.v3.Sessions.MatchIntent], with
    // input from
    // [MatchIntentResponse][google.cloud.dialogflow.cx.v3.MatchIntentResponse].
    // Otherwise, the behavior is undefined.
    virtual ::grpc::Status FulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>> AsyncFulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>>(AsyncFulfillIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>> PrepareAsyncFulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>>(PrepareAsyncFulfillIntentRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Processes a natural language query and returns structured, actionable data
      // as a result. This method is not idempotent, because it may cause session
      // entity types to be updated, which in turn might affect results of future
      // queries.
      //
      // Note: Always use agent versions for production traffic.
      // See [Versions and
      // environments](https://cloud.google.com/dialogflow/cx/docs/concept/version).
      virtual void DetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Processes a natural language query in audio format in a streaming fashion
      // and returns structured, actionable data as a result. This method is only
      // available via the gRPC API (not REST).
      //
      // Note: Always use agent versions for production traffic.
      // See [Versions and
      // environments](https://cloud.google.com/dialogflow/cx/docs/concept/version).
      virtual void StreamingDetectIntent(::grpc::ClientContext* context, ::grpc::ClientBidiReactor< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest,::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* reactor) = 0;
      // Returns preliminary intent match results, doesn't change the session
      // status.
      virtual void MatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Fulfills a matched intent returned by
      // [MatchIntent][google.cloud.dialogflow.cx.v3.Sessions.MatchIntent]. Must be
      // called after
      // [MatchIntent][google.cloud.dialogflow.cx.v3.Sessions.MatchIntent], with
      // input from
      // [MatchIntentResponse][google.cloud.dialogflow.cx.v3.MatchIntentResponse].
      // Otherwise, the behavior is undefined.
      virtual void FulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* AsyncDetectIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* PrepareAsyncDetectIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* StreamingDetectIntentRaw(::grpc::ClientContext* context) = 0;
    virtual ::grpc::ClientAsyncReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* AsyncStreamingDetectIntentRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) = 0;
    virtual ::grpc::ClientAsyncReaderWriterInterface< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* PrepareAsyncStreamingDetectIntentRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* AsyncMatchIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* PrepareAsyncMatchIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* AsyncFulfillIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* PrepareAsyncFulfillIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status DetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>> AsyncDetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>>(AsyncDetectIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>> PrepareAsyncDetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>>(PrepareAsyncDetectIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>> StreamingDetectIntent(::grpc::ClientContext* context) {
      return std::unique_ptr< ::grpc::ClientReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>>(StreamingDetectIntentRaw(context));
    }
    std::unique_ptr<  ::grpc::ClientAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>> AsyncStreamingDetectIntent(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>>(AsyncStreamingDetectIntentRaw(context, cq, tag));
    }
    std::unique_ptr<  ::grpc::ClientAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>> PrepareAsyncStreamingDetectIntent(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>>(PrepareAsyncStreamingDetectIntentRaw(context, cq));
    }
    ::grpc::Status MatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>> AsyncMatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>>(AsyncMatchIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>> PrepareAsyncMatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>>(PrepareAsyncMatchIntentRaw(context, request, cq));
    }
    ::grpc::Status FulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>> AsyncFulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>>(AsyncFulfillIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>> PrepareAsyncFulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>>(PrepareAsyncFulfillIntentRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void DetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response, std::function<void(::grpc::Status)>) override;
      void DetectIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StreamingDetectIntent(::grpc::ClientContext* context, ::grpc::ClientBidiReactor< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest,::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* reactor) override;
      void MatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response, std::function<void(::grpc::Status)>) override;
      void MatchIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response, std::function<void(::grpc::Status)>) override;
      void FulfillIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* AsyncDetectIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* PrepareAsyncDetectIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* StreamingDetectIntentRaw(::grpc::ClientContext* context) override;
    ::grpc::ClientAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* AsyncStreamingDetectIntentRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq, void* tag) override;
    ::grpc::ClientAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* PrepareAsyncStreamingDetectIntentRaw(::grpc::ClientContext* context, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* AsyncMatchIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* PrepareAsyncMatchIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* AsyncFulfillIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* PrepareAsyncFulfillIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_DetectIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_StreamingDetectIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_MatchIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_FulfillIntent_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Processes a natural language query and returns structured, actionable data
    // as a result. This method is not idempotent, because it may cause session
    // entity types to be updated, which in turn might affect results of future
    // queries.
    //
    // Note: Always use agent versions for production traffic.
    // See [Versions and
    // environments](https://cloud.google.com/dialogflow/cx/docs/concept/version).
    virtual ::grpc::Status DetectIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response);
    // Processes a natural language query in audio format in a streaming fashion
    // and returns structured, actionable data as a result. This method is only
    // available via the gRPC API (not REST).
    //
    // Note: Always use agent versions for production traffic.
    // See [Versions and
    // environments](https://cloud.google.com/dialogflow/cx/docs/concept/version).
    virtual ::grpc::Status StreamingDetectIntent(::grpc::ServerContext* context, ::grpc::ServerReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* stream);
    // Returns preliminary intent match results, doesn't change the session
    // status.
    virtual ::grpc::Status MatchIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response);
    // Fulfills a matched intent returned by
    // [MatchIntent][google.cloud.dialogflow.cx.v3.Sessions.MatchIntent]. Must be
    // called after
    // [MatchIntent][google.cloud.dialogflow.cx.v3.Sessions.MatchIntent], with
    // input from
    // [MatchIntentResponse][google.cloud.dialogflow.cx.v3.MatchIntentResponse].
    // Otherwise, the behavior is undefined.
    virtual ::grpc::Status FulfillIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_DetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DetectIntent() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_DetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetectIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDetectIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StreamingDetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StreamingDetectIntent() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_StreamingDetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingDetectIntent(::grpc::ServerContext* /*context*/, ::grpc::ServerReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* /*stream*/)  override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStreamingDetectIntent(::grpc::ServerContext* context, ::grpc::ServerAsyncReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* stream, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncBidiStreaming(1, context, stream, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MatchIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MatchIntent() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_MatchIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MatchIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMatchIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FulfillIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FulfillIntent() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_FulfillIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FulfillIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFulfillIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_DetectIntent<WithAsyncMethod_StreamingDetectIntent<WithAsyncMethod_MatchIntent<WithAsyncMethod_FulfillIntent<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_DetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DetectIntent() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::cx::v3::DetectIntentRequest, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* request, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* response) { return this->DetectIntent(context, request, response); }));}
    void SetMessageAllocatorFor_DetectIntent(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::cx::v3::DetectIntentRequest, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::cx::v3::DetectIntentRequest, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetectIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DetectIntent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StreamingDetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StreamingDetectIntent() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackBidiHandler< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context) { return this->StreamingDetectIntent(context); }));
    }
    ~WithCallbackMethod_StreamingDetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingDetectIntent(::grpc::ServerContext* /*context*/, ::grpc::ServerReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* /*stream*/)  override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerBidiReactor< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse>* StreamingDetectIntent(
      ::grpc::CallbackServerContext* /*context*/)
      { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MatchIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MatchIntent() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::cx::v3::MatchIntentRequest, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* request, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* response) { return this->MatchIntent(context, request, response); }));}
    void SetMessageAllocatorFor_MatchIntent(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::cx::v3::MatchIntentRequest, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::cx::v3::MatchIntentRequest, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MatchIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MatchIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MatchIntent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FulfillIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FulfillIntent() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* request, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* response) { return this->FulfillIntent(context, request, response); }));}
    void SetMessageAllocatorFor_FulfillIntent(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FulfillIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FulfillIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FulfillIntent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_DetectIntent<WithCallbackMethod_StreamingDetectIntent<WithCallbackMethod_MatchIntent<WithCallbackMethod_FulfillIntent<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_DetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DetectIntent() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_DetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetectIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StreamingDetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StreamingDetectIntent() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_StreamingDetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingDetectIntent(::grpc::ServerContext* /*context*/, ::grpc::ServerReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* /*stream*/)  override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MatchIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MatchIntent() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_MatchIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MatchIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FulfillIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FulfillIntent() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_FulfillIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FulfillIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_DetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DetectIntent() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_DetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetectIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDetectIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StreamingDetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StreamingDetectIntent() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_StreamingDetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingDetectIntent(::grpc::ServerContext* /*context*/, ::grpc::ServerReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* /*stream*/)  override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStreamingDetectIntent(::grpc::ServerContext* context, ::grpc::ServerAsyncReaderWriter< ::grpc::ByteBuffer, ::grpc::ByteBuffer>* stream, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncBidiStreaming(1, context, stream, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MatchIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MatchIntent() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_MatchIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MatchIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMatchIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FulfillIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FulfillIntent() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_FulfillIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FulfillIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFulfillIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DetectIntent() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DetectIntent(context, request, response); }));
    }
    ~WithRawCallbackMethod_DetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetectIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DetectIntent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StreamingDetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StreamingDetectIntent() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackBidiHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context) { return this->StreamingDetectIntent(context); }));
    }
    ~WithRawCallbackMethod_StreamingDetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StreamingDetectIntent(::grpc::ServerContext* /*context*/, ::grpc::ServerReaderWriter< ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentResponse, ::google::cloud::dialogflow::cx::v3::StreamingDetectIntentRequest>* /*stream*/)  override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerBidiReactor< ::grpc::ByteBuffer, ::grpc::ByteBuffer>* StreamingDetectIntent(
      ::grpc::CallbackServerContext* /*context*/)
      { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MatchIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MatchIntent() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MatchIntent(context, request, response); }));
    }
    ~WithRawCallbackMethod_MatchIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MatchIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MatchIntent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FulfillIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FulfillIntent() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FulfillIntent(context, request, response); }));
    }
    ~WithRawCallbackMethod_FulfillIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FulfillIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FulfillIntent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DetectIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DetectIntent() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::cx::v3::DetectIntentRequest, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::cx::v3::DetectIntentRequest, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* streamer) {
                       return this->StreamedDetectIntent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DetectIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DetectIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::DetectIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::DetectIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDetectIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::cx::v3::DetectIntentRequest,::google::cloud::dialogflow::cx::v3::DetectIntentResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MatchIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MatchIntent() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::cx::v3::MatchIntentRequest, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::cx::v3::MatchIntentRequest, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* streamer) {
                       return this->StreamedMatchIntent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MatchIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MatchIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::MatchIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::MatchIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMatchIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::cx::v3::MatchIntentRequest,::google::cloud::dialogflow::cx::v3::MatchIntentResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FulfillIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FulfillIntent() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* streamer) {
                       return this->StreamedFulfillIntent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FulfillIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FulfillIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest* /*request*/, ::google::cloud::dialogflow::cx::v3::FulfillIntentResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFulfillIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::cx::v3::FulfillIntentRequest,::google::cloud::dialogflow::cx::v3::FulfillIntentResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_DetectIntent<WithStreamedUnaryMethod_MatchIntent<WithStreamedUnaryMethod_FulfillIntent<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_DetectIntent<WithStreamedUnaryMethod_MatchIntent<WithStreamedUnaryMethod_FulfillIntent<Service > > > StreamedService;
};

}  // namespace v3
}  // namespace cx
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdialogflow_2fcx_2fv3_2fsession_2eproto__INCLUDED
