// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/filestore/v1/cloud_filestore_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ffilestore_2fv1_2fcloud_5ffilestore_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ffilestore_2fv1_2fcloud_5ffilestore_5fservice_2eproto__INCLUDED

#include "google/cloud/filestore/v1/cloud_filestore_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace filestore {
namespace v1 {

// Configures and manages Filestore resources.
//
// Filestore Manager v1.
//
// The `file.googleapis.com` service implements the Filestore API and
// defines the following resource model for managing instances:
// * The service works with a collection of cloud projects, named: `/projects/*`
// * Each project has a collection of available locations, named: `/locations/*`
// * Each location has a collection of instances and backups, named:
// `/instances/*` and `/backups/*` respectively.
// * As such, Filestore instances are resources of the form:
//   `/projects/{project_number}/locations/{location_id}/instances/{instance_id}`
//   and backups are resources of the form:
//   `/projects/{project_number}/locations/{location_id}/backup/{backup_id}`
//
// Note that location_id must be a Google Cloud `zone` for instances, but
// a Google Cloud `region` for backups; for example:
// * `projects/12345/locations/us-central1-c/instances/my-filestore`
// * `projects/12345/locations/us-central1/backups/my-backup`
class CloudFilestoreManager final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.filestore.v1.CloudFilestoreManager";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all instances in a project for either a specified location
    // or for all locations.
    virtual ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::google::cloud::filestore::v1::ListInstancesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    // Gets the details of a specific instance.
    virtual ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::google::cloud::filestore::v1::Instance* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    // Creates an instance.
    // When creating from a backup, the capacity of the new instance needs to be
    // equal to or larger than the capacity of the backup (and also equal to or
    // larger than the minimum capacity of the tier).
    virtual ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    // Updates the settings of a specific instance.
    virtual ::grpc::Status UpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceRaw(context, request, cq));
    }
    // Restores an existing instance's file share from a backup.
    //
    // The capacity of the instance needs to be equal to or larger than the
    // capacity of the backup (and also equal to or larger than the minimum
    // capacity of the tier).
    virtual ::grpc::Status RestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRestoreInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRestoreInstanceRaw(context, request, cq));
    }
    // Deletes an instance.
    virtual ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    // Lists all snapshots in a project for either a specified location
    // or for all locations.
    virtual ::grpc::Status ListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListSnapshotsResponse>> AsyncListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListSnapshotsResponse>>(AsyncListSnapshotsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListSnapshotsResponse>> PrepareAsyncListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListSnapshotsResponse>>(PrepareAsyncListSnapshotsRaw(context, request, cq));
    }
    // Gets the details of a specific snapshot.
    virtual ::grpc::Status GetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::google::cloud::filestore::v1::Snapshot* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Snapshot>> AsyncGetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Snapshot>>(AsyncGetSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Snapshot>> PrepareAsyncGetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Snapshot>>(PrepareAsyncGetSnapshotRaw(context, request, cq));
    }
    // Creates a snapshot.
    virtual ::grpc::Status CreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateSnapshotRaw(context, request, cq));
    }
    // Deletes a snapshot.
    virtual ::grpc::Status DeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteSnapshotRaw(context, request, cq));
    }
    // Updates the settings of a specific snapshot.
    virtual ::grpc::Status UpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSnapshotRaw(context, request, cq));
    }
    // Lists all backups in a project for either a specified location or for all
    // locations.
    virtual ::grpc::Status ListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::google::cloud::filestore::v1::ListBackupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListBackupsResponse>> AsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListBackupsResponse>>(AsyncListBackupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListBackupsResponse>> PrepareAsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListBackupsResponse>>(PrepareAsyncListBackupsRaw(context, request, cq));
    }
    // Gets the details of a specific backup.
    virtual ::grpc::Status GetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::google::cloud::filestore::v1::Backup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Backup>> AsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Backup>>(AsyncGetBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Backup>> PrepareAsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Backup>>(PrepareAsyncGetBackupRaw(context, request, cq));
    }
    // Creates a backup.
    virtual ::grpc::Status CreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateBackupRaw(context, request, cq));
    }
    // Deletes a backup.
    virtual ::grpc::Status DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteBackupRaw(context, request, cq));
    }
    // Updates the settings of a specific backup.
    virtual ::grpc::Status UpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateBackupRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all instances in a project for either a specified location
      // or for all locations.
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest* request, ::google::cloud::filestore::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest* request, ::google::cloud::filestore::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific instance.
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest* request, ::google::cloud::filestore::v1::Instance* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest* request, ::google::cloud::filestore::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an instance.
      // When creating from a backup, the capacity of the new instance needs to be
      // equal to or larger than the capacity of the backup (and also equal to or
      // larger than the minimum capacity of the tier).
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the settings of a specific instance.
      virtual void UpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restores an existing instance's file share from a backup.
      //
      // The capacity of the instance needs to be equal to or larger than the
      // capacity of the backup (and also equal to or larger than the minimum
      // capacity of the tier).
      virtual void RestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an instance.
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all snapshots in a project for either a specified location
      // or for all locations.
      virtual void ListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific snapshot.
      virtual void GetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::google::cloud::filestore::v1::Snapshot* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::google::cloud::filestore::v1::Snapshot* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a snapshot.
      virtual void CreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a snapshot.
      virtual void DeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the settings of a specific snapshot.
      virtual void UpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all backups in a project for either a specified location or for all
      // locations.
      virtual void ListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest* request, ::google::cloud::filestore::v1::ListBackupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest* request, ::google::cloud::filestore::v1::ListBackupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific backup.
      virtual void GetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest* request, ::google::cloud::filestore::v1::Backup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest* request, ::google::cloud::filestore::v1::Backup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a backup.
      virtual void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a backup.
      virtual void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the settings of a specific backup.
      virtual void UpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRestoreInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRestoreInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListSnapshotsResponse>* AsyncListSnapshotsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListSnapshotsResponse>* PrepareAsyncListSnapshotsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Snapshot>* AsyncGetSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Snapshot>* PrepareAsyncGetSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListBackupsResponse>* AsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::ListBackupsResponse>* PrepareAsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Backup>* AsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::filestore::v1::Backup>* PrepareAsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::google::cloud::filestore::v1::ListInstancesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::google::cloud::filestore::v1::Instance* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    ::grpc::Status UpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceRaw(context, request, cq));
    }
    ::grpc::Status RestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRestoreInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRestoreInstanceRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    ::grpc::Status ListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListSnapshotsResponse>> AsyncListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListSnapshotsResponse>>(AsyncListSnapshotsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListSnapshotsResponse>> PrepareAsyncListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListSnapshotsResponse>>(PrepareAsyncListSnapshotsRaw(context, request, cq));
    }
    ::grpc::Status GetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::google::cloud::filestore::v1::Snapshot* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Snapshot>> AsyncGetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Snapshot>>(AsyncGetSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Snapshot>> PrepareAsyncGetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Snapshot>>(PrepareAsyncGetSnapshotRaw(context, request, cq));
    }
    ::grpc::Status CreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateSnapshotRaw(context, request, cq));
    }
    ::grpc::Status DeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteSnapshotRaw(context, request, cq));
    }
    ::grpc::Status UpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSnapshotRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSnapshotRaw(context, request, cq));
    }
    ::grpc::Status ListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::google::cloud::filestore::v1::ListBackupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListBackupsResponse>> AsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListBackupsResponse>>(AsyncListBackupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListBackupsResponse>> PrepareAsyncListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListBackupsResponse>>(PrepareAsyncListBackupsRaw(context, request, cq));
    }
    ::grpc::Status GetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::google::cloud::filestore::v1::Backup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Backup>> AsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Backup>>(AsyncGetBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Backup>> PrepareAsyncGetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Backup>>(PrepareAsyncGetBackupRaw(context, request, cq));
    }
    ::grpc::Status CreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateBackupRaw(context, request, cq));
    }
    ::grpc::Status DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteBackupRaw(context, request, cq));
    }
    ::grpc::Status UpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateBackupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateBackupRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest* request, ::google::cloud::filestore::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstances(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest* request, ::google::cloud::filestore::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest* request, ::google::cloud::filestore::v1::Instance* response, std::function<void(::grpc::Status)>) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest* request, ::google::cloud::filestore::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RestoreInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSnapshots(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::google::cloud::filestore::v1::Snapshot* response, std::function<void(::grpc::Status)>) override;
      void GetSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::google::cloud::filestore::v1::Snapshot* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSnapshot(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest* request, ::google::cloud::filestore::v1::ListBackupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBackups(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest* request, ::google::cloud::filestore::v1::ListBackupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest* request, ::google::cloud::filestore::v1::Backup* response, std::function<void(::grpc::Status)>) override;
      void GetBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest* request, ::google::cloud::filestore::v1::Backup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateBackup(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRestoreInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRestoreInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListSnapshotsResponse>* AsyncListSnapshotsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListSnapshotsResponse>* PrepareAsyncListSnapshotsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Snapshot>* AsyncGetSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Snapshot>* PrepareAsyncGetSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSnapshotRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListBackupsResponse>* AsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::ListBackupsResponse>* PrepareAsyncListBackupsRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Backup>* AsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::filestore::v1::Backup>* PrepareAsyncGetBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::GetBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateBackupRaw(::grpc::ClientContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstances_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_RestoreInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSnapshots_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSnapshot_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSnapshot_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSnapshot_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSnapshot_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBackups_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBackup_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateBackup_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all instances in a project for either a specified location
    // or for all locations.
    virtual ::grpc::Status ListInstances(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest* request, ::google::cloud::filestore::v1::ListInstancesResponse* response);
    // Gets the details of a specific instance.
    virtual ::grpc::Status GetInstance(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest* request, ::google::cloud::filestore::v1::Instance* response);
    // Creates an instance.
    // When creating from a backup, the capacity of the new instance needs to be
    // equal to or larger than the capacity of the backup (and also equal to or
    // larger than the minimum capacity of the tier).
    virtual ::grpc::Status CreateInstance(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response);
    // Updates the settings of a specific instance.
    virtual ::grpc::Status UpdateInstance(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response);
    // Restores an existing instance's file share from a backup.
    //
    // The capacity of the instance needs to be equal to or larger than the
    // capacity of the backup (and also equal to or larger than the minimum
    // capacity of the tier).
    virtual ::grpc::Status RestoreInstance(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::google::longrunning::Operation* response);
    // Deletes an instance.
    virtual ::grpc::Status DeleteInstance(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response);
    // Lists all snapshots in a project for either a specified location
    // or for all locations.
    virtual ::grpc::Status ListSnapshots(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response);
    // Gets the details of a specific snapshot.
    virtual ::grpc::Status GetSnapshot(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::google::cloud::filestore::v1::Snapshot* response);
    // Creates a snapshot.
    virtual ::grpc::Status CreateSnapshot(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::google::longrunning::Operation* response);
    // Deletes a snapshot.
    virtual ::grpc::Status DeleteSnapshot(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::google::longrunning::Operation* response);
    // Updates the settings of a specific snapshot.
    virtual ::grpc::Status UpdateSnapshot(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::google::longrunning::Operation* response);
    // Lists all backups in a project for either a specified location or for all
    // locations.
    virtual ::grpc::Status ListBackups(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest* request, ::google::cloud::filestore::v1::ListBackupsResponse* response);
    // Gets the details of a specific backup.
    virtual ::grpc::Status GetBackup(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::GetBackupRequest* request, ::google::cloud::filestore::v1::Backup* response);
    // Creates a backup.
    virtual ::grpc::Status CreateBackup(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response);
    // Deletes a backup.
    virtual ::grpc::Status DeleteBackup(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response);
    // Updates the settings of a specific backup.
    virtual ::grpc::Status UpdateBackup(::grpc::ServerContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstances() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::google::cloud::filestore::v1::ListInstancesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::filestore::v1::ListInstancesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstance() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::google::cloud::filestore::v1::GetInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::filestore::v1::Instance>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInstance() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstance(::grpc::ServerContext* context, ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RestoreInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RestoreInstance() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_RestoreInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreInstance(::grpc::ServerContext* context, ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSnapshots : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSnapshots() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListSnapshots() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSnapshots(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSnapshots(::grpc::ServerContext* context, ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::filestore::v1::ListSnapshotsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSnapshot() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSnapshot(::grpc::ServerContext* context, ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::filestore::v1::Snapshot>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSnapshot() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSnapshot(::grpc::ServerContext* context, ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSnapshot() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSnapshot(::grpc::ServerContext* context, ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSnapshot() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_UpdateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSnapshot(::grpc::ServerContext* context, ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBackups() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackups(::grpc::ServerContext* context, ::google::cloud::filestore::v1::ListBackupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::filestore::v1::ListBackupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBackup() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackup(::grpc::ServerContext* context, ::google::cloud::filestore::v1::GetBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::filestore::v1::Backup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBackup() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBackup(::grpc::ServerContext* context, ::google::cloud::filestore::v1::CreateBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBackup(::grpc::ServerContext* context, ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateBackup() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_UpdateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBackup(::grpc::ServerContext* context, ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListInstances<WithAsyncMethod_GetInstance<WithAsyncMethod_CreateInstance<WithAsyncMethod_UpdateInstance<WithAsyncMethod_RestoreInstance<WithAsyncMethod_DeleteInstance<WithAsyncMethod_ListSnapshots<WithAsyncMethod_GetSnapshot<WithAsyncMethod_CreateSnapshot<WithAsyncMethod_DeleteSnapshot<WithAsyncMethod_UpdateSnapshot<WithAsyncMethod_ListBackups<WithAsyncMethod_GetBackup<WithAsyncMethod_CreateBackup<WithAsyncMethod_DeleteBackup<WithAsyncMethod_UpdateBackup<Service > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::ListInstancesRequest, ::google::cloud::filestore::v1::ListInstancesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::ListInstancesRequest* request, ::google::cloud::filestore::v1::ListInstancesResponse* response) { return this->ListInstances(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstances(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::ListInstancesRequest, ::google::cloud::filestore::v1::ListInstancesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::ListInstancesRequest, ::google::cloud::filestore::v1::ListInstancesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::GetInstanceRequest, ::google::cloud::filestore::v1::Instance>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::GetInstanceRequest* request, ::google::cloud::filestore::v1::Instance* response) { return this->GetInstance(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstance(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::GetInstanceRequest, ::google::cloud::filestore::v1::Instance>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::GetInstanceRequest, ::google::cloud::filestore::v1::Instance>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response) { return this->CreateInstance(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInstance(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::CreateInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::CreateInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::UpdateInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::UpdateInstanceRequest* request, ::google::longrunning::Operation* response) { return this->UpdateInstance(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInstance(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::UpdateInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::UpdateInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RestoreInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RestoreInstance() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::RestoreInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::RestoreInstanceRequest* request, ::google::longrunning::Operation* response) { return this->RestoreInstance(context, request, response); }));}
    void SetMessageAllocatorFor_RestoreInstance(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::RestoreInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::RestoreInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RestoreInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstance(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::DeleteInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSnapshots : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSnapshots() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::ListSnapshotsRequest, ::google::cloud::filestore::v1::ListSnapshotsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::ListSnapshotsRequest* request, ::google::cloud::filestore::v1::ListSnapshotsResponse* response) { return this->ListSnapshots(context, request, response); }));}
    void SetMessageAllocatorFor_ListSnapshots(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::ListSnapshotsRequest, ::google::cloud::filestore::v1::ListSnapshotsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::ListSnapshotsRequest, ::google::cloud::filestore::v1::ListSnapshotsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSnapshots() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSnapshots(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSnapshots(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSnapshot() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::GetSnapshotRequest, ::google::cloud::filestore::v1::Snapshot>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::GetSnapshotRequest* request, ::google::cloud::filestore::v1::Snapshot* response) { return this->GetSnapshot(context, request, response); }));}
    void SetMessageAllocatorFor_GetSnapshot(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::GetSnapshotRequest, ::google::cloud::filestore::v1::Snapshot>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::GetSnapshotRequest, ::google::cloud::filestore::v1::Snapshot>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSnapshot() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::CreateSnapshotRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::CreateSnapshotRequest* request, ::google::longrunning::Operation* response) { return this->CreateSnapshot(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSnapshot(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::CreateSnapshotRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::CreateSnapshotRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSnapshot() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::DeleteSnapshotRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSnapshot(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSnapshot(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::DeleteSnapshotRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::DeleteSnapshotRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSnapshot() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::UpdateSnapshotRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSnapshot(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSnapshot(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::UpdateSnapshotRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::UpdateSnapshotRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBackups() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::ListBackupsRequest, ::google::cloud::filestore::v1::ListBackupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::ListBackupsRequest* request, ::google::cloud::filestore::v1::ListBackupsResponse* response) { return this->ListBackups(context, request, response); }));}
    void SetMessageAllocatorFor_ListBackups(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::ListBackupsRequest, ::google::cloud::filestore::v1::ListBackupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::ListBackupsRequest, ::google::cloud::filestore::v1::ListBackupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBackup() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::GetBackupRequest, ::google::cloud::filestore::v1::Backup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::GetBackupRequest* request, ::google::cloud::filestore::v1::Backup* response) { return this->GetBackup(context, request, response); }));}
    void SetMessageAllocatorFor_GetBackup(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::GetBackupRequest, ::google::cloud::filestore::v1::Backup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::GetBackupRequest, ::google::cloud::filestore::v1::Backup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBackup() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::CreateBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::CreateBackupRequest* request, ::google::longrunning::Operation* response) { return this->CreateBackup(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBackup(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::CreateBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::CreateBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::DeleteBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::DeleteBackupRequest* request, ::google::longrunning::Operation* response) { return this->DeleteBackup(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBackup(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::DeleteBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::DeleteBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateBackup() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::UpdateBackupRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::filestore::v1::UpdateBackupRequest* request, ::google::longrunning::Operation* response) { return this->UpdateBackup(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateBackup(
        ::grpc::MessageAllocator< ::google::cloud::filestore::v1::UpdateBackupRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::filestore::v1::UpdateBackupRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListInstances<WithCallbackMethod_GetInstance<WithCallbackMethod_CreateInstance<WithCallbackMethod_UpdateInstance<WithCallbackMethod_RestoreInstance<WithCallbackMethod_DeleteInstance<WithCallbackMethod_ListSnapshots<WithCallbackMethod_GetSnapshot<WithCallbackMethod_CreateSnapshot<WithCallbackMethod_DeleteSnapshot<WithCallbackMethod_UpdateSnapshot<WithCallbackMethod_ListBackups<WithCallbackMethod_GetBackup<WithCallbackMethod_CreateBackup<WithCallbackMethod_DeleteBackup<WithCallbackMethod_UpdateBackup<Service > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstances() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstance() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInstance() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RestoreInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RestoreInstance() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_RestoreInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSnapshots : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSnapshots() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListSnapshots() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSnapshots(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSnapshot() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSnapshot() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSnapshot() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSnapshot() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_UpdateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBackups() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBackup() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBackup() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateBackup() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_UpdateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstances() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstance() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RestoreInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RestoreInstance() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_RestoreInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSnapshots : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSnapshots() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListSnapshots() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSnapshots(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSnapshots(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSnapshot() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSnapshot(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSnapshot() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSnapshot(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSnapshot() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSnapshot(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSnapshot() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_UpdateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSnapshot(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBackups() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBackups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBackup() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBackup() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateBackup() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_UpdateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBackup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstances(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RestoreInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RestoreInstance() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RestoreInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_RestoreInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSnapshots : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSnapshots() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSnapshots(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSnapshots() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSnapshots(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSnapshots(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSnapshot() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSnapshot(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSnapshot() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSnapshot(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSnapshot() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSnapshot(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSnapshot() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSnapshot(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSnapshot(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBackups() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBackups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBackups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBackup() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBackup() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateBackup() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateBackup(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBackup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstances() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::ListInstancesRequest, ::google::cloud::filestore::v1::ListInstancesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::ListInstancesRequest, ::google::cloud::filestore::v1::ListInstancesResponse>* streamer) {
                       return this->StreamedListInstances(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListInstancesRequest* /*request*/, ::google::cloud::filestore::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstances(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::ListInstancesRequest,::google::cloud::filestore::v1::ListInstancesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstance() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::GetInstanceRequest, ::google::cloud::filestore::v1::Instance>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::GetInstanceRequest, ::google::cloud::filestore::v1::Instance>* streamer) {
                       return this->StreamedGetInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetInstanceRequest* /*request*/, ::google::cloud::filestore::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::GetInstanceRequest,::google::cloud::filestore::v1::Instance>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInstance() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::CreateInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::CreateInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInstance() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::UpdateInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::UpdateInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::UpdateInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RestoreInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RestoreInstance() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::RestoreInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::RestoreInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRestoreInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RestoreInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RestoreInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::RestoreInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestoreInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::RestoreInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::DeleteInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSnapshots : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSnapshots() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::ListSnapshotsRequest, ::google::cloud::filestore::v1::ListSnapshotsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::ListSnapshotsRequest, ::google::cloud::filestore::v1::ListSnapshotsResponse>* streamer) {
                       return this->StreamedListSnapshots(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSnapshots() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSnapshots(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListSnapshotsRequest* /*request*/, ::google::cloud::filestore::v1::ListSnapshotsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSnapshots(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::ListSnapshotsRequest,::google::cloud::filestore::v1::ListSnapshotsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSnapshot() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::GetSnapshotRequest, ::google::cloud::filestore::v1::Snapshot>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::GetSnapshotRequest, ::google::cloud::filestore::v1::Snapshot>* streamer) {
                       return this->StreamedGetSnapshot(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetSnapshotRequest* /*request*/, ::google::cloud::filestore::v1::Snapshot* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSnapshot(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::GetSnapshotRequest,::google::cloud::filestore::v1::Snapshot>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSnapshot() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::CreateSnapshotRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::CreateSnapshotRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSnapshot(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSnapshot(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::CreateSnapshotRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSnapshot() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::DeleteSnapshotRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::DeleteSnapshotRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSnapshot(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSnapshot(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::DeleteSnapshotRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSnapshot : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSnapshot() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::UpdateSnapshotRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::UpdateSnapshotRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSnapshot(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSnapshot() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSnapshot(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateSnapshotRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSnapshot(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::UpdateSnapshotRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBackups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBackups() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::ListBackupsRequest, ::google::cloud::filestore::v1::ListBackupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::ListBackupsRequest, ::google::cloud::filestore::v1::ListBackupsResponse>* streamer) {
                       return this->StreamedListBackups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBackups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBackups(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::ListBackupsRequest* /*request*/, ::google::cloud::filestore::v1::ListBackupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBackups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::ListBackupsRequest,::google::cloud::filestore::v1::ListBackupsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBackup() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::GetBackupRequest, ::google::cloud::filestore::v1::Backup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::GetBackupRequest, ::google::cloud::filestore::v1::Backup>* streamer) {
                       return this->StreamedGetBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::GetBackupRequest* /*request*/, ::google::cloud::filestore::v1::Backup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::GetBackupRequest,::google::cloud::filestore::v1::Backup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBackup() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::CreateBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::CreateBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::CreateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::CreateBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBackup() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::DeleteBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::DeleteBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::DeleteBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::DeleteBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateBackup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateBackup() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::filestore::v1::UpdateBackupRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::filestore::v1::UpdateBackupRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateBackup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateBackup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateBackup(::grpc::ServerContext* /*context*/, const ::google::cloud::filestore::v1::UpdateBackupRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateBackup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::filestore::v1::UpdateBackupRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_UpdateInstance<WithStreamedUnaryMethod_RestoreInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_ListSnapshots<WithStreamedUnaryMethod_GetSnapshot<WithStreamedUnaryMethod_CreateSnapshot<WithStreamedUnaryMethod_DeleteSnapshot<WithStreamedUnaryMethod_UpdateSnapshot<WithStreamedUnaryMethod_ListBackups<WithStreamedUnaryMethod_GetBackup<WithStreamedUnaryMethod_CreateBackup<WithStreamedUnaryMethod_DeleteBackup<WithStreamedUnaryMethod_UpdateBackup<Service > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_UpdateInstance<WithStreamedUnaryMethod_RestoreInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_ListSnapshots<WithStreamedUnaryMethod_GetSnapshot<WithStreamedUnaryMethod_CreateSnapshot<WithStreamedUnaryMethod_DeleteSnapshot<WithStreamedUnaryMethod_UpdateSnapshot<WithStreamedUnaryMethod_ListBackups<WithStreamedUnaryMethod_GetBackup<WithStreamedUnaryMethod_CreateBackup<WithStreamedUnaryMethod_DeleteBackup<WithStreamedUnaryMethod_UpdateBackup<Service > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace filestore
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2ffilestore_2fv1_2fcloud_5ffilestore_5fservice_2eproto__INCLUDED
