// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/kms/v1/ekm_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fkms_2fv1_2fekm_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fkms_2fv1_2fekm_5fservice_2eproto__INCLUDED

#include "google/cloud/kms/v1/ekm_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace kms {
namespace v1 {

// Google Cloud Key Management EKM Service
//
// Manages external cryptographic keys and operations using those keys.
// Implements a REST model with the following objects:
// * [EkmConnection][google.cloud.kms.v1.EkmConnection]
class EkmService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.kms.v1.EkmService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists [EkmConnections][google.cloud.kms.v1.EkmConnection].
    virtual ::grpc::Status ListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListEkmConnectionsResponse>> AsyncListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListEkmConnectionsResponse>>(AsyncListEkmConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListEkmConnectionsResponse>> PrepareAsyncListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListEkmConnectionsResponse>>(PrepareAsyncListEkmConnectionsRaw(context, request, cq));
    }
    // Returns metadata for a given
    // [EkmConnection][google.cloud.kms.v1.EkmConnection].
    virtual ::grpc::Status GetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::google::cloud::kms::v1::EkmConnection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>> AsyncGetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>>(AsyncGetEkmConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>> PrepareAsyncGetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>>(PrepareAsyncGetEkmConnectionRaw(context, request, cq));
    }
    // Creates a new [EkmConnection][google.cloud.kms.v1.EkmConnection] in a given
    // Project and Location.
    virtual ::grpc::Status CreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::google::cloud::kms::v1::EkmConnection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>> AsyncCreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>>(AsyncCreateEkmConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>> PrepareAsyncCreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>>(PrepareAsyncCreateEkmConnectionRaw(context, request, cq));
    }
    // Updates an [EkmConnection][google.cloud.kms.v1.EkmConnection]'s metadata.
    virtual ::grpc::Status UpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::google::cloud::kms::v1::EkmConnection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>> AsyncUpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>>(AsyncUpdateEkmConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>> PrepareAsyncUpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>>(PrepareAsyncUpdateEkmConnectionRaw(context, request, cq));
    }
    // Returns the [EkmConfig][google.cloud.kms.v1.EkmConfig] singleton resource
    // for a given project and location.
    virtual ::grpc::Status GetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::google::cloud::kms::v1::EkmConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>> AsyncGetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>>(AsyncGetEkmConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>> PrepareAsyncGetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>>(PrepareAsyncGetEkmConfigRaw(context, request, cq));
    }
    // Updates the [EkmConfig][google.cloud.kms.v1.EkmConfig] singleton resource
    // for a given project and location.
    virtual ::grpc::Status UpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::google::cloud::kms::v1::EkmConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>> AsyncUpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>>(AsyncUpdateEkmConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>> PrepareAsyncUpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>>(PrepareAsyncUpdateEkmConfigRaw(context, request, cq));
    }
    // Verifies that Cloud KMS can successfully connect to the external key
    // manager specified by an [EkmConnection][google.cloud.kms.v1.EkmConnection].
    // If there is an error connecting to the EKM, this method returns a
    // FAILED_PRECONDITION status containing structured information as described
    // at https://cloud.google.com/kms/docs/reference/ekm_errors.
    virtual ::grpc::Status VerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::VerifyConnectivityResponse>> AsyncVerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::VerifyConnectivityResponse>>(AsyncVerifyConnectivityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::VerifyConnectivityResponse>> PrepareAsyncVerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::VerifyConnectivityResponse>>(PrepareAsyncVerifyConnectivityRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists [EkmConnections][google.cloud.kms.v1.EkmConnection].
      virtual void ListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns metadata for a given
      // [EkmConnection][google.cloud.kms.v1.EkmConnection].
      virtual void GetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new [EkmConnection][google.cloud.kms.v1.EkmConnection] in a given
      // Project and Location.
      virtual void CreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an [EkmConnection][google.cloud.kms.v1.EkmConnection]'s metadata.
      virtual void UpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the [EkmConfig][google.cloud.kms.v1.EkmConfig] singleton resource
      // for a given project and location.
      virtual void GetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the [EkmConfig][google.cloud.kms.v1.EkmConfig] singleton resource
      // for a given project and location.
      virtual void UpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Verifies that Cloud KMS can successfully connect to the external key
      // manager specified by an [EkmConnection][google.cloud.kms.v1.EkmConnection].
      // If there is an error connecting to the EKM, this method returns a
      // FAILED_PRECONDITION status containing structured information as described
      // at https://cloud.google.com/kms/docs/reference/ekm_errors.
      virtual void VerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void VerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListEkmConnectionsResponse>* AsyncListEkmConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListEkmConnectionsResponse>* PrepareAsyncListEkmConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>* AsyncGetEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>* PrepareAsyncGetEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>* AsyncCreateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>* PrepareAsyncCreateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>* AsyncUpdateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConnection>* PrepareAsyncUpdateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>* AsyncGetEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>* PrepareAsyncGetEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>* AsyncUpdateEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EkmConfig>* PrepareAsyncUpdateEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::VerifyConnectivityResponse>* AsyncVerifyConnectivityRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::VerifyConnectivityResponse>* PrepareAsyncVerifyConnectivityRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListEkmConnectionsResponse>> AsyncListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListEkmConnectionsResponse>>(AsyncListEkmConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListEkmConnectionsResponse>> PrepareAsyncListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListEkmConnectionsResponse>>(PrepareAsyncListEkmConnectionsRaw(context, request, cq));
    }
    ::grpc::Status GetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::google::cloud::kms::v1::EkmConnection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>> AsyncGetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>>(AsyncGetEkmConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>> PrepareAsyncGetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>>(PrepareAsyncGetEkmConnectionRaw(context, request, cq));
    }
    ::grpc::Status CreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::google::cloud::kms::v1::EkmConnection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>> AsyncCreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>>(AsyncCreateEkmConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>> PrepareAsyncCreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>>(PrepareAsyncCreateEkmConnectionRaw(context, request, cq));
    }
    ::grpc::Status UpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::google::cloud::kms::v1::EkmConnection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>> AsyncUpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>>(AsyncUpdateEkmConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>> PrepareAsyncUpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>>(PrepareAsyncUpdateEkmConnectionRaw(context, request, cq));
    }
    ::grpc::Status GetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::google::cloud::kms::v1::EkmConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>> AsyncGetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>>(AsyncGetEkmConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>> PrepareAsyncGetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>>(PrepareAsyncGetEkmConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::google::cloud::kms::v1::EkmConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>> AsyncUpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>>(AsyncUpdateEkmConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>> PrepareAsyncUpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>>(PrepareAsyncUpdateEkmConfigRaw(context, request, cq));
    }
    ::grpc::Status VerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::VerifyConnectivityResponse>> AsyncVerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::VerifyConnectivityResponse>>(AsyncVerifyConnectivityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::VerifyConnectivityResponse>> PrepareAsyncVerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::VerifyConnectivityResponse>>(PrepareAsyncVerifyConnectivityRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEkmConnections(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, std::function<void(::grpc::Status)>) override;
      void GetEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, std::function<void(::grpc::Status)>) override;
      void CreateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, std::function<void(::grpc::Status)>) override;
      void UpdateEkmConnection(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, std::function<void(::grpc::Status)>) override;
      void GetEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateEkmConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void VerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response, std::function<void(::grpc::Status)>) override;
      void VerifyConnectivity(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListEkmConnectionsResponse>* AsyncListEkmConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListEkmConnectionsResponse>* PrepareAsyncListEkmConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>* AsyncGetEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>* PrepareAsyncGetEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>* AsyncCreateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>* PrepareAsyncCreateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>* AsyncUpdateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConnection>* PrepareAsyncUpdateEkmConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>* AsyncGetEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>* PrepareAsyncGetEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>* AsyncUpdateEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EkmConfig>* PrepareAsyncUpdateEkmConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::VerifyConnectivityResponse>* AsyncVerifyConnectivityRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::VerifyConnectivityResponse>* PrepareAsyncVerifyConnectivityRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListEkmConnections_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEkmConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEkmConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEkmConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEkmConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEkmConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_VerifyConnectivity_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists [EkmConnections][google.cloud.kms.v1.EkmConnection].
    virtual ::grpc::Status ListEkmConnections(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response);
    // Returns metadata for a given
    // [EkmConnection][google.cloud.kms.v1.EkmConnection].
    virtual ::grpc::Status GetEkmConnection(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response);
    // Creates a new [EkmConnection][google.cloud.kms.v1.EkmConnection] in a given
    // Project and Location.
    virtual ::grpc::Status CreateEkmConnection(::grpc::ServerContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response);
    // Updates an [EkmConnection][google.cloud.kms.v1.EkmConnection]'s metadata.
    virtual ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response);
    // Returns the [EkmConfig][google.cloud.kms.v1.EkmConfig] singleton resource
    // for a given project and location.
    virtual ::grpc::Status GetEkmConfig(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response);
    // Updates the [EkmConfig][google.cloud.kms.v1.EkmConfig] singleton resource
    // for a given project and location.
    virtual ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response);
    // Verifies that Cloud KMS can successfully connect to the external key
    // manager specified by an [EkmConnection][google.cloud.kms.v1.EkmConnection].
    // If there is an error connecting to the EKM, this method returns a
    // FAILED_PRECONDITION status containing structured information as described
    // at https://cloud.google.com/kms/docs/reference/ekm_errors.
    virtual ::grpc::Status VerifyConnectivity(::grpc::ServerContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEkmConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEkmConnections() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListEkmConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEkmConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEkmConnections(::grpc::ServerContext* context, ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ListEkmConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEkmConnection() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEkmConnection(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::EkmConnection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEkmConnection() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEkmConnection(::grpc::ServerContext* context, ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::EkmConnection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEkmConnection() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEkmConnection(::grpc::ServerContext* context, ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::EkmConnection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEkmConfig() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEkmConfig(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::EkmConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEkmConfig() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdateEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEkmConfig(::grpc::ServerContext* context, ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::EkmConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_VerifyConnectivity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_VerifyConnectivity() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_VerifyConnectivity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyConnectivity(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestVerifyConnectivity(::grpc::ServerContext* context, ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::VerifyConnectivityResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListEkmConnections<WithAsyncMethod_GetEkmConnection<WithAsyncMethod_CreateEkmConnection<WithAsyncMethod_UpdateEkmConnection<WithAsyncMethod_GetEkmConfig<WithAsyncMethod_UpdateEkmConfig<WithAsyncMethod_VerifyConnectivity<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListEkmConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEkmConnections() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListEkmConnectionsRequest, ::google::cloud::kms::v1::ListEkmConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* request, ::google::cloud::kms::v1::ListEkmConnectionsResponse* response) { return this->ListEkmConnections(context, request, response); }));}
    void SetMessageAllocatorFor_ListEkmConnections(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ListEkmConnectionsRequest, ::google::cloud::kms::v1::ListEkmConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListEkmConnectionsRequest, ::google::cloud::kms::v1::ListEkmConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEkmConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEkmConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEkmConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEkmConnection() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response) { return this->GetEkmConnection(context, request, response); }));}
    void SetMessageAllocatorFor_GetEkmConnection(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEkmConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEkmConnection() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response) { return this->CreateEkmConnection(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEkmConnection(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::CreateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEkmConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEkmConnection() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* request, ::google::cloud::kms::v1::EkmConnection* response) { return this->UpdateEkmConnection(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEkmConnection(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::UpdateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEkmConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEkmConfig() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response) { return this->GetEkmConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetEkmConfig(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEkmConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEkmConfig() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* request, ::google::cloud::kms::v1::EkmConfig* response) { return this->UpdateEkmConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEkmConfig(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::UpdateEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEkmConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_VerifyConnectivity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_VerifyConnectivity() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::VerifyConnectivityRequest, ::google::cloud::kms::v1::VerifyConnectivityResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::VerifyConnectivityRequest* request, ::google::cloud::kms::v1::VerifyConnectivityResponse* response) { return this->VerifyConnectivity(context, request, response); }));}
    void SetMessageAllocatorFor_VerifyConnectivity(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::VerifyConnectivityRequest, ::google::cloud::kms::v1::VerifyConnectivityResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::VerifyConnectivityRequest, ::google::cloud::kms::v1::VerifyConnectivityResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_VerifyConnectivity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyConnectivity(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* VerifyConnectivity(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListEkmConnections<WithCallbackMethod_GetEkmConnection<WithCallbackMethod_CreateEkmConnection<WithCallbackMethod_UpdateEkmConnection<WithCallbackMethod_GetEkmConfig<WithCallbackMethod_UpdateEkmConfig<WithCallbackMethod_VerifyConnectivity<Service > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListEkmConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEkmConnections() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListEkmConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEkmConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEkmConnection() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEkmConnection() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEkmConnection() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEkmConfig() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEkmConfig() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdateEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_VerifyConnectivity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_VerifyConnectivity() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_VerifyConnectivity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyConnectivity(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEkmConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEkmConnections() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListEkmConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEkmConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEkmConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEkmConnection() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEkmConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEkmConnection() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEkmConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEkmConnection() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEkmConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEkmConfig() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEkmConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEkmConfig() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdateEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEkmConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_VerifyConnectivity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_VerifyConnectivity() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_VerifyConnectivity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyConnectivity(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestVerifyConnectivity(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEkmConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEkmConnections() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEkmConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEkmConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEkmConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEkmConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEkmConnection() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEkmConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEkmConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEkmConnection() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEkmConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEkmConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEkmConnection() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEkmConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEkmConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEkmConfig() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEkmConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEkmConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEkmConfig() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEkmConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEkmConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_VerifyConnectivity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_VerifyConnectivity() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->VerifyConnectivity(context, request, response); }));
    }
    ~WithRawCallbackMethod_VerifyConnectivity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status VerifyConnectivity(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* VerifyConnectivity(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEkmConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEkmConnections() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ListEkmConnectionsRequest, ::google::cloud::kms::v1::ListEkmConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ListEkmConnectionsRequest, ::google::cloud::kms::v1::ListEkmConnectionsResponse>* streamer) {
                       return this->StreamedListEkmConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEkmConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEkmConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListEkmConnectionsRequest* /*request*/, ::google::cloud::kms::v1::ListEkmConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEkmConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ListEkmConnectionsRequest,::google::cloud::kms::v1::ListEkmConnectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEkmConnection() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>* streamer) {
                       return this->StreamedGetEkmConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEkmConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetEkmConnectionRequest,::google::cloud::kms::v1::EkmConnection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEkmConnection() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::CreateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::CreateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>* streamer) {
                       return this->StreamedCreateEkmConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEkmConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::CreateEkmConnectionRequest,::google::cloud::kms::v1::EkmConnection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEkmConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEkmConnection() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::UpdateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::UpdateEkmConnectionRequest, ::google::cloud::kms::v1::EkmConnection>* streamer) {
                       return this->StreamedUpdateEkmConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEkmConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEkmConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConnectionRequest* /*request*/, ::google::cloud::kms::v1::EkmConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEkmConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::UpdateEkmConnectionRequest,::google::cloud::kms::v1::EkmConnection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEkmConfig() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>* streamer) {
                       return this->StreamedGetEkmConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEkmConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetEkmConfigRequest,::google::cloud::kms::v1::EkmConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEkmConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEkmConfig() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::UpdateEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::UpdateEkmConfigRequest, ::google::cloud::kms::v1::EkmConfig>* streamer) {
                       return this->StreamedUpdateEkmConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEkmConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEkmConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateEkmConfigRequest* /*request*/, ::google::cloud::kms::v1::EkmConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEkmConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::UpdateEkmConfigRequest,::google::cloud::kms::v1::EkmConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_VerifyConnectivity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_VerifyConnectivity() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::VerifyConnectivityRequest, ::google::cloud::kms::v1::VerifyConnectivityResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::VerifyConnectivityRequest, ::google::cloud::kms::v1::VerifyConnectivityResponse>* streamer) {
                       return this->StreamedVerifyConnectivity(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_VerifyConnectivity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status VerifyConnectivity(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::VerifyConnectivityRequest* /*request*/, ::google::cloud::kms::v1::VerifyConnectivityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedVerifyConnectivity(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::VerifyConnectivityRequest,::google::cloud::kms::v1::VerifyConnectivityResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListEkmConnections<WithStreamedUnaryMethod_GetEkmConnection<WithStreamedUnaryMethod_CreateEkmConnection<WithStreamedUnaryMethod_UpdateEkmConnection<WithStreamedUnaryMethod_GetEkmConfig<WithStreamedUnaryMethod_UpdateEkmConfig<WithStreamedUnaryMethod_VerifyConnectivity<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListEkmConnections<WithStreamedUnaryMethod_GetEkmConnection<WithStreamedUnaryMethod_CreateEkmConnection<WithStreamedUnaryMethod_UpdateEkmConnection<WithStreamedUnaryMethod_GetEkmConfig<WithStreamedUnaryMethod_UpdateEkmConfig<WithStreamedUnaryMethod_VerifyConnectivity<Service > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace kms
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fkms_2fv1_2fekm_5fservice_2eproto__INCLUDED
