// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/orgpolicy/v2/orgpolicy.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ORGPOLICY_V2_MOCKS_MOCK_ORG_POLICY_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ORGPOLICY_V2_MOCKS_MOCK_ORG_POLICY_CONNECTION_H

#include "google/cloud/orgpolicy/v2/org_policy_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace orgpolicy_v2_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `OrgPolicyConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `OrgPolicyClient`. To do so,
 * construct an object of type `OrgPolicyClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockOrgPolicyConnection : public orgpolicy_v2::OrgPolicyConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD((StreamRange<google::cloud::orgpolicy::v2::Constraint>),
              ListConstraints,
              (google::cloud::orgpolicy::v2::ListConstraintsRequest request),
              (override));

  MOCK_METHOD((StreamRange<google::cloud::orgpolicy::v2::Policy>), ListPolicies,
              (google::cloud::orgpolicy::v2::ListPoliciesRequest request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::orgpolicy::v2::Policy>, GetPolicy,
              (google::cloud::orgpolicy::v2::GetPolicyRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::orgpolicy::v2::Policy>, GetEffectivePolicy,
      (google::cloud::orgpolicy::v2::GetEffectivePolicyRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::orgpolicy::v2::Policy>, CreatePolicy,
      (google::cloud::orgpolicy::v2::CreatePolicyRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::orgpolicy::v2::Policy>, UpdatePolicy,
      (google::cloud::orgpolicy::v2::UpdatePolicyRequest const& request),
      (override));

  MOCK_METHOD(
      Status, DeletePolicy,
      (google::cloud::orgpolicy::v2::DeletePolicyRequest const& request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace orgpolicy_v2_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_ORGPOLICY_V2_MOCKS_MOCK_ORG_POLICY_CONNECTION_H
