// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/osconfig/v1/osconfig_zonal_service.proto
// Original file comments:
// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fosconfig_2fv1_2fosconfig_5fzonal_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fosconfig_2fv1_2fosconfig_5fzonal_5fservice_2eproto__INCLUDED

#include "google/cloud/osconfig/v1/osconfig_zonal_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace osconfig {
namespace v1 {

// Zonal OS Config API
//
// The OS Config service is the server-side component that allows users to
// manage package installations and patch jobs for Compute Engine VM instances.
class OsConfigZonalService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.osconfig.v1.OsConfigZonalService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Create an OS policy assignment.
    //
    // This method also creates the first revision of the OS policy assignment.
    //
    // This method returns a long running operation (LRO) that contains the
    // rollout details. The rollout can be cancelled by cancelling the LRO.
    //
    // For more information, see [Method:
    // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
    virtual ::grpc::Status CreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateOSPolicyAssignmentRaw(context, request, cq));
    }
    // Update an existing OS policy assignment.
    //
    // This method creates a new revision of the OS policy assignment.
    //
    // This method returns a long running operation (LRO) that contains the
    // rollout details. The rollout can be cancelled by cancelling the LRO.
    //
    // For more information, see [Method:
    // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
    virtual ::grpc::Status UpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateOSPolicyAssignmentRaw(context, request, cq));
    }
    // Retrieve an existing OS policy assignment.
    //
    // This method always returns the latest revision. In order to retrieve a
    // previous revision of the assignment, also provide the revision ID in the
    // `name` parameter.
    virtual ::grpc::Status GetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignment>> AsyncGetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignment>>(AsyncGetOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignment>> PrepareAsyncGetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignment>>(PrepareAsyncGetOSPolicyAssignmentRaw(context, request, cq));
    }
    // List the OS policy assignments under the parent resource.
    //
    // For each OS policy assignment, the latest revision is returned.
    virtual ::grpc::Status ListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>> AsyncListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>>(AsyncListOSPolicyAssignmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>> PrepareAsyncListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>>(PrepareAsyncListOSPolicyAssignmentsRaw(context, request, cq));
    }
    // List the OS policy assignment revisions for a given OS policy assignment.
    virtual ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>> AsyncListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>>(AsyncListOSPolicyAssignmentRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>> PrepareAsyncListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>>(PrepareAsyncListOSPolicyAssignmentRevisionsRaw(context, request, cq));
    }
    // Delete the OS policy assignment.
    //
    // This method creates a new revision of the OS policy assignment.
    //
    // This method returns a long running operation (LRO) that contains the
    // rollout details. The rollout can be cancelled by cancelling the LRO.
    //
    // If the LRO completes and is not cancelled, all revisions associated with
    // the OS policy assignment are deleted.
    //
    // For more information, see [Method:
    // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
    virtual ::grpc::Status DeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteOSPolicyAssignmentRaw(context, request, cq));
    }
    // Get the OS policy asssignment report for the specified Compute Engine VM
    // instance.
    virtual ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>> AsyncGetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>>(AsyncGetOSPolicyAssignmentReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>> PrepareAsyncGetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>>(PrepareAsyncGetOSPolicyAssignmentReportRaw(context, request, cq));
    }
    // List OS policy asssignment reports for all Compute Engine VM instances in
    // the specified zone.
    virtual ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>> AsyncListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>>(AsyncListOSPolicyAssignmentReportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>> PrepareAsyncListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>>(PrepareAsyncListOSPolicyAssignmentReportsRaw(context, request, cq));
    }
    // Get inventory data for the specified VM instance. If the VM has no
    // associated inventory, the message `NOT_FOUND` is returned.
    virtual ::grpc::Status GetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::google::cloud::osconfig::v1::Inventory* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::Inventory>> AsyncGetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::Inventory>>(AsyncGetInventoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::Inventory>> PrepareAsyncGetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::Inventory>>(PrepareAsyncGetInventoryRaw(context, request, cq));
    }
    // List inventory data for all VM instances in the specified zone.
    virtual ::grpc::Status ListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListInventoriesResponse>> AsyncListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListInventoriesResponse>>(AsyncListInventoriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListInventoriesResponse>> PrepareAsyncListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListInventoriesResponse>>(PrepareAsyncListInventoriesRaw(context, request, cq));
    }
    // Gets the vulnerability report for the specified VM instance. Only VMs with
    // inventory data have vulnerability reports associated with them.
    virtual ::grpc::Status GetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::google::cloud::osconfig::v1::VulnerabilityReport* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::VulnerabilityReport>> AsyncGetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::VulnerabilityReport>>(AsyncGetVulnerabilityReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::VulnerabilityReport>> PrepareAsyncGetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::VulnerabilityReport>>(PrepareAsyncGetVulnerabilityReportRaw(context, request, cq));
    }
    // List vulnerability reports for all VM instances in the specified zone.
    virtual ::grpc::Status ListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>> AsyncListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>>(AsyncListVulnerabilityReportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>> PrepareAsyncListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>>(PrepareAsyncListVulnerabilityReportsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Create an OS policy assignment.
      //
      // This method also creates the first revision of the OS policy assignment.
      //
      // This method returns a long running operation (LRO) that contains the
      // rollout details. The rollout can be cancelled by cancelling the LRO.
      //
      // For more information, see [Method:
      // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
      virtual void CreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update an existing OS policy assignment.
      //
      // This method creates a new revision of the OS policy assignment.
      //
      // This method returns a long running operation (LRO) that contains the
      // rollout details. The rollout can be cancelled by cancelling the LRO.
      //
      // For more information, see [Method:
      // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
      virtual void UpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieve an existing OS policy assignment.
      //
      // This method always returns the latest revision. In order to retrieve a
      // previous revision of the assignment, also provide the revision ID in the
      // `name` parameter.
      virtual void GetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List the OS policy assignments under the parent resource.
      //
      // For each OS policy assignment, the latest revision is returned.
      virtual void ListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List the OS policy assignment revisions for a given OS policy assignment.
      virtual void ListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete the OS policy assignment.
      //
      // This method creates a new revision of the OS policy assignment.
      //
      // This method returns a long running operation (LRO) that contains the
      // rollout details. The rollout can be cancelled by cancelling the LRO.
      //
      // If the LRO completes and is not cancelled, all revisions associated with
      // the OS policy assignment are deleted.
      //
      // For more information, see [Method:
      // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
      virtual void DeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get the OS policy asssignment report for the specified Compute Engine VM
      // instance.
      virtual void GetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List OS policy asssignment reports for all Compute Engine VM instances in
      // the specified zone.
      virtual void ListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get inventory data for the specified VM instance. If the VM has no
      // associated inventory, the message `NOT_FOUND` is returned.
      virtual void GetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::google::cloud::osconfig::v1::Inventory* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::google::cloud::osconfig::v1::Inventory* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List inventory data for all VM instances in the specified zone.
      virtual void ListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the vulnerability report for the specified VM instance. Only VMs with
      // inventory data have vulnerability reports associated with them.
      virtual void GetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::google::cloud::osconfig::v1::VulnerabilityReport* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::google::cloud::osconfig::v1::VulnerabilityReport* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List vulnerability reports for all VM instances in the specified zone.
      virtual void ListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignment>* AsyncGetOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignment>* PrepareAsyncGetOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* AsyncListOSPolicyAssignmentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* PrepareAsyncListOSPolicyAssignmentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* AsyncListOSPolicyAssignmentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* PrepareAsyncListOSPolicyAssignmentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* AsyncGetOSPolicyAssignmentReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* PrepareAsyncGetOSPolicyAssignmentReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* AsyncListOSPolicyAssignmentReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* PrepareAsyncListOSPolicyAssignmentReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::Inventory>* AsyncGetInventoryRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::Inventory>* PrepareAsyncGetInventoryRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListInventoriesResponse>* AsyncListInventoriesRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListInventoriesResponse>* PrepareAsyncListInventoriesRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::VulnerabilityReport>* AsyncGetVulnerabilityReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::VulnerabilityReport>* PrepareAsyncGetVulnerabilityReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* AsyncListVulnerabilityReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* PrepareAsyncListVulnerabilityReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateOSPolicyAssignmentRaw(context, request, cq));
    }
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateOSPolicyAssignmentRaw(context, request, cq));
    }
    ::grpc::Status GetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignment>> AsyncGetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignment>>(AsyncGetOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignment>> PrepareAsyncGetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignment>>(PrepareAsyncGetOSPolicyAssignmentRaw(context, request, cq));
    }
    ::grpc::Status ListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>> AsyncListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>>(AsyncListOSPolicyAssignmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>> PrepareAsyncListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>>(PrepareAsyncListOSPolicyAssignmentsRaw(context, request, cq));
    }
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>> AsyncListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>>(AsyncListOSPolicyAssignmentRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>> PrepareAsyncListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>>(PrepareAsyncListOSPolicyAssignmentRevisionsRaw(context, request, cq));
    }
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteOSPolicyAssignmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteOSPolicyAssignmentRaw(context, request, cq));
    }
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>> AsyncGetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>>(AsyncGetOSPolicyAssignmentReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>> PrepareAsyncGetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>>(PrepareAsyncGetOSPolicyAssignmentReportRaw(context, request, cq));
    }
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>> AsyncListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>>(AsyncListOSPolicyAssignmentReportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>> PrepareAsyncListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>>(PrepareAsyncListOSPolicyAssignmentReportsRaw(context, request, cq));
    }
    ::grpc::Status GetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::google::cloud::osconfig::v1::Inventory* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::Inventory>> AsyncGetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::Inventory>>(AsyncGetInventoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::Inventory>> PrepareAsyncGetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::Inventory>>(PrepareAsyncGetInventoryRaw(context, request, cq));
    }
    ::grpc::Status ListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListInventoriesResponse>> AsyncListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListInventoriesResponse>>(AsyncListInventoriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListInventoriesResponse>> PrepareAsyncListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListInventoriesResponse>>(PrepareAsyncListInventoriesRaw(context, request, cq));
    }
    ::grpc::Status GetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::google::cloud::osconfig::v1::VulnerabilityReport* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::VulnerabilityReport>> AsyncGetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::VulnerabilityReport>>(AsyncGetVulnerabilityReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::VulnerabilityReport>> PrepareAsyncGetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::VulnerabilityReport>>(PrepareAsyncGetVulnerabilityReportRaw(context, request, cq));
    }
    ::grpc::Status ListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>> AsyncListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>>(AsyncListVulnerabilityReportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>> PrepareAsyncListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>>(PrepareAsyncListVulnerabilityReportsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response, std::function<void(::grpc::Status)>) override;
      void GetOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOSPolicyAssignments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOSPolicyAssignmentRevisions(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteOSPolicyAssignment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response, std::function<void(::grpc::Status)>) override;
      void GetOSPolicyAssignmentReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOSPolicyAssignmentReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::google::cloud::osconfig::v1::Inventory* response, std::function<void(::grpc::Status)>) override;
      void GetInventory(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::google::cloud::osconfig::v1::Inventory* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInventories(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::google::cloud::osconfig::v1::VulnerabilityReport* response, std::function<void(::grpc::Status)>) override;
      void GetVulnerabilityReport(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::google::cloud::osconfig::v1::VulnerabilityReport* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVulnerabilityReports(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignment>* AsyncGetOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignment>* PrepareAsyncGetOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* AsyncListOSPolicyAssignmentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* PrepareAsyncListOSPolicyAssignmentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* AsyncListOSPolicyAssignmentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* PrepareAsyncListOSPolicyAssignmentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteOSPolicyAssignmentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* AsyncGetOSPolicyAssignmentReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* PrepareAsyncGetOSPolicyAssignmentReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* AsyncListOSPolicyAssignmentReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* PrepareAsyncListOSPolicyAssignmentReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::Inventory>* AsyncGetInventoryRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::Inventory>* PrepareAsyncGetInventoryRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListInventoriesResponse>* AsyncListInventoriesRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListInventoriesResponse>* PrepareAsyncListInventoriesRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::VulnerabilityReport>* AsyncGetVulnerabilityReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::VulnerabilityReport>* PrepareAsyncGetVulnerabilityReportRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* AsyncListVulnerabilityReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* PrepareAsyncListVulnerabilityReportsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateOSPolicyAssignment_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateOSPolicyAssignment_;
    const ::grpc::internal::RpcMethod rpcmethod_GetOSPolicyAssignment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOSPolicyAssignments_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOSPolicyAssignmentRevisions_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteOSPolicyAssignment_;
    const ::grpc::internal::RpcMethod rpcmethod_GetOSPolicyAssignmentReport_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOSPolicyAssignmentReports_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInventory_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInventories_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVulnerabilityReport_;
    const ::grpc::internal::RpcMethod rpcmethod_ListVulnerabilityReports_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Create an OS policy assignment.
    //
    // This method also creates the first revision of the OS policy assignment.
    //
    // This method returns a long running operation (LRO) that contains the
    // rollout details. The rollout can be cancelled by cancelling the LRO.
    //
    // For more information, see [Method:
    // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
    virtual ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response);
    // Update an existing OS policy assignment.
    //
    // This method creates a new revision of the OS policy assignment.
    //
    // This method returns a long running operation (LRO) that contains the
    // rollout details. The rollout can be cancelled by cancelling the LRO.
    //
    // For more information, see [Method:
    // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
    virtual ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response);
    // Retrieve an existing OS policy assignment.
    //
    // This method always returns the latest revision. In order to retrieve a
    // previous revision of the assignment, also provide the revision ID in the
    // `name` parameter.
    virtual ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response);
    // List the OS policy assignments under the parent resource.
    //
    // For each OS policy assignment, the latest revision is returned.
    virtual ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response);
    // List the OS policy assignment revisions for a given OS policy assignment.
    virtual ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response);
    // Delete the OS policy assignment.
    //
    // This method creates a new revision of the OS policy assignment.
    //
    // This method returns a long running operation (LRO) that contains the
    // rollout details. The rollout can be cancelled by cancelling the LRO.
    //
    // If the LRO completes and is not cancelled, all revisions associated with
    // the OS policy assignment are deleted.
    //
    // For more information, see [Method:
    // projects.locations.osPolicyAssignments.operations.cancel](https://cloud.google.com/compute/docs/osconfig/rest/v1/projects.locations.osPolicyAssignments.operations/cancel).
    virtual ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response);
    // Get the OS policy asssignment report for the specified Compute Engine VM
    // instance.
    virtual ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response);
    // List OS policy asssignment reports for all Compute Engine VM instances in
    // the specified zone.
    virtual ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response);
    // Get inventory data for the specified VM instance. If the VM has no
    // associated inventory, the message `NOT_FOUND` is returned.
    virtual ::grpc::Status GetInventory(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::google::cloud::osconfig::v1::Inventory* response);
    // List inventory data for all VM instances in the specified zone.
    virtual ::grpc::Status ListInventories(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response);
    // Gets the vulnerability report for the specified VM instance. Only VMs with
    // inventory data have vulnerability reports associated with them.
    virtual ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::google::cloud::osconfig::v1::VulnerabilityReport* response);
    // List vulnerability reports for all VM instances in the specified zone.
    virtual ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOSPolicyAssignment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateOSPolicyAssignment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetOSPolicyAssignment() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOSPolicyAssignment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::OSPolicyAssignment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOSPolicyAssignments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOSPolicyAssignments() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListOSPolicyAssignments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOSPolicyAssignments(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOSPolicyAssignmentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOSPolicyAssignmentRevisions() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListOSPolicyAssignmentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOSPolicyAssignmentRevisions(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteOSPolicyAssignment() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteOSPolicyAssignment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetOSPolicyAssignmentReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetOSPolicyAssignmentReport() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetOSPolicyAssignmentReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOSPolicyAssignmentReport(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOSPolicyAssignmentReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOSPolicyAssignmentReports() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListOSPolicyAssignmentReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOSPolicyAssignmentReports(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInventory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInventory() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetInventory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInventory(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInventory(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::Inventory>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInventories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInventories() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListInventories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInventories(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInventories(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListInventoriesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVulnerabilityReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVulnerabilityReport() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetVulnerabilityReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVulnerabilityReport(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::VulnerabilityReport>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVulnerabilityReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVulnerabilityReports() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListVulnerabilityReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVulnerabilityReports(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateOSPolicyAssignment<WithAsyncMethod_UpdateOSPolicyAssignment<WithAsyncMethod_GetOSPolicyAssignment<WithAsyncMethod_ListOSPolicyAssignments<WithAsyncMethod_ListOSPolicyAssignmentRevisions<WithAsyncMethod_DeleteOSPolicyAssignment<WithAsyncMethod_GetOSPolicyAssignmentReport<WithAsyncMethod_ListOSPolicyAssignmentReports<WithAsyncMethod_GetInventory<WithAsyncMethod_ListInventories<WithAsyncMethod_GetVulnerabilityReport<WithAsyncMethod_ListVulnerabilityReports<Service > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response) { return this->CreateOSPolicyAssignment(context, request, response); }));}
    void SetMessageAllocatorFor_CreateOSPolicyAssignment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response) { return this->UpdateOSPolicyAssignment(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateOSPolicyAssignment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetOSPolicyAssignment() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest, ::google::cloud::osconfig::v1::OSPolicyAssignment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignment* response) { return this->GetOSPolicyAssignment(context, request, response); }));}
    void SetMessageAllocatorFor_GetOSPolicyAssignment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest, ::google::cloud::osconfig::v1::OSPolicyAssignment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest, ::google::cloud::osconfig::v1::OSPolicyAssignment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOSPolicyAssignments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOSPolicyAssignments() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* response) { return this->ListOSPolicyAssignments(context, request, response); }));}
    void SetMessageAllocatorFor_ListOSPolicyAssignments(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOSPolicyAssignments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOSPolicyAssignments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOSPolicyAssignmentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOSPolicyAssignmentRevisions() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* response) { return this->ListOSPolicyAssignmentRevisions(context, request, response); }));}
    void SetMessageAllocatorFor_ListOSPolicyAssignmentRevisions(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOSPolicyAssignmentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOSPolicyAssignmentRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteOSPolicyAssignment() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* request, ::google::longrunning::Operation* response) { return this->DeleteOSPolicyAssignment(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteOSPolicyAssignment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetOSPolicyAssignmentReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetOSPolicyAssignmentReport() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* request, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* response) { return this->GetOSPolicyAssignmentReport(context, request, response); }));}
    void SetMessageAllocatorFor_GetOSPolicyAssignmentReport(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetOSPolicyAssignmentReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOSPolicyAssignmentReport(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOSPolicyAssignmentReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOSPolicyAssignmentReports() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* request, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* response) { return this->ListOSPolicyAssignmentReports(context, request, response); }));}
    void SetMessageAllocatorFor_ListOSPolicyAssignmentReports(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOSPolicyAssignmentReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOSPolicyAssignmentReports(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInventory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInventory() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetInventoryRequest, ::google::cloud::osconfig::v1::Inventory>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::GetInventoryRequest* request, ::google::cloud::osconfig::v1::Inventory* response) { return this->GetInventory(context, request, response); }));}
    void SetMessageAllocatorFor_GetInventory(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::GetInventoryRequest, ::google::cloud::osconfig::v1::Inventory>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetInventoryRequest, ::google::cloud::osconfig::v1::Inventory>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInventory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInventory(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInventory(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInventories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInventories() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListInventoriesRequest, ::google::cloud::osconfig::v1::ListInventoriesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListInventoriesRequest* request, ::google::cloud::osconfig::v1::ListInventoriesResponse* response) { return this->ListInventories(context, request, response); }));}
    void SetMessageAllocatorFor_ListInventories(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListInventoriesRequest, ::google::cloud::osconfig::v1::ListInventoriesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListInventoriesRequest, ::google::cloud::osconfig::v1::ListInventoriesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInventories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInventories(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInventories(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVulnerabilityReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVulnerabilityReport() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest, ::google::cloud::osconfig::v1::VulnerabilityReport>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* request, ::google::cloud::osconfig::v1::VulnerabilityReport* response) { return this->GetVulnerabilityReport(context, request, response); }));}
    void SetMessageAllocatorFor_GetVulnerabilityReport(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest, ::google::cloud::osconfig::v1::VulnerabilityReport>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest, ::google::cloud::osconfig::v1::VulnerabilityReport>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVulnerabilityReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVulnerabilityReport(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListVulnerabilityReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVulnerabilityReports() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* request, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* response) { return this->ListVulnerabilityReports(context, request, response); }));}
    void SetMessageAllocatorFor_ListVulnerabilityReports(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVulnerabilityReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVulnerabilityReports(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateOSPolicyAssignment<WithCallbackMethod_UpdateOSPolicyAssignment<WithCallbackMethod_GetOSPolicyAssignment<WithCallbackMethod_ListOSPolicyAssignments<WithCallbackMethod_ListOSPolicyAssignmentRevisions<WithCallbackMethod_DeleteOSPolicyAssignment<WithCallbackMethod_GetOSPolicyAssignmentReport<WithCallbackMethod_ListOSPolicyAssignmentReports<WithCallbackMethod_GetInventory<WithCallbackMethod_ListInventories<WithCallbackMethod_GetVulnerabilityReport<WithCallbackMethod_ListVulnerabilityReports<Service > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetOSPolicyAssignment() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOSPolicyAssignments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOSPolicyAssignments() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListOSPolicyAssignments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOSPolicyAssignmentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOSPolicyAssignmentRevisions() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListOSPolicyAssignmentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteOSPolicyAssignment() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetOSPolicyAssignmentReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetOSPolicyAssignmentReport() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetOSPolicyAssignmentReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOSPolicyAssignmentReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOSPolicyAssignmentReports() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListOSPolicyAssignmentReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInventory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInventory() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetInventory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInventory(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInventories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInventories() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListInventories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInventories(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVulnerabilityReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVulnerabilityReport() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetVulnerabilityReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListVulnerabilityReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVulnerabilityReports() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListVulnerabilityReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOSPolicyAssignments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOSPolicyAssignments() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListOSPolicyAssignments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOSPolicyAssignments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOSPolicyAssignmentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOSPolicyAssignmentRevisions() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListOSPolicyAssignmentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOSPolicyAssignmentRevisions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetOSPolicyAssignmentReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetOSPolicyAssignmentReport() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetOSPolicyAssignmentReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOSPolicyAssignmentReport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOSPolicyAssignmentReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOSPolicyAssignmentReports() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListOSPolicyAssignmentReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOSPolicyAssignmentReports(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInventory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInventory() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetInventory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInventory(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInventory(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInventories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInventories() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListInventories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInventories(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInventories(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVulnerabilityReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVulnerabilityReport() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetVulnerabilityReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVulnerabilityReport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVulnerabilityReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVulnerabilityReports() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListVulnerabilityReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVulnerabilityReports(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateOSPolicyAssignment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateOSPolicyAssignment(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetOSPolicyAssignment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOSPolicyAssignments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOSPolicyAssignments() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOSPolicyAssignments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOSPolicyAssignments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOSPolicyAssignments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOSPolicyAssignmentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOSPolicyAssignmentRevisions() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOSPolicyAssignmentRevisions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOSPolicyAssignmentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOSPolicyAssignmentRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteOSPolicyAssignment() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteOSPolicyAssignment(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteOSPolicyAssignment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetOSPolicyAssignmentReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetOSPolicyAssignmentReport() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetOSPolicyAssignmentReport(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetOSPolicyAssignmentReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOSPolicyAssignmentReport(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOSPolicyAssignmentReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOSPolicyAssignmentReports() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOSPolicyAssignmentReports(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOSPolicyAssignmentReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOSPolicyAssignmentReports(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInventory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInventory() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInventory(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInventory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInventory(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInventory(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInventories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInventories() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInventories(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInventories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInventories(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInventories(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVulnerabilityReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVulnerabilityReport() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVulnerabilityReport(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVulnerabilityReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVulnerabilityReport(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVulnerabilityReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVulnerabilityReports() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVulnerabilityReports(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVulnerabilityReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVulnerabilityReports(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateOSPolicyAssignment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::CreateOSPolicyAssignmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateOSPolicyAssignment() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateOSPolicyAssignment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::UpdateOSPolicyAssignmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetOSPolicyAssignment() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest, ::google::cloud::osconfig::v1::OSPolicyAssignment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest, ::google::cloud::osconfig::v1::OSPolicyAssignment>* streamer) {
                       return this->StreamedGetOSPolicyAssignment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentRequest,::google::cloud::osconfig::v1::OSPolicyAssignment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOSPolicyAssignments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOSPolicyAssignments() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* streamer) {
                       return this->StreamedListOSPolicyAssignments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOSPolicyAssignments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOSPolicyAssignments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOSPolicyAssignments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentsRequest,::google::cloud::osconfig::v1::ListOSPolicyAssignmentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOSPolicyAssignmentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOSPolicyAssignmentRevisions() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* streamer) {
                       return this->StreamedListOSPolicyAssignmentRevisions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOSPolicyAssignmentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOSPolicyAssignmentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOSPolicyAssignmentRevisions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsRequest,::google::cloud::osconfig::v1::ListOSPolicyAssignmentRevisionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteOSPolicyAssignment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteOSPolicyAssignment() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteOSPolicyAssignment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteOSPolicyAssignment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteOSPolicyAssignment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteOSPolicyAssignment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::DeleteOSPolicyAssignmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetOSPolicyAssignmentReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetOSPolicyAssignmentReport() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* streamer) {
                       return this->StreamedGetOSPolicyAssignmentReport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetOSPolicyAssignmentReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetOSPolicyAssignmentReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest* /*request*/, ::google::cloud::osconfig::v1::OSPolicyAssignmentReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetOSPolicyAssignmentReport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::GetOSPolicyAssignmentReportRequest,::google::cloud::osconfig::v1::OSPolicyAssignmentReport>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOSPolicyAssignmentReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOSPolicyAssignmentReports() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* streamer) {
                       return this->StreamedListOSPolicyAssignmentReports(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOSPolicyAssignmentReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOSPolicyAssignmentReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOSPolicyAssignmentReports(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsRequest,::google::cloud::osconfig::v1::ListOSPolicyAssignmentReportsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInventory : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInventory() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::GetInventoryRequest, ::google::cloud::osconfig::v1::Inventory>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::GetInventoryRequest, ::google::cloud::osconfig::v1::Inventory>* streamer) {
                       return this->StreamedGetInventory(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInventory() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInventory(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetInventoryRequest* /*request*/, ::google::cloud::osconfig::v1::Inventory* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInventory(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::GetInventoryRequest,::google::cloud::osconfig::v1::Inventory>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInventories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInventories() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListInventoriesRequest, ::google::cloud::osconfig::v1::ListInventoriesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListInventoriesRequest, ::google::cloud::osconfig::v1::ListInventoriesResponse>* streamer) {
                       return this->StreamedListInventories(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInventories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInventories(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListInventoriesRequest* /*request*/, ::google::cloud::osconfig::v1::ListInventoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInventories(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListInventoriesRequest,::google::cloud::osconfig::v1::ListInventoriesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVulnerabilityReport : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVulnerabilityReport() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest, ::google::cloud::osconfig::v1::VulnerabilityReport>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest, ::google::cloud::osconfig::v1::VulnerabilityReport>* streamer) {
                       return this->StreamedGetVulnerabilityReport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVulnerabilityReport() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVulnerabilityReport(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest* /*request*/, ::google::cloud::osconfig::v1::VulnerabilityReport* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVulnerabilityReport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::GetVulnerabilityReportRequest,::google::cloud::osconfig::v1::VulnerabilityReport>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVulnerabilityReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVulnerabilityReports() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* streamer) {
                       return this->StreamedListVulnerabilityReports(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVulnerabilityReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVulnerabilityReports(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest* /*request*/, ::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVulnerabilityReports(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListVulnerabilityReportsRequest,::google::cloud::osconfig::v1::ListVulnerabilityReportsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateOSPolicyAssignment<WithStreamedUnaryMethod_UpdateOSPolicyAssignment<WithStreamedUnaryMethod_GetOSPolicyAssignment<WithStreamedUnaryMethod_ListOSPolicyAssignments<WithStreamedUnaryMethod_ListOSPolicyAssignmentRevisions<WithStreamedUnaryMethod_DeleteOSPolicyAssignment<WithStreamedUnaryMethod_GetOSPolicyAssignmentReport<WithStreamedUnaryMethod_ListOSPolicyAssignmentReports<WithStreamedUnaryMethod_GetInventory<WithStreamedUnaryMethod_ListInventories<WithStreamedUnaryMethod_GetVulnerabilityReport<WithStreamedUnaryMethod_ListVulnerabilityReports<Service > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateOSPolicyAssignment<WithStreamedUnaryMethod_UpdateOSPolicyAssignment<WithStreamedUnaryMethod_GetOSPolicyAssignment<WithStreamedUnaryMethod_ListOSPolicyAssignments<WithStreamedUnaryMethod_ListOSPolicyAssignmentRevisions<WithStreamedUnaryMethod_DeleteOSPolicyAssignment<WithStreamedUnaryMethod_GetOSPolicyAssignmentReport<WithStreamedUnaryMethod_ListOSPolicyAssignmentReports<WithStreamedUnaryMethod_GetInventory<WithStreamedUnaryMethod_ListInventories<WithStreamedUnaryMethod_GetVulnerabilityReport<WithStreamedUnaryMethod_ListVulnerabilityReports<Service > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace osconfig
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fosconfig_2fv1_2fosconfig_5fzonal_5fservice_2eproto__INCLUDED
