// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/resourcemanager/v3/folders.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fresourcemanager_2fv3_2ffolders_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fresourcemanager_2fv3_2ffolders_2eproto__INCLUDED

#include "google/cloud/resourcemanager/v3/folders.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace resourcemanager {
namespace v3 {

// Manages Cloud Platform folder resources.
// Folders can be used to organize the resources under an
// organization and to control the policies applied to groups of resources.
class Folders final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.resourcemanager.v3.Folders";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Retrieves a folder identified by the supplied resource name.
    // Valid folder resource names have the format `folders/{folder_id}`
    // (for example, `folders/1234`).
    // The caller must have `resourcemanager.folders.get` permission on the
    // identified folder.
    virtual ::grpc::Status GetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::google::cloud::resourcemanager::v3::Folder* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Folder>> AsyncGetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Folder>>(AsyncGetFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Folder>> PrepareAsyncGetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Folder>>(PrepareAsyncGetFolderRaw(context, request, cq));
    }
    // Lists the folders that are direct descendants of supplied parent resource.
    // `list()` provides a strongly consistent view of the folders underneath
    // the specified parent resource.
    // `list()` returns folders sorted based upon the (ascending) lexical ordering
    // of their display_name.
    // The caller must have `resourcemanager.folders.list` permission on the
    // identified parent.
    virtual ::grpc::Status ListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListFoldersResponse>> AsyncListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListFoldersResponse>>(AsyncListFoldersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListFoldersResponse>> PrepareAsyncListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListFoldersResponse>>(PrepareAsyncListFoldersRaw(context, request, cq));
    }
    // Search for folders that match specific filter criteria.
    // `search()` provides an eventually consistent view of the folders a user has
    // access to which meet the specified filter criteria.
    //
    // This will only return folders on which the caller has the
    // permission `resourcemanager.folders.get`.
    virtual ::grpc::Status SearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>> AsyncSearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>>(AsyncSearchFoldersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>> PrepareAsyncSearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>>(PrepareAsyncSearchFoldersRaw(context, request, cq));
    }
    // Creates a folder in the resource hierarchy.
    // Returns an `Operation` which can be used to track the progress of the
    // folder creation workflow.
    // Upon success, the `Operation.response` field will be populated with the
    // created Folder.
    //
    // In order to succeed, the addition of this new folder must not violate
    // the folder naming, height, or fanout constraints.
    //
    // + The folder's `display_name` must be distinct from all other folders that
    // share its parent.
    // + The addition of the folder must not cause the active folder hierarchy
    // to exceed a height of 10. Note, the full active + deleted folder hierarchy
    // is allowed to reach a height of 20; this provides additional headroom when
    // moving folders that contain deleted folders.
    // + The addition of the folder must not cause the total number of folders
    // under its parent to exceed 300.
    //
    // If the operation fails due to a folder constraint violation, some errors
    // may be returned by the `CreateFolder` request, with status code
    // `FAILED_PRECONDITION` and an error description. Other folder constraint
    // violations will be communicated in the `Operation`, with the specific
    // `PreconditionFailure` returned in the details list in the `Operation.error`
    // field.
    //
    // The caller must have `resourcemanager.folders.create` permission on the
    // identified parent.
    virtual ::grpc::Status CreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateFolderRaw(context, request, cq));
    }
    // Updates a folder, changing its `display_name`.
    // Changes to the folder `display_name` will be rejected if they violate
    // either the `display_name` formatting rules or the naming constraints
    // described in the
    // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
    // documentation.
    //
    // The folder's `display_name` must start and end with a letter or digit,
    // may contain letters, digits, spaces, hyphens and underscores and can be
    // between 3 and 30 characters. This is captured by the regular expression:
    // `[\p{L}\p{N}][\p{L}\p{N}_- ]{1,28}[\p{L}\p{N}]`.
    // The caller must have `resourcemanager.folders.update` permission on the
    // identified folder.
    //
    // If the update fails due to the unique name constraint then a
    // `PreconditionFailure` explaining this violation will be returned
    // in the Status.details field.
    virtual ::grpc::Status UpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateFolderRaw(context, request, cq));
    }
    // Moves a folder under a new resource parent.
    // Returns an `Operation` which can be used to track the progress of the
    // folder move workflow.
    // Upon success, the `Operation.response` field will be populated with the
    // moved folder.
    // Upon failure, a `FolderOperationError` categorizing the failure cause will
    // be returned - if the failure occurs synchronously then the
    // `FolderOperationError` will be returned in the `Status.details` field.
    // If it occurs asynchronously, then the FolderOperation will be returned
    // in the `Operation.error` field.
    // In addition, the `Operation.metadata` field will be populated with a
    // `FolderOperation` message as an aid to stateless clients.
    // Folder moves will be rejected if they violate either the naming, height,
    // or fanout constraints described in the
    // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
    // documentation. The caller must have `resourcemanager.folders.move`
    // permission on the folder's current and proposed new parent.
    virtual ::grpc::Status MoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncMoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncMoveFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncMoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncMoveFolderRaw(context, request, cq));
    }
    // Requests deletion of a folder. The folder is moved into the
    // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Folder.State.DELETE_REQUESTED]
    // state immediately, and is deleted approximately 30 days later. This method
    // may only be called on an empty folder, where a folder is empty if it
    // doesn't contain any folders or projects in the
    // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state. If
    // called on a folder in
    // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Folder.State.DELETE_REQUESTED]
    // state the operation will result in a no-op success.
    // The caller must have `resourcemanager.folders.delete` permission on the
    // identified folder.
    virtual ::grpc::Status DeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteFolderRaw(context, request, cq));
    }
    // Cancels the deletion request for a folder. This method may be called on a
    // folder in any state. If the folder is in the
    // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state the
    // result will be a no-op success. In order to succeed, the folder's parent
    // must be in the
    // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state. In
    // addition, reintroducing the folder into the tree must not violate folder
    // naming, height, and fanout constraints described in the
    // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
    // documentation. The caller must have `resourcemanager.folders.undelete`
    // permission on the identified folder.
    virtual ::grpc::Status UndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeleteFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeleteFolderRaw(context, request, cq));
    }
    // Gets the access control policy for a folder. The returned policy may be
    // empty if no such policy or resource exists. The `resource` field should
    // be the folder's resource name, for example: "folders/1234".
    // The caller must have `resourcemanager.folders.getIamPolicy` permission
    // on the identified folder.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Sets the access control policy on a folder, replacing any existing policy.
    // The `resource` field should be the folder's resource name, for example:
    // "folders/1234".
    // The caller must have `resourcemanager.folders.setIamPolicy` permission
    // on the identified folder.
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Returns permissions that a caller has on the specified folder.
    // The `resource` field should be the folder's resource name,
    // for example: "folders/1234".
    //
    // There are no permissions required for making this API call.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Retrieves a folder identified by the supplied resource name.
      // Valid folder resource names have the format `folders/{folder_id}`
      // (for example, `folders/1234`).
      // The caller must have `resourcemanager.folders.get` permission on the
      // identified folder.
      virtual void GetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::google::cloud::resourcemanager::v3::Folder* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::google::cloud::resourcemanager::v3::Folder* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the folders that are direct descendants of supplied parent resource.
      // `list()` provides a strongly consistent view of the folders underneath
      // the specified parent resource.
      // `list()` returns folders sorted based upon the (ascending) lexical ordering
      // of their display_name.
      // The caller must have `resourcemanager.folders.list` permission on the
      // identified parent.
      virtual void ListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Search for folders that match specific filter criteria.
      // `search()` provides an eventually consistent view of the folders a user has
      // access to which meet the specified filter criteria.
      //
      // This will only return folders on which the caller has the
      // permission `resourcemanager.folders.get`.
      virtual void SearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a folder in the resource hierarchy.
      // Returns an `Operation` which can be used to track the progress of the
      // folder creation workflow.
      // Upon success, the `Operation.response` field will be populated with the
      // created Folder.
      //
      // In order to succeed, the addition of this new folder must not violate
      // the folder naming, height, or fanout constraints.
      //
      // + The folder's `display_name` must be distinct from all other folders that
      // share its parent.
      // + The addition of the folder must not cause the active folder hierarchy
      // to exceed a height of 10. Note, the full active + deleted folder hierarchy
      // is allowed to reach a height of 20; this provides additional headroom when
      // moving folders that contain deleted folders.
      // + The addition of the folder must not cause the total number of folders
      // under its parent to exceed 300.
      //
      // If the operation fails due to a folder constraint violation, some errors
      // may be returned by the `CreateFolder` request, with status code
      // `FAILED_PRECONDITION` and an error description. Other folder constraint
      // violations will be communicated in the `Operation`, with the specific
      // `PreconditionFailure` returned in the details list in the `Operation.error`
      // field.
      //
      // The caller must have `resourcemanager.folders.create` permission on the
      // identified parent.
      virtual void CreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a folder, changing its `display_name`.
      // Changes to the folder `display_name` will be rejected if they violate
      // either the `display_name` formatting rules or the naming constraints
      // described in the
      // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
      // documentation.
      //
      // The folder's `display_name` must start and end with a letter or digit,
      // may contain letters, digits, spaces, hyphens and underscores and can be
      // between 3 and 30 characters. This is captured by the regular expression:
      // `[\p{L}\p{N}][\p{L}\p{N}_- ]{1,28}[\p{L}\p{N}]`.
      // The caller must have `resourcemanager.folders.update` permission on the
      // identified folder.
      //
      // If the update fails due to the unique name constraint then a
      // `PreconditionFailure` explaining this violation will be returned
      // in the Status.details field.
      virtual void UpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Moves a folder under a new resource parent.
      // Returns an `Operation` which can be used to track the progress of the
      // folder move workflow.
      // Upon success, the `Operation.response` field will be populated with the
      // moved folder.
      // Upon failure, a `FolderOperationError` categorizing the failure cause will
      // be returned - if the failure occurs synchronously then the
      // `FolderOperationError` will be returned in the `Status.details` field.
      // If it occurs asynchronously, then the FolderOperation will be returned
      // in the `Operation.error` field.
      // In addition, the `Operation.metadata` field will be populated with a
      // `FolderOperation` message as an aid to stateless clients.
      // Folder moves will be rejected if they violate either the naming, height,
      // or fanout constraints described in the
      // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
      // documentation. The caller must have `resourcemanager.folders.move`
      // permission on the folder's current and proposed new parent.
      virtual void MoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Requests deletion of a folder. The folder is moved into the
      // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Folder.State.DELETE_REQUESTED]
      // state immediately, and is deleted approximately 30 days later. This method
      // may only be called on an empty folder, where a folder is empty if it
      // doesn't contain any folders or projects in the
      // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state. If
      // called on a folder in
      // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Folder.State.DELETE_REQUESTED]
      // state the operation will result in a no-op success.
      // The caller must have `resourcemanager.folders.delete` permission on the
      // identified folder.
      virtual void DeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels the deletion request for a folder. This method may be called on a
      // folder in any state. If the folder is in the
      // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state the
      // result will be a no-op success. In order to succeed, the folder's parent
      // must be in the
      // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state. In
      // addition, reintroducing the folder into the tree must not violate folder
      // naming, height, and fanout constraints described in the
      // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
      // documentation. The caller must have `resourcemanager.folders.undelete`
      // permission on the identified folder.
      virtual void UndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the access control policy for a folder. The returned policy may be
      // empty if no such policy or resource exists. The `resource` field should
      // be the folder's resource name, for example: "folders/1234".
      // The caller must have `resourcemanager.folders.getIamPolicy` permission
      // on the identified folder.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets the access control policy on a folder, replacing any existing policy.
      // The `resource` field should be the folder's resource name, for example:
      // "folders/1234".
      // The caller must have `resourcemanager.folders.setIamPolicy` permission
      // on the identified folder.
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns permissions that a caller has on the specified folder.
      // The `resource` field should be the folder's resource name,
      // for example: "folders/1234".
      //
      // There are no permissions required for making this API call.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Folder>* AsyncGetFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::Folder>* PrepareAsyncGetFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListFoldersResponse>* AsyncListFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::ListFoldersResponse>* PrepareAsyncListFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* AsyncSearchFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* PrepareAsyncSearchFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncMoveFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncMoveFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::google::cloud::resourcemanager::v3::Folder* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Folder>> AsyncGetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Folder>>(AsyncGetFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Folder>> PrepareAsyncGetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Folder>>(PrepareAsyncGetFolderRaw(context, request, cq));
    }
    ::grpc::Status ListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListFoldersResponse>> AsyncListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListFoldersResponse>>(AsyncListFoldersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListFoldersResponse>> PrepareAsyncListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListFoldersResponse>>(PrepareAsyncListFoldersRaw(context, request, cq));
    }
    ::grpc::Status SearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>> AsyncSearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>>(AsyncSearchFoldersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>> PrepareAsyncSearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>>(PrepareAsyncSearchFoldersRaw(context, request, cq));
    }
    ::grpc::Status CreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateFolderRaw(context, request, cq));
    }
    ::grpc::Status UpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateFolderRaw(context, request, cq));
    }
    ::grpc::Status MoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncMoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncMoveFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncMoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncMoveFolderRaw(context, request, cq));
    }
    ::grpc::Status DeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteFolderRaw(context, request, cq));
    }
    ::grpc::Status UndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeleteFolderRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeleteFolderRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::google::cloud::resourcemanager::v3::Folder* response, std::function<void(::grpc::Status)>) override;
      void GetFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::google::cloud::resourcemanager::v3::Folder* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchFolders(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void MoveFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeleteFolder(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Folder>* AsyncGetFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::Folder>* PrepareAsyncGetFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListFoldersResponse>* AsyncListFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::ListFoldersResponse>* PrepareAsyncListFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* AsyncSearchFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* PrepareAsyncSearchFoldersRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncMoveFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncMoveFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeleteFolderRaw(::grpc::ClientContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetFolder_;
    const ::grpc::internal::RpcMethod rpcmethod_ListFolders_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchFolders_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateFolder_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFolder_;
    const ::grpc::internal::RpcMethod rpcmethod_MoveFolder_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFolder_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeleteFolder_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Retrieves a folder identified by the supplied resource name.
    // Valid folder resource names have the format `folders/{folder_id}`
    // (for example, `folders/1234`).
    // The caller must have `resourcemanager.folders.get` permission on the
    // identified folder.
    virtual ::grpc::Status GetFolder(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::google::cloud::resourcemanager::v3::Folder* response);
    // Lists the folders that are direct descendants of supplied parent resource.
    // `list()` provides a strongly consistent view of the folders underneath
    // the specified parent resource.
    // `list()` returns folders sorted based upon the (ascending) lexical ordering
    // of their display_name.
    // The caller must have `resourcemanager.folders.list` permission on the
    // identified parent.
    virtual ::grpc::Status ListFolders(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response);
    // Search for folders that match specific filter criteria.
    // `search()` provides an eventually consistent view of the folders a user has
    // access to which meet the specified filter criteria.
    //
    // This will only return folders on which the caller has the
    // permission `resourcemanager.folders.get`.
    virtual ::grpc::Status SearchFolders(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response);
    // Creates a folder in the resource hierarchy.
    // Returns an `Operation` which can be used to track the progress of the
    // folder creation workflow.
    // Upon success, the `Operation.response` field will be populated with the
    // created Folder.
    //
    // In order to succeed, the addition of this new folder must not violate
    // the folder naming, height, or fanout constraints.
    //
    // + The folder's `display_name` must be distinct from all other folders that
    // share its parent.
    // + The addition of the folder must not cause the active folder hierarchy
    // to exceed a height of 10. Note, the full active + deleted folder hierarchy
    // is allowed to reach a height of 20; this provides additional headroom when
    // moving folders that contain deleted folders.
    // + The addition of the folder must not cause the total number of folders
    // under its parent to exceed 300.
    //
    // If the operation fails due to a folder constraint violation, some errors
    // may be returned by the `CreateFolder` request, with status code
    // `FAILED_PRECONDITION` and an error description. Other folder constraint
    // violations will be communicated in the `Operation`, with the specific
    // `PreconditionFailure` returned in the details list in the `Operation.error`
    // field.
    //
    // The caller must have `resourcemanager.folders.create` permission on the
    // identified parent.
    virtual ::grpc::Status CreateFolder(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::google::longrunning::Operation* response);
    // Updates a folder, changing its `display_name`.
    // Changes to the folder `display_name` will be rejected if they violate
    // either the `display_name` formatting rules or the naming constraints
    // described in the
    // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
    // documentation.
    //
    // The folder's `display_name` must start and end with a letter or digit,
    // may contain letters, digits, spaces, hyphens and underscores and can be
    // between 3 and 30 characters. This is captured by the regular expression:
    // `[\p{L}\p{N}][\p{L}\p{N}_- ]{1,28}[\p{L}\p{N}]`.
    // The caller must have `resourcemanager.folders.update` permission on the
    // identified folder.
    //
    // If the update fails due to the unique name constraint then a
    // `PreconditionFailure` explaining this violation will be returned
    // in the Status.details field.
    virtual ::grpc::Status UpdateFolder(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::google::longrunning::Operation* response);
    // Moves a folder under a new resource parent.
    // Returns an `Operation` which can be used to track the progress of the
    // folder move workflow.
    // Upon success, the `Operation.response` field will be populated with the
    // moved folder.
    // Upon failure, a `FolderOperationError` categorizing the failure cause will
    // be returned - if the failure occurs synchronously then the
    // `FolderOperationError` will be returned in the `Status.details` field.
    // If it occurs asynchronously, then the FolderOperation will be returned
    // in the `Operation.error` field.
    // In addition, the `Operation.metadata` field will be populated with a
    // `FolderOperation` message as an aid to stateless clients.
    // Folder moves will be rejected if they violate either the naming, height,
    // or fanout constraints described in the
    // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
    // documentation. The caller must have `resourcemanager.folders.move`
    // permission on the folder's current and proposed new parent.
    virtual ::grpc::Status MoveFolder(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::google::longrunning::Operation* response);
    // Requests deletion of a folder. The folder is moved into the
    // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Folder.State.DELETE_REQUESTED]
    // state immediately, and is deleted approximately 30 days later. This method
    // may only be called on an empty folder, where a folder is empty if it
    // doesn't contain any folders or projects in the
    // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state. If
    // called on a folder in
    // [DELETE_REQUESTED][google.cloud.resourcemanager.v3.Folder.State.DELETE_REQUESTED]
    // state the operation will result in a no-op success.
    // The caller must have `resourcemanager.folders.delete` permission on the
    // identified folder.
    virtual ::grpc::Status DeleteFolder(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::google::longrunning::Operation* response);
    // Cancels the deletion request for a folder. This method may be called on a
    // folder in any state. If the folder is in the
    // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state the
    // result will be a no-op success. In order to succeed, the folder's parent
    // must be in the
    // [ACTIVE][google.cloud.resourcemanager.v3.Folder.State.ACTIVE] state. In
    // addition, reintroducing the folder into the tree must not violate folder
    // naming, height, and fanout constraints described in the
    // [CreateFolder][google.cloud.resourcemanager.v3.Folders.CreateFolder]
    // documentation. The caller must have `resourcemanager.folders.undelete`
    // permission on the identified folder.
    virtual ::grpc::Status UndeleteFolder(::grpc::ServerContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::google::longrunning::Operation* response);
    // Gets the access control policy for a folder. The returned policy may be
    // empty if no such policy or resource exists. The `resource` field should
    // be the folder's resource name, for example: "folders/1234".
    // The caller must have `resourcemanager.folders.getIamPolicy` permission
    // on the identified folder.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Sets the access control policy on a folder, replacing any existing policy.
    // The `resource` field should be the folder's resource name, for example:
    // "folders/1234".
    // The caller must have `resourcemanager.folders.setIamPolicy` permission
    // on the identified folder.
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Returns permissions that a caller has on the specified folder.
    // The `resource` field should be the folder's resource name,
    // for example: "folders/1234".
    //
    // There are no permissions required for making this API call.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFolder() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFolder(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::Folder>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFolders() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFolders(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::ListFoldersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchFolders() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_SearchFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchFolders(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateFolder() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFolder(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFolder() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFolder(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MoveFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MoveFolder() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_MoveFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveFolder(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFolder() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFolder(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeleteFolder() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UndeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteFolder(::grpc::ServerContext* context, ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetFolder<WithAsyncMethod_ListFolders<WithAsyncMethod_SearchFolders<WithAsyncMethod_CreateFolder<WithAsyncMethod_UpdateFolder<WithAsyncMethod_MoveFolder<WithAsyncMethod_DeleteFolder<WithAsyncMethod_UndeleteFolder<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_TestIamPermissions<Service > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFolder() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::GetFolderRequest, ::google::cloud::resourcemanager::v3::Folder>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::GetFolderRequest* request, ::google::cloud::resourcemanager::v3::Folder* response) { return this->GetFolder(context, request, response); }));}
    void SetMessageAllocatorFor_GetFolder(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::GetFolderRequest, ::google::cloud::resourcemanager::v3::Folder>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::GetFolderRequest, ::google::cloud::resourcemanager::v3::Folder>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFolders() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListFoldersRequest, ::google::cloud::resourcemanager::v3::ListFoldersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* request, ::google::cloud::resourcemanager::v3::ListFoldersResponse* response) { return this->ListFolders(context, request, response); }));}
    void SetMessageAllocatorFor_ListFolders(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::ListFoldersRequest, ::google::cloud::resourcemanager::v3::ListFoldersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::ListFoldersRequest, ::google::cloud::resourcemanager::v3::ListFoldersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFolders(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchFolders() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::SearchFoldersRequest, ::google::cloud::resourcemanager::v3::SearchFoldersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* request, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* response) { return this->SearchFolders(context, request, response); }));}
    void SetMessageAllocatorFor_SearchFolders(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::SearchFoldersRequest, ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::SearchFoldersRequest, ::google::cloud::resourcemanager::v3::SearchFoldersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchFolders(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateFolder() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateFolderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* request, ::google::longrunning::Operation* response) { return this->CreateFolder(context, request, response); }));}
    void SetMessageAllocatorFor_CreateFolder(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::CreateFolderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::CreateFolderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFolder() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UpdateFolderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* request, ::google::longrunning::Operation* response) { return this->UpdateFolder(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFolder(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::UpdateFolderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UpdateFolderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MoveFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MoveFolder() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::MoveFolderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* request, ::google::longrunning::Operation* response) { return this->MoveFolder(context, request, response); }));}
    void SetMessageAllocatorFor_MoveFolder(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::MoveFolderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::MoveFolderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MoveFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFolder() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteFolderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* request, ::google::longrunning::Operation* response) { return this->DeleteFolder(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFolder(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::DeleteFolderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::DeleteFolderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeleteFolder() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UndeleteFolderRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* request, ::google::longrunning::Operation* response) { return this->UndeleteFolder(context, request, response); }));}
    void SetMessageAllocatorFor_UndeleteFolder(
        ::grpc::MessageAllocator< ::google::cloud::resourcemanager::v3::UndeleteFolderRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::resourcemanager::v3::UndeleteFolderRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetFolder<WithCallbackMethod_ListFolders<WithCallbackMethod_SearchFolders<WithCallbackMethod_CreateFolder<WithCallbackMethod_UpdateFolder<WithCallbackMethod_MoveFolder<WithCallbackMethod_DeleteFolder<WithCallbackMethod_UndeleteFolder<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_TestIamPermissions<Service > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFolder() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFolders() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchFolders() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_SearchFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateFolder() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFolder() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MoveFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MoveFolder() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_MoveFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFolder() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeleteFolder() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UndeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFolder() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFolder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFolders() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFolders(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchFolders() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_SearchFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchFolders(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateFolder() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFolder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFolder() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFolder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MoveFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MoveFolder() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_MoveFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMoveFolder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFolder() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFolder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeleteFolder() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UndeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteFolder(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFolder() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFolder(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFolders() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFolders(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFolders(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchFolders() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchFolders(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchFolders(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateFolder() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateFolder(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFolder() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFolder(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MoveFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MoveFolder() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MoveFolder(context, request, response); }));
    }
    ~WithRawCallbackMethod_MoveFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MoveFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MoveFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFolder() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFolder(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeleteFolder() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeleteFolder(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteFolder(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFolder() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::GetFolderRequest, ::google::cloud::resourcemanager::v3::Folder>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::GetFolderRequest, ::google::cloud::resourcemanager::v3::Folder>* streamer) {
                       return this->StreamedGetFolder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::GetFolderRequest* /*request*/, ::google::cloud::resourcemanager::v3::Folder* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFolder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::GetFolderRequest,::google::cloud::resourcemanager::v3::Folder>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFolders() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::ListFoldersRequest, ::google::cloud::resourcemanager::v3::ListFoldersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::ListFoldersRequest, ::google::cloud::resourcemanager::v3::ListFoldersResponse>* streamer) {
                       return this->StreamedListFolders(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::ListFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::ListFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFolders(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::ListFoldersRequest,::google::cloud::resourcemanager::v3::ListFoldersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchFolders : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchFolders() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::SearchFoldersRequest, ::google::cloud::resourcemanager::v3::SearchFoldersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::SearchFoldersRequest, ::google::cloud::resourcemanager::v3::SearchFoldersResponse>* streamer) {
                       return this->StreamedSearchFolders(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchFolders() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchFolders(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::SearchFoldersRequest* /*request*/, ::google::cloud::resourcemanager::v3::SearchFoldersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchFolders(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::SearchFoldersRequest,::google::cloud::resourcemanager::v3::SearchFoldersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateFolder() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::CreateFolderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::CreateFolderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateFolder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::CreateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateFolder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::CreateFolderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFolder() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::UpdateFolderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::UpdateFolderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateFolder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UpdateFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFolder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::UpdateFolderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MoveFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MoveFolder() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::MoveFolderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::MoveFolderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedMoveFolder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MoveFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MoveFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::MoveFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMoveFolder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::MoveFolderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFolder() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::DeleteFolderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::DeleteFolderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteFolder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::DeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFolder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::DeleteFolderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeleteFolder : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeleteFolder() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::resourcemanager::v3::UndeleteFolderRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::resourcemanager::v3::UndeleteFolderRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeleteFolder(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeleteFolder() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeleteFolder(::grpc::ServerContext* /*context*/, const ::google::cloud::resourcemanager::v3::UndeleteFolderRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeleteFolder(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::resourcemanager::v3::UndeleteFolderRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetFolder<WithStreamedUnaryMethod_ListFolders<WithStreamedUnaryMethod_SearchFolders<WithStreamedUnaryMethod_CreateFolder<WithStreamedUnaryMethod_UpdateFolder<WithStreamedUnaryMethod_MoveFolder<WithStreamedUnaryMethod_DeleteFolder<WithStreamedUnaryMethod_UndeleteFolder<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetFolder<WithStreamedUnaryMethod_ListFolders<WithStreamedUnaryMethod_SearchFolders<WithStreamedUnaryMethod_CreateFolder<WithStreamedUnaryMethod_UpdateFolder<WithStreamedUnaryMethod_MoveFolder<WithStreamedUnaryMethod_DeleteFolder<WithStreamedUnaryMethod_UndeleteFolder<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > StreamedService;
};

}  // namespace v3
}  // namespace resourcemanager
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fresourcemanager_2fv3_2ffolders_2eproto__INCLUDED
