// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/retail/v2/completion_service.proto
// Original file comments:
// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fretail_2fv2_2fcompletion_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fretail_2fv2_2fcompletion_5fservice_2eproto__INCLUDED

#include "google/cloud/retail/v2/completion_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace retail {
namespace v2 {

// Autocomplete service for retail.
//
// This feature is only available for users who have Retail Search enabled.
// Enable Retail Search on Cloud Console before using this feature.
class CompletionService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.retail.v2.CompletionService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Completes the specified prefix with keyword suggestions.
    //
    // This feature is only available for users who have Retail Search enabled.
    // Enable Retail Search on Cloud Console before using this feature.
    virtual ::grpc::Status CompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::google::cloud::retail::v2::CompleteQueryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompleteQueryResponse>> AsyncCompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompleteQueryResponse>>(AsyncCompleteQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompleteQueryResponse>> PrepareAsyncCompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompleteQueryResponse>>(PrepareAsyncCompleteQueryRaw(context, request, cq));
    }
    // Bulk import of processed completion dataset.
    //
    // Request processing is asynchronous. Partial updating is not supported.
    //
    // The operation is successfully finished only after the imported suggestions
    // are indexed successfully and ready for serving. The process takes hours.
    //
    // This feature is only available for users who have Retail Search enabled.
    // Enable Retail Search on Cloud Console before using this feature.
    virtual ::grpc::Status ImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportCompletionDataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportCompletionDataRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Completes the specified prefix with keyword suggestions.
      //
      // This feature is only available for users who have Retail Search enabled.
      // Enable Retail Search on Cloud Console before using this feature.
      virtual void CompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest* request, ::google::cloud::retail::v2::CompleteQueryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest* request, ::google::cloud::retail::v2::CompleteQueryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Bulk import of processed completion dataset.
      //
      // Request processing is asynchronous. Partial updating is not supported.
      //
      // The operation is successfully finished only after the imported suggestions
      // are indexed successfully and ready for serving. The process takes hours.
      //
      // This feature is only available for users who have Retail Search enabled.
      // Enable Retail Search on Cloud Console before using this feature.
      virtual void ImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompleteQueryResponse>* AsyncCompleteQueryRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::CompleteQueryResponse>* PrepareAsyncCompleteQueryRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportCompletionDataRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportCompletionDataRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::google::cloud::retail::v2::CompleteQueryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompleteQueryResponse>> AsyncCompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompleteQueryResponse>>(AsyncCompleteQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompleteQueryResponse>> PrepareAsyncCompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompleteQueryResponse>>(PrepareAsyncCompleteQueryRaw(context, request, cq));
    }
    ::grpc::Status ImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportCompletionDataRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportCompletionDataRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest* request, ::google::cloud::retail::v2::CompleteQueryResponse* response, std::function<void(::grpc::Status)>) override;
      void CompleteQuery(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest* request, ::google::cloud::retail::v2::CompleteQueryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportCompletionData(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompleteQueryResponse>* AsyncCompleteQueryRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::CompleteQueryResponse>* PrepareAsyncCompleteQueryRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportCompletionDataRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportCompletionDataRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CompleteQuery_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportCompletionData_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Completes the specified prefix with keyword suggestions.
    //
    // This feature is only available for users who have Retail Search enabled.
    // Enable Retail Search on Cloud Console before using this feature.
    virtual ::grpc::Status CompleteQuery(::grpc::ServerContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest* request, ::google::cloud::retail::v2::CompleteQueryResponse* response);
    // Bulk import of processed completion dataset.
    //
    // Request processing is asynchronous. Partial updating is not supported.
    //
    // The operation is successfully finished only after the imported suggestions
    // are indexed successfully and ready for serving. The process takes hours.
    //
    // This feature is only available for users who have Retail Search enabled.
    // Enable Retail Search on Cloud Console before using this feature.
    virtual ::grpc::Status ImportCompletionData(::grpc::ServerContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CompleteQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CompleteQuery() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CompleteQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCompleteQuery(::grpc::ServerContext* context, ::google::cloud::retail::v2::CompleteQueryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::CompleteQueryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportCompletionData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportCompletionData() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ImportCompletionData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCompletionData(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportCompletionData(::grpc::ServerContext* context, ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CompleteQuery<WithAsyncMethod_ImportCompletionData<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CompleteQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CompleteQuery() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::CompleteQueryRequest, ::google::cloud::retail::v2::CompleteQueryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::CompleteQueryRequest* request, ::google::cloud::retail::v2::CompleteQueryResponse* response) { return this->CompleteQuery(context, request, response); }));}
    void SetMessageAllocatorFor_CompleteQuery(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::CompleteQueryRequest, ::google::cloud::retail::v2::CompleteQueryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::CompleteQueryRequest, ::google::cloud::retail::v2::CompleteQueryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CompleteQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CompleteQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportCompletionData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportCompletionData() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ImportCompletionDataRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::ImportCompletionDataRequest* request, ::google::longrunning::Operation* response) { return this->ImportCompletionData(context, request, response); }));}
    void SetMessageAllocatorFor_ImportCompletionData(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::ImportCompletionDataRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ImportCompletionDataRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportCompletionData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCompletionData(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportCompletionData(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CompleteQuery<WithCallbackMethod_ImportCompletionData<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CompleteQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CompleteQuery() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CompleteQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportCompletionData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportCompletionData() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ImportCompletionData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCompletionData(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CompleteQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CompleteQuery() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CompleteQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCompleteQuery(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportCompletionData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportCompletionData() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ImportCompletionData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCompletionData(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportCompletionData(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CompleteQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CompleteQuery() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CompleteQuery(context, request, response); }));
    }
    ~WithRawCallbackMethod_CompleteQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CompleteQuery(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportCompletionData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportCompletionData() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportCompletionData(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportCompletionData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCompletionData(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportCompletionData(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CompleteQuery : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CompleteQuery() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::CompleteQueryRequest, ::google::cloud::retail::v2::CompleteQueryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::CompleteQueryRequest, ::google::cloud::retail::v2::CompleteQueryResponse>* streamer) {
                       return this->StreamedCompleteQuery(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CompleteQuery() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CompleteQuery(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CompleteQueryRequest* /*request*/, ::google::cloud::retail::v2::CompleteQueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCompleteQuery(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::CompleteQueryRequest,::google::cloud::retail::v2::CompleteQueryResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportCompletionData : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportCompletionData() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::ImportCompletionDataRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::ImportCompletionDataRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportCompletionData(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportCompletionData() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportCompletionData(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportCompletionDataRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportCompletionData(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::ImportCompletionDataRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CompleteQuery<WithStreamedUnaryMethod_ImportCompletionData<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CompleteQuery<WithStreamedUnaryMethod_ImportCompletionData<Service > > StreamedService;
};

}  // namespace v2
}  // namespace retail
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fretail_2fv2_2fcompletion_5fservice_2eproto__INCLUDED
