// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/retail/v2/model_service.proto
// Original file comments:
// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fretail_2fv2_2fmodel_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fretail_2fv2_2fmodel_5fservice_2eproto__INCLUDED

#include "google/cloud/retail/v2/model_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace retail {
namespace v2 {

// Service for performing CRUD operations on models.
// Recommendation models contain all the metadata necessary to generate a set of
// models for the `Predict()` API. A model is queried
// indirectly via a ServingConfig, which associates a model with a
// given Placement (e.g. Frequently Bought Together on Home Page).
//
// This service allows you to do the following:
//
// * Initiate training of a model.
// * Pause training of an existing model.
// * List all the available models along with their metadata.
// * Control their tuning schedule.
class ModelService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.retail.v2.ModelService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new model.
    virtual ::grpc::Status CreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateModelRaw(context, request, cq));
    }
    // Gets a model.
    virtual ::grpc::Status GetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::google::cloud::retail::v2::Model* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> AsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(AsyncGetModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> PrepareAsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(PrepareAsyncGetModelRaw(context, request, cq));
    }
    // Pauses the training of an existing model.
    virtual ::grpc::Status PauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::google::cloud::retail::v2::Model* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> AsyncPauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(AsyncPauseModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> PrepareAsyncPauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(PrepareAsyncPauseModelRaw(context, request, cq));
    }
    // Resumes the training of an existing model.
    virtual ::grpc::Status ResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::google::cloud::retail::v2::Model* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> AsyncResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(AsyncResumeModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> PrepareAsyncResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(PrepareAsyncResumeModelRaw(context, request, cq));
    }
    // Deletes an existing model.
    virtual ::grpc::Status DeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteModelRaw(context, request, cq));
    }
    // Lists all the models linked to this event store.
    virtual ::grpc::Status ListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::google::cloud::retail::v2::ListModelsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListModelsResponse>> AsyncListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListModelsResponse>>(AsyncListModelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListModelsResponse>> PrepareAsyncListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListModelsResponse>>(PrepareAsyncListModelsRaw(context, request, cq));
    }
    // Update of model metadata. Only fields that
    // currently can be updated are: `filtering_option` and
    // `periodic_tuning_state`.
    // If other values are provided, this API method ignores them.
    virtual ::grpc::Status UpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::google::cloud::retail::v2::Model* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> AsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(AsyncUpdateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>> PrepareAsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>>(PrepareAsyncUpdateModelRaw(context, request, cq));
    }
    // Tunes an existing model.
    virtual ::grpc::Status TuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTuneModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTuneModelRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new model.
      virtual void CreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a model.
      virtual void GetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Pauses the training of an existing model.
      virtual void PauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resumes the training of an existing model.
      virtual void ResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing model.
      virtual void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all the models linked to this event store.
      virtual void ListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest* request, ::google::cloud::retail::v2::ListModelsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest* request, ::google::cloud::retail::v2::ListModelsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update of model metadata. Only fields that
      // currently can be updated are: `filtering_option` and
      // `periodic_tuning_state`.
      // If other values are provided, this API method ignores them.
      virtual void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Tunes an existing model.
      virtual void TuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* AsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* PrepareAsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* AsyncPauseModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* PrepareAsyncPauseModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* AsyncResumeModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* PrepareAsyncResumeModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListModelsResponse>* AsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::ListModelsResponse>* PrepareAsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* AsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::Model>* PrepareAsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTuneModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTuneModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateModelRaw(context, request, cq));
    }
    ::grpc::Status GetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::google::cloud::retail::v2::Model* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> AsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(AsyncGetModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> PrepareAsyncGetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(PrepareAsyncGetModelRaw(context, request, cq));
    }
    ::grpc::Status PauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::google::cloud::retail::v2::Model* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> AsyncPauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(AsyncPauseModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> PrepareAsyncPauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(PrepareAsyncPauseModelRaw(context, request, cq));
    }
    ::grpc::Status ResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::google::cloud::retail::v2::Model* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> AsyncResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(AsyncResumeModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> PrepareAsyncResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(PrepareAsyncResumeModelRaw(context, request, cq));
    }
    ::grpc::Status DeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteModelRaw(context, request, cq));
    }
    ::grpc::Status ListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::google::cloud::retail::v2::ListModelsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListModelsResponse>> AsyncListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListModelsResponse>>(AsyncListModelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListModelsResponse>> PrepareAsyncListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListModelsResponse>>(PrepareAsyncListModelsRaw(context, request, cq));
    }
    ::grpc::Status UpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::google::cloud::retail::v2::Model* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> AsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(AsyncUpdateModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>> PrepareAsyncUpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>>(PrepareAsyncUpdateModelRaw(context, request, cq));
    }
    ::grpc::Status TuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTuneModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTuneModelRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) override;
      void GetModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) override;
      void PauseModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) override;
      void ResumeModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest* request, ::google::cloud::retail::v2::ListModelsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListModels(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest* request, ::google::cloud::retail::v2::ListModelsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest* request, ::google::cloud::retail::v2::Model* response, std::function<void(::grpc::Status)>) override;
      void UpdateModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest* request, ::google::cloud::retail::v2::Model* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TuneModel(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CreateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* AsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* PrepareAsyncGetModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::GetModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* AsyncPauseModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* PrepareAsyncPauseModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PauseModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* AsyncResumeModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* PrepareAsyncResumeModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ResumeModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::DeleteModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListModelsResponse>* AsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::ListModelsResponse>* PrepareAsyncListModelsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ListModelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* AsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::Model>* PrepareAsyncUpdateModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::UpdateModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTuneModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTuneModelRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::TuneModelRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateModel_;
    const ::grpc::internal::RpcMethod rpcmethod_GetModel_;
    const ::grpc::internal::RpcMethod rpcmethod_PauseModel_;
    const ::grpc::internal::RpcMethod rpcmethod_ResumeModel_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteModel_;
    const ::grpc::internal::RpcMethod rpcmethod_ListModels_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateModel_;
    const ::grpc::internal::RpcMethod rpcmethod_TuneModel_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new model.
    virtual ::grpc::Status CreateModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::CreateModelRequest* request, ::google::longrunning::Operation* response);
    // Gets a model.
    virtual ::grpc::Status GetModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::GetModelRequest* request, ::google::cloud::retail::v2::Model* response);
    // Pauses the training of an existing model.
    virtual ::grpc::Status PauseModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::PauseModelRequest* request, ::google::cloud::retail::v2::Model* response);
    // Resumes the training of an existing model.
    virtual ::grpc::Status ResumeModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::ResumeModelRequest* request, ::google::cloud::retail::v2::Model* response);
    // Deletes an existing model.
    virtual ::grpc::Status DeleteModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::DeleteModelRequest* request, ::google::protobuf::Empty* response);
    // Lists all the models linked to this event store.
    virtual ::grpc::Status ListModels(::grpc::ServerContext* context, const ::google::cloud::retail::v2::ListModelsRequest* request, ::google::cloud::retail::v2::ListModelsResponse* response);
    // Update of model metadata. Only fields that
    // currently can be updated are: `filtering_option` and
    // `periodic_tuning_state`.
    // If other values are provided, this API method ignores them.
    virtual ::grpc::Status UpdateModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::UpdateModelRequest* request, ::google::cloud::retail::v2::Model* response);
    // Tunes an existing model.
    virtual ::grpc::Status TuneModel(::grpc::ServerContext* context, const ::google::cloud::retail::v2::TuneModelRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateModel() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::CreateModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetModel() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::GetModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::Model>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PauseModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PauseModel() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_PauseModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPauseModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::PauseModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::Model>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResumeModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResumeModel() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ResumeModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResumeModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::ResumeModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::Model>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteModel() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::DeleteModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListModels() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListModels(::grpc::ServerContext* context, ::google::cloud::retail::v2::ListModelsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::ListModelsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateModel() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::UpdateModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::Model>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TuneModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TuneModel() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_TuneModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TuneModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTuneModel(::grpc::ServerContext* context, ::google::cloud::retail::v2::TuneModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateModel<WithAsyncMethod_GetModel<WithAsyncMethod_PauseModel<WithAsyncMethod_ResumeModel<WithAsyncMethod_DeleteModel<WithAsyncMethod_ListModels<WithAsyncMethod_UpdateModel<WithAsyncMethod_TuneModel<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateModel() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::CreateModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::CreateModelRequest* request, ::google::longrunning::Operation* response) { return this->CreateModel(context, request, response); }));}
    void SetMessageAllocatorFor_CreateModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::CreateModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::CreateModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetModel() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetModelRequest, ::google::cloud::retail::v2::Model>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::GetModelRequest* request, ::google::cloud::retail::v2::Model* response) { return this->GetModel(context, request, response); }));}
    void SetMessageAllocatorFor_GetModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::GetModelRequest, ::google::cloud::retail::v2::Model>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::GetModelRequest, ::google::cloud::retail::v2::Model>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PauseModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PauseModel() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::PauseModelRequest, ::google::cloud::retail::v2::Model>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::PauseModelRequest* request, ::google::cloud::retail::v2::Model* response) { return this->PauseModel(context, request, response); }));}
    void SetMessageAllocatorFor_PauseModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::PauseModelRequest, ::google::cloud::retail::v2::Model>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::PauseModelRequest, ::google::cloud::retail::v2::Model>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PauseModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PauseModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResumeModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResumeModel() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ResumeModelRequest, ::google::cloud::retail::v2::Model>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::ResumeModelRequest* request, ::google::cloud::retail::v2::Model* response) { return this->ResumeModel(context, request, response); }));}
    void SetMessageAllocatorFor_ResumeModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::ResumeModelRequest, ::google::cloud::retail::v2::Model>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ResumeModelRequest, ::google::cloud::retail::v2::Model>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResumeModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResumeModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteModel() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::DeleteModelRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::DeleteModelRequest* request, ::google::protobuf::Empty* response) { return this->DeleteModel(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::DeleteModelRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::DeleteModelRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListModels() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ListModelsRequest, ::google::cloud::retail::v2::ListModelsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::ListModelsRequest* request, ::google::cloud::retail::v2::ListModelsResponse* response) { return this->ListModels(context, request, response); }));}
    void SetMessageAllocatorFor_ListModels(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::ListModelsRequest, ::google::cloud::retail::v2::ListModelsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ListModelsRequest, ::google::cloud::retail::v2::ListModelsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListModels(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateModel() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateModelRequest, ::google::cloud::retail::v2::Model>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::UpdateModelRequest* request, ::google::cloud::retail::v2::Model* response) { return this->UpdateModel(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::UpdateModelRequest, ::google::cloud::retail::v2::Model>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::UpdateModelRequest, ::google::cloud::retail::v2::Model>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TuneModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TuneModel() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::TuneModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::TuneModelRequest* request, ::google::longrunning::Operation* response) { return this->TuneModel(context, request, response); }));}
    void SetMessageAllocatorFor_TuneModel(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::TuneModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::TuneModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TuneModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TuneModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TuneModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateModel<WithCallbackMethod_GetModel<WithCallbackMethod_PauseModel<WithCallbackMethod_ResumeModel<WithCallbackMethod_DeleteModel<WithCallbackMethod_ListModels<WithCallbackMethod_UpdateModel<WithCallbackMethod_TuneModel<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateModel() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetModel() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PauseModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PauseModel() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_PauseModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResumeModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResumeModel() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ResumeModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteModel() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListModels() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateModel() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TuneModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TuneModel() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_TuneModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TuneModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateModel() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetModel() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PauseModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PauseModel() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_PauseModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPauseModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResumeModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResumeModel() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ResumeModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResumeModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteModel() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListModels() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListModels(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateModel() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TuneModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TuneModel() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_TuneModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TuneModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTuneModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateModel() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetModel() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PauseModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PauseModel() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PauseModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_PauseModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PauseModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResumeModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResumeModel() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResumeModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResumeModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResumeModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteModel() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListModels() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListModels(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListModels(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateModel() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TuneModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TuneModel() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TuneModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_TuneModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TuneModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TuneModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateModel() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::CreateModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::CreateModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CreateModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::CreateModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetModel() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::GetModelRequest, ::google::cloud::retail::v2::Model>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::GetModelRequest, ::google::cloud::retail::v2::Model>* streamer) {
                       return this->StreamedGetModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::GetModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::GetModelRequest,::google::cloud::retail::v2::Model>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PauseModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PauseModel() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::PauseModelRequest, ::google::cloud::retail::v2::Model>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::PauseModelRequest, ::google::cloud::retail::v2::Model>* streamer) {
                       return this->StreamedPauseModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PauseModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PauseModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PauseModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPauseModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::PauseModelRequest,::google::cloud::retail::v2::Model>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResumeModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResumeModel() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::ResumeModelRequest, ::google::cloud::retail::v2::Model>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::ResumeModelRequest, ::google::cloud::retail::v2::Model>* streamer) {
                       return this->StreamedResumeModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResumeModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResumeModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ResumeModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResumeModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::ResumeModelRequest,::google::cloud::retail::v2::Model>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteModel() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::DeleteModelRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::DeleteModelRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::DeleteModelRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::DeleteModelRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListModels() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::ListModelsRequest, ::google::cloud::retail::v2::ListModelsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::ListModelsRequest, ::google::cloud::retail::v2::ListModelsResponse>* streamer) {
                       return this->StreamedListModels(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListModels(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ListModelsRequest* /*request*/, ::google::cloud::retail::v2::ListModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListModels(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::ListModelsRequest,::google::cloud::retail::v2::ListModelsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateModel() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::UpdateModelRequest, ::google::cloud::retail::v2::Model>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::UpdateModelRequest, ::google::cloud::retail::v2::Model>* streamer) {
                       return this->StreamedUpdateModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::UpdateModelRequest* /*request*/, ::google::cloud::retail::v2::Model* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::UpdateModelRequest,::google::cloud::retail::v2::Model>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TuneModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TuneModel() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::TuneModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::TuneModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedTuneModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TuneModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TuneModel(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::TuneModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTuneModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::TuneModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateModel<WithStreamedUnaryMethod_GetModel<WithStreamedUnaryMethod_PauseModel<WithStreamedUnaryMethod_ResumeModel<WithStreamedUnaryMethod_DeleteModel<WithStreamedUnaryMethod_ListModels<WithStreamedUnaryMethod_UpdateModel<WithStreamedUnaryMethod_TuneModel<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateModel<WithStreamedUnaryMethod_GetModel<WithStreamedUnaryMethod_PauseModel<WithStreamedUnaryMethod_ResumeModel<WithStreamedUnaryMethod_DeleteModel<WithStreamedUnaryMethod_ListModels<WithStreamedUnaryMethod_UpdateModel<WithStreamedUnaryMethod_TuneModel<Service > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace retail
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fretail_2fv2_2fmodel_5fservice_2eproto__INCLUDED
