// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/support/v2/case_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_INTERNAL_CASE_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_INTERNAL_CASE_STUB_H

#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/support/v2/case_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace support_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CaseServiceStub {
 public:
  virtual ~CaseServiceStub() = 0;

  virtual StatusOr<google::cloud::support::v2::Case> GetCase(
      grpc::ClientContext& context,
      google::cloud::support::v2::GetCaseRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::ListCasesResponse> ListCases(
      grpc::ClientContext& context,
      google::cloud::support::v2::ListCasesRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::SearchCasesResponse> SearchCases(
      grpc::ClientContext& context,
      google::cloud::support::v2::SearchCasesRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::Case> CreateCase(
      grpc::ClientContext& context,
      google::cloud::support::v2::CreateCaseRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::Case> UpdateCase(
      grpc::ClientContext& context,
      google::cloud::support::v2::UpdateCaseRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::Case> EscalateCase(
      grpc::ClientContext& context,
      google::cloud::support::v2::EscalateCaseRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::Case> CloseCase(
      grpc::ClientContext& context,
      google::cloud::support::v2::CloseCaseRequest const& request) = 0;

  virtual StatusOr<
      google::cloud::support::v2::SearchCaseClassificationsResponse>
  SearchCaseClassifications(
      grpc::ClientContext& context,
      google::cloud::support::v2::SearchCaseClassificationsRequest const&
          request) = 0;
};

class DefaultCaseServiceStub : public CaseServiceStub {
 public:
  explicit DefaultCaseServiceStub(
      std::unique_ptr<google::cloud::support::v2::CaseService::StubInterface>
          grpc_stub)
      : grpc_stub_(std::move(grpc_stub)) {}

  StatusOr<google::cloud::support::v2::Case> GetCase(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::GetCaseRequest const& request) override;

  StatusOr<google::cloud::support::v2::ListCasesResponse> ListCases(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::ListCasesRequest const& request) override;

  StatusOr<google::cloud::support::v2::SearchCasesResponse> SearchCases(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::SearchCasesRequest const& request) override;

  StatusOr<google::cloud::support::v2::Case> CreateCase(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::CreateCaseRequest const& request) override;

  StatusOr<google::cloud::support::v2::Case> UpdateCase(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::UpdateCaseRequest const& request) override;

  StatusOr<google::cloud::support::v2::Case> EscalateCase(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::EscalateCaseRequest const& request) override;

  StatusOr<google::cloud::support::v2::Case> CloseCase(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::CloseCaseRequest const& request) override;

  StatusOr<google::cloud::support::v2::SearchCaseClassificationsResponse>
  SearchCaseClassifications(
      grpc::ClientContext& client_context,
      google::cloud::support::v2::SearchCaseClassificationsRequest const&
          request) override;

 private:
  std::unique_ptr<google::cloud::support::v2::CaseService::StubInterface>
      grpc_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace support_v2_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_INTERNAL_CASE_STUB_H
