// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dataplex/v1/service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdataplex_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdataplex_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/dataplex/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dataplex {
namespace v1 {

// Dataplex service provides data lakes as a service. The primary resources
// offered by this service are Lakes, Zones and Assets which collectively allow
// a data administrator to organize, manage, secure and catalog data across
// their organization located across cloud projects in a variety of storage
// systems including Cloud Storage and BigQuery.
class DataplexService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dataplex.v1.DataplexService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a lake resource.
    virtual ::grpc::Status CreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateLakeRaw(context, request, cq));
    }
    // Updates a lake resource.
    virtual ::grpc::Status UpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateLakeRaw(context, request, cq));
    }
    // Deletes a lake resource. All zones within the lake must be deleted before
    // the lake can be deleted.
    virtual ::grpc::Status DeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteLakeRaw(context, request, cq));
    }
    // Lists lake resources in a project and location.
    virtual ::grpc::Status ListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::google::cloud::dataplex::v1::ListLakesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListLakesResponse>> AsyncListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListLakesResponse>>(AsyncListLakesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListLakesResponse>> PrepareAsyncListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListLakesResponse>>(PrepareAsyncListLakesRaw(context, request, cq));
    }
    // Retrieves a lake resource.
    virtual ::grpc::Status GetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::google::cloud::dataplex::v1::Lake* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Lake>> AsyncGetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Lake>>(AsyncGetLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Lake>> PrepareAsyncGetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Lake>>(PrepareAsyncGetLakeRaw(context, request, cq));
    }
    // Lists action resources in a lake.
    virtual ::grpc::Status ListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::google::cloud::dataplex::v1::ListActionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>> AsyncListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>>(AsyncListLakeActionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>> PrepareAsyncListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>>(PrepareAsyncListLakeActionsRaw(context, request, cq));
    }
    // Creates a zone resource within a lake.
    virtual ::grpc::Status CreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateZoneRaw(context, request, cq));
    }
    // Updates a zone resource.
    virtual ::grpc::Status UpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateZoneRaw(context, request, cq));
    }
    // Deletes a zone resource. All assets within a zone must be deleted before
    // the zone can be deleted.
    virtual ::grpc::Status DeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteZoneRaw(context, request, cq));
    }
    // Lists zone resources in a lake.
    virtual ::grpc::Status ListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::google::cloud::dataplex::v1::ListZonesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListZonesResponse>> AsyncListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListZonesResponse>>(AsyncListZonesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListZonesResponse>> PrepareAsyncListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListZonesResponse>>(PrepareAsyncListZonesRaw(context, request, cq));
    }
    // Retrieves a zone resource.
    virtual ::grpc::Status GetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::google::cloud::dataplex::v1::Zone* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Zone>> AsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Zone>>(AsyncGetZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Zone>> PrepareAsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Zone>>(PrepareAsyncGetZoneRaw(context, request, cq));
    }
    // Lists action resources in a zone.
    virtual ::grpc::Status ListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::google::cloud::dataplex::v1::ListActionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>> AsyncListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>>(AsyncListZoneActionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>> PrepareAsyncListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>>(PrepareAsyncListZoneActionsRaw(context, request, cq));
    }
    // Creates an asset resource.
    virtual ::grpc::Status CreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAssetRaw(context, request, cq));
    }
    // Updates an asset resource.
    virtual ::grpc::Status UpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAssetRaw(context, request, cq));
    }
    // Deletes an asset resource. The referenced storage resource is detached
    // (default) or deleted based on the associated Lifecycle policy.
    virtual ::grpc::Status DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAssetRaw(context, request, cq));
    }
    // Lists asset resources in a zone.
    virtual ::grpc::Status ListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::google::cloud::dataplex::v1::ListAssetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListAssetsResponse>> AsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListAssetsResponse>>(AsyncListAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListAssetsResponse>> PrepareAsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListAssetsResponse>>(PrepareAsyncListAssetsRaw(context, request, cq));
    }
    // Retrieves an asset resource.
    virtual ::grpc::Status GetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::google::cloud::dataplex::v1::Asset* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Asset>> AsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Asset>>(AsyncGetAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Asset>> PrepareAsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Asset>>(PrepareAsyncGetAssetRaw(context, request, cq));
    }
    // Lists action resources in an asset.
    virtual ::grpc::Status ListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::google::cloud::dataplex::v1::ListActionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>> AsyncListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>>(AsyncListAssetActionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>> PrepareAsyncListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>>(PrepareAsyncListAssetActionsRaw(context, request, cq));
    }
    // Creates a task resource within a lake.
    virtual ::grpc::Status CreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateTaskRaw(context, request, cq));
    }
    // Update the task resource.
    virtual ::grpc::Status UpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateTaskRaw(context, request, cq));
    }
    // Delete the task resource.
    virtual ::grpc::Status DeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTaskRaw(context, request, cq));
    }
    // Lists tasks under the given lake.
    virtual ::grpc::Status ListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::google::cloud::dataplex::v1::ListTasksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListTasksResponse>> AsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListTasksResponse>>(AsyncListTasksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListTasksResponse>> PrepareAsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListTasksResponse>>(PrepareAsyncListTasksRaw(context, request, cq));
    }
    // Get task resource.
    virtual ::grpc::Status GetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::google::cloud::dataplex::v1::Task* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Task>> AsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Task>>(AsyncGetTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Task>> PrepareAsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Task>>(PrepareAsyncGetTaskRaw(context, request, cq));
    }
    // Lists Jobs under the given task.
    virtual ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::google::cloud::dataplex::v1::ListJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    // Run an on demand execution of a Task.
    virtual ::grpc::Status RunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::google::cloud::dataplex::v1::RunTaskResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::RunTaskResponse>> AsyncRunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::RunTaskResponse>>(AsyncRunTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::RunTaskResponse>> PrepareAsyncRunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::RunTaskResponse>>(PrepareAsyncRunTaskRaw(context, request, cq));
    }
    // Get job resource.
    virtual ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::google::cloud::dataplex::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    // Cancel jobs running for the task resource.
    virtual ::grpc::Status CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncCancelJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncCancelJobRaw(context, request, cq));
    }
    // Create an environment resource.
    virtual ::grpc::Status CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateEnvironmentRaw(context, request, cq));
    }
    // Update the environment resource.
    virtual ::grpc::Status UpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateEnvironmentRaw(context, request, cq));
    }
    // Delete the environment resource. All the child resources must have been
    // deleted before environment deletion can be initiated.
    virtual ::grpc::Status DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteEnvironmentRaw(context, request, cq));
    }
    // Lists environments under the given lake.
    virtual ::grpc::Status ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>> AsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>>(AsyncListEnvironmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>> PrepareAsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>>(PrepareAsyncListEnvironmentsRaw(context, request, cq));
    }
    // Get environment resource.
    virtual ::grpc::Status GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::google::cloud::dataplex::v1::Environment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Environment>> AsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Environment>>(AsyncGetEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Environment>> PrepareAsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Environment>>(PrepareAsyncGetEnvironmentRaw(context, request, cq));
    }
    // Lists session resources in an environment.
    virtual ::grpc::Status ListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::google::cloud::dataplex::v1::ListSessionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListSessionsResponse>> AsyncListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListSessionsResponse>>(AsyncListSessionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListSessionsResponse>> PrepareAsyncListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListSessionsResponse>>(PrepareAsyncListSessionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a lake resource.
      virtual void CreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a lake resource.
      virtual void UpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a lake resource. All zones within the lake must be deleted before
      // the lake can be deleted.
      virtual void DeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists lake resources in a project and location.
      virtual void ListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest* request, ::google::cloud::dataplex::v1::ListLakesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest* request, ::google::cloud::dataplex::v1::ListLakesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a lake resource.
      virtual void GetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest* request, ::google::cloud::dataplex::v1::Lake* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest* request, ::google::cloud::dataplex::v1::Lake* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists action resources in a lake.
      virtual void ListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a zone resource within a lake.
      virtual void CreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a zone resource.
      virtual void UpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a zone resource. All assets within a zone must be deleted before
      // the zone can be deleted.
      virtual void DeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists zone resources in a lake.
      virtual void ListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest* request, ::google::cloud::dataplex::v1::ListZonesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest* request, ::google::cloud::dataplex::v1::ListZonesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a zone resource.
      virtual void GetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest* request, ::google::cloud::dataplex::v1::Zone* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest* request, ::google::cloud::dataplex::v1::Zone* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists action resources in a zone.
      virtual void ListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an asset resource.
      virtual void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an asset resource.
      virtual void UpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an asset resource. The referenced storage resource is detached
      // (default) or deleted based on the associated Lifecycle policy.
      virtual void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists asset resources in a zone.
      virtual void ListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::google::cloud::dataplex::v1::ListAssetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::google::cloud::dataplex::v1::ListAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves an asset resource.
      virtual void GetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest* request, ::google::cloud::dataplex::v1::Asset* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest* request, ::google::cloud::dataplex::v1::Asset* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists action resources in an asset.
      virtual void ListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a task resource within a lake.
      virtual void CreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update the task resource.
      virtual void UpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete the task resource.
      virtual void DeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists tasks under the given lake.
      virtual void ListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest* request, ::google::cloud::dataplex::v1::ListTasksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest* request, ::google::cloud::dataplex::v1::ListTasksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get task resource.
      virtual void GetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest* request, ::google::cloud::dataplex::v1::Task* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest* request, ::google::cloud::dataplex::v1::Task* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Jobs under the given task.
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest* request, ::google::cloud::dataplex::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest* request, ::google::cloud::dataplex::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Run an on demand execution of a Task.
      virtual void RunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest* request, ::google::cloud::dataplex::v1::RunTaskResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest* request, ::google::cloud::dataplex::v1::RunTaskResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get job resource.
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest* request, ::google::cloud::dataplex::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest* request, ::google::cloud::dataplex::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancel jobs running for the task resource.
      virtual void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create an environment resource.
      virtual void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update the environment resource.
      virtual void UpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete the environment resource. All the child resources must have been
      // deleted before environment deletion can be initiated.
      virtual void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists environments under the given lake.
      virtual void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get environment resource.
      virtual void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::google::cloud::dataplex::v1::Environment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::google::cloud::dataplex::v1::Environment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists session resources in an environment.
      virtual void ListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::google::cloud::dataplex::v1::ListSessionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::google::cloud::dataplex::v1::ListSessionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListLakesResponse>* AsyncListLakesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListLakesResponse>* PrepareAsyncListLakesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Lake>* AsyncGetLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Lake>* PrepareAsyncGetLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>* AsyncListLakeActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>* PrepareAsyncListLakeActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListZonesResponse>* AsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListZonesResponse>* PrepareAsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Zone>* AsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Zone>* PrepareAsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>* AsyncListZoneActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>* PrepareAsyncListZoneActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListAssetsResponse>* AsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListAssetsResponse>* PrepareAsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Asset>* AsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Asset>* PrepareAsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>* AsyncListAssetActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListActionsResponse>* PrepareAsyncListAssetActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListTasksResponse>* AsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListTasksResponse>* PrepareAsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Task>* AsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Task>* PrepareAsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::RunTaskResponse>* AsyncRunTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::RunTaskResponse>* PrepareAsyncRunTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* AsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* PrepareAsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Environment>* AsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::Environment>* PrepareAsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListSessionsResponse>* AsyncListSessionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dataplex::v1::ListSessionsResponse>* PrepareAsyncListSessionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateLakeRaw(context, request, cq));
    }
    ::grpc::Status UpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateLakeRaw(context, request, cq));
    }
    ::grpc::Status DeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteLakeRaw(context, request, cq));
    }
    ::grpc::Status ListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::google::cloud::dataplex::v1::ListLakesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListLakesResponse>> AsyncListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListLakesResponse>>(AsyncListLakesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListLakesResponse>> PrepareAsyncListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListLakesResponse>>(PrepareAsyncListLakesRaw(context, request, cq));
    }
    ::grpc::Status GetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::google::cloud::dataplex::v1::Lake* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Lake>> AsyncGetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Lake>>(AsyncGetLakeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Lake>> PrepareAsyncGetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Lake>>(PrepareAsyncGetLakeRaw(context, request, cq));
    }
    ::grpc::Status ListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::google::cloud::dataplex::v1::ListActionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>> AsyncListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>>(AsyncListLakeActionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>> PrepareAsyncListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>>(PrepareAsyncListLakeActionsRaw(context, request, cq));
    }
    ::grpc::Status CreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateZoneRaw(context, request, cq));
    }
    ::grpc::Status UpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateZoneRaw(context, request, cq));
    }
    ::grpc::Status DeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteZoneRaw(context, request, cq));
    }
    ::grpc::Status ListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::google::cloud::dataplex::v1::ListZonesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListZonesResponse>> AsyncListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListZonesResponse>>(AsyncListZonesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListZonesResponse>> PrepareAsyncListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListZonesResponse>>(PrepareAsyncListZonesRaw(context, request, cq));
    }
    ::grpc::Status GetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::google::cloud::dataplex::v1::Zone* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Zone>> AsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Zone>>(AsyncGetZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Zone>> PrepareAsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Zone>>(PrepareAsyncGetZoneRaw(context, request, cq));
    }
    ::grpc::Status ListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::google::cloud::dataplex::v1::ListActionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>> AsyncListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>>(AsyncListZoneActionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>> PrepareAsyncListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>>(PrepareAsyncListZoneActionsRaw(context, request, cq));
    }
    ::grpc::Status CreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAssetRaw(context, request, cq));
    }
    ::grpc::Status UpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAssetRaw(context, request, cq));
    }
    ::grpc::Status DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAssetRaw(context, request, cq));
    }
    ::grpc::Status ListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::google::cloud::dataplex::v1::ListAssetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListAssetsResponse>> AsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListAssetsResponse>>(AsyncListAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListAssetsResponse>> PrepareAsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListAssetsResponse>>(PrepareAsyncListAssetsRaw(context, request, cq));
    }
    ::grpc::Status GetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::google::cloud::dataplex::v1::Asset* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Asset>> AsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Asset>>(AsyncGetAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Asset>> PrepareAsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Asset>>(PrepareAsyncGetAssetRaw(context, request, cq));
    }
    ::grpc::Status ListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::google::cloud::dataplex::v1::ListActionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>> AsyncListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>>(AsyncListAssetActionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>> PrepareAsyncListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>>(PrepareAsyncListAssetActionsRaw(context, request, cq));
    }
    ::grpc::Status CreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateTaskRaw(context, request, cq));
    }
    ::grpc::Status UpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateTaskRaw(context, request, cq));
    }
    ::grpc::Status DeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTaskRaw(context, request, cq));
    }
    ::grpc::Status ListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::google::cloud::dataplex::v1::ListTasksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListTasksResponse>> AsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListTasksResponse>>(AsyncListTasksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListTasksResponse>> PrepareAsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListTasksResponse>>(PrepareAsyncListTasksRaw(context, request, cq));
    }
    ::grpc::Status GetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::google::cloud::dataplex::v1::Task* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Task>> AsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Task>>(AsyncGetTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Task>> PrepareAsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Task>>(PrepareAsyncGetTaskRaw(context, request, cq));
    }
    ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::google::cloud::dataplex::v1::ListJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    ::grpc::Status RunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::google::cloud::dataplex::v1::RunTaskResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::RunTaskResponse>> AsyncRunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::RunTaskResponse>>(AsyncRunTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::RunTaskResponse>> PrepareAsyncRunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::RunTaskResponse>>(PrepareAsyncRunTaskRaw(context, request, cq));
    }
    ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::google::cloud::dataplex::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    ::grpc::Status CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncCancelJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncCancelJobRaw(context, request, cq));
    }
    ::grpc::Status CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status UpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>> AsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>>(AsyncListEnvironmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>> PrepareAsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>>(PrepareAsyncListEnvironmentsRaw(context, request, cq));
    }
    ::grpc::Status GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::google::cloud::dataplex::v1::Environment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Environment>> AsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Environment>>(AsyncGetEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Environment>> PrepareAsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Environment>>(PrepareAsyncGetEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status ListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::google::cloud::dataplex::v1::ListSessionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListSessionsResponse>> AsyncListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListSessionsResponse>>(AsyncListSessionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListSessionsResponse>> PrepareAsyncListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListSessionsResponse>>(PrepareAsyncListSessionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest* request, ::google::cloud::dataplex::v1::ListLakesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListLakes(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest* request, ::google::cloud::dataplex::v1::ListLakesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest* request, ::google::cloud::dataplex::v1::Lake* response, std::function<void(::grpc::Status)>) override;
      void GetLake(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest* request, ::google::cloud::dataplex::v1::Lake* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListLakeActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest* request, ::google::cloud::dataplex::v1::ListZonesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListZones(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest* request, ::google::cloud::dataplex::v1::ListZonesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest* request, ::google::cloud::dataplex::v1::Zone* response, std::function<void(::grpc::Status)>) override;
      void GetZone(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest* request, ::google::cloud::dataplex::v1::Zone* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListZoneActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::google::cloud::dataplex::v1::ListAssetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAssets(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::google::cloud::dataplex::v1::ListAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest* request, ::google::cloud::dataplex::v1::Asset* response, std::function<void(::grpc::Status)>) override;
      void GetAsset(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest* request, ::google::cloud::dataplex::v1::Asset* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAssetActions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest* request, ::google::cloud::dataplex::v1::ListTasksResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTasks(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest* request, ::google::cloud::dataplex::v1::ListTasksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest* request, ::google::cloud::dataplex::v1::Task* response, std::function<void(::grpc::Status)>) override;
      void GetTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest* request, ::google::cloud::dataplex::v1::Task* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest* request, ::google::cloud::dataplex::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest* request, ::google::cloud::dataplex::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest* request, ::google::cloud::dataplex::v1::RunTaskResponse* response, std::function<void(::grpc::Status)>) override;
      void RunTask(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest* request, ::google::cloud::dataplex::v1::RunTaskResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest* request, ::google::cloud::dataplex::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest* request, ::google::cloud::dataplex::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void CancelJob(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::google::cloud::dataplex::v1::Environment* response, std::function<void(::grpc::Status)>) override;
      void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::google::cloud::dataplex::v1::Environment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::google::cloud::dataplex::v1::ListSessionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSessions(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::google::cloud::dataplex::v1::ListSessionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListLakesResponse>* AsyncListLakesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListLakesResponse>* PrepareAsyncListLakesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Lake>* AsyncGetLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Lake>* PrepareAsyncGetLakeRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>* AsyncListLakeActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>* PrepareAsyncListLakeActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListZonesResponse>* AsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListZonesResponse>* PrepareAsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Zone>* AsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Zone>* PrepareAsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>* AsyncListZoneActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>* PrepareAsyncListZoneActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListAssetsResponse>* AsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListAssetsResponse>* PrepareAsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Asset>* AsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Asset>* PrepareAsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>* AsyncListAssetActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListActionsResponse>* PrepareAsyncListAssetActionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListTasksResponse>* AsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListTasksResponse>* PrepareAsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Task>* AsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Task>* PrepareAsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::RunTaskResponse>* AsyncRunTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::RunTaskResponse>* PrepareAsyncRunTaskRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* AsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* PrepareAsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Environment>* AsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::Environment>* PrepareAsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListSessionsResponse>* AsyncListSessionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dataplex::v1::ListSessionsResponse>* PrepareAsyncListSessionsRaw(::grpc::ClientContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateLake_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateLake_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteLake_;
    const ::grpc::internal::RpcMethod rpcmethod_ListLakes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLake_;
    const ::grpc::internal::RpcMethod rpcmethod_ListLakeActions_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateZone_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateZone_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteZone_;
    const ::grpc::internal::RpcMethod rpcmethod_ListZones_;
    const ::grpc::internal::RpcMethod rpcmethod_GetZone_;
    const ::grpc::internal::RpcMethod rpcmethod_ListZoneActions_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAssets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAssetActions_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTask_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTask_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTask_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTasks_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTask_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_RunTask_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEnvironments_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSessions_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a lake resource.
    virtual ::grpc::Status CreateLake(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::google::longrunning::Operation* response);
    // Updates a lake resource.
    virtual ::grpc::Status UpdateLake(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::google::longrunning::Operation* response);
    // Deletes a lake resource. All zones within the lake must be deleted before
    // the lake can be deleted.
    virtual ::grpc::Status DeleteLake(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::google::longrunning::Operation* response);
    // Lists lake resources in a project and location.
    virtual ::grpc::Status ListLakes(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest* request, ::google::cloud::dataplex::v1::ListLakesResponse* response);
    // Retrieves a lake resource.
    virtual ::grpc::Status GetLake(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest* request, ::google::cloud::dataplex::v1::Lake* response);
    // Lists action resources in a lake.
    virtual ::grpc::Status ListLakeActions(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response);
    // Creates a zone resource within a lake.
    virtual ::grpc::Status CreateZone(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::google::longrunning::Operation* response);
    // Updates a zone resource.
    virtual ::grpc::Status UpdateZone(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::google::longrunning::Operation* response);
    // Deletes a zone resource. All assets within a zone must be deleted before
    // the zone can be deleted.
    virtual ::grpc::Status DeleteZone(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::google::longrunning::Operation* response);
    // Lists zone resources in a lake.
    virtual ::grpc::Status ListZones(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest* request, ::google::cloud::dataplex::v1::ListZonesResponse* response);
    // Retrieves a zone resource.
    virtual ::grpc::Status GetZone(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest* request, ::google::cloud::dataplex::v1::Zone* response);
    // Lists action resources in a zone.
    virtual ::grpc::Status ListZoneActions(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response);
    // Creates an asset resource.
    virtual ::grpc::Status CreateAsset(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response);
    // Updates an asset resource.
    virtual ::grpc::Status UpdateAsset(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::google::longrunning::Operation* response);
    // Deletes an asset resource. The referenced storage resource is detached
    // (default) or deleted based on the associated Lifecycle policy.
    virtual ::grpc::Status DeleteAsset(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response);
    // Lists asset resources in a zone.
    virtual ::grpc::Status ListAssets(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::google::cloud::dataplex::v1::ListAssetsResponse* response);
    // Retrieves an asset resource.
    virtual ::grpc::Status GetAsset(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest* request, ::google::cloud::dataplex::v1::Asset* response);
    // Lists action resources in an asset.
    virtual ::grpc::Status ListAssetActions(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response);
    // Creates a task resource within a lake.
    virtual ::grpc::Status CreateTask(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::google::longrunning::Operation* response);
    // Update the task resource.
    virtual ::grpc::Status UpdateTask(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::google::longrunning::Operation* response);
    // Delete the task resource.
    virtual ::grpc::Status DeleteTask(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::google::longrunning::Operation* response);
    // Lists tasks under the given lake.
    virtual ::grpc::Status ListTasks(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest* request, ::google::cloud::dataplex::v1::ListTasksResponse* response);
    // Get task resource.
    virtual ::grpc::Status GetTask(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest* request, ::google::cloud::dataplex::v1::Task* response);
    // Lists Jobs under the given task.
    virtual ::grpc::Status ListJobs(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest* request, ::google::cloud::dataplex::v1::ListJobsResponse* response);
    // Run an on demand execution of a Task.
    virtual ::grpc::Status RunTask(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest* request, ::google::cloud::dataplex::v1::RunTaskResponse* response);
    // Get job resource.
    virtual ::grpc::Status GetJob(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::GetJobRequest* request, ::google::cloud::dataplex::v1::Job* response);
    // Cancel jobs running for the task resource.
    virtual ::grpc::Status CancelJob(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest* request, ::google::protobuf::Empty* response);
    // Create an environment resource.
    virtual ::grpc::Status CreateEnvironment(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Update the environment resource.
    virtual ::grpc::Status UpdateEnvironment(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Delete the environment resource. All the child resources must have been
    // deleted before environment deletion can be initiated.
    virtual ::grpc::Status DeleteEnvironment(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Lists environments under the given lake.
    virtual ::grpc::Status ListEnvironments(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response);
    // Get environment resource.
    virtual ::grpc::Status GetEnvironment(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::google::cloud::dataplex::v1::Environment* response);
    // Lists session resources in an environment.
    virtual ::grpc::Status ListSessions(::grpc::ServerContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::google::cloud::dataplex::v1::ListSessionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateLake() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLake(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateLake() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateLake(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteLake() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLake(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListLakes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListLakes() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListLakes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakes(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLakes(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListLakesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListLakesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLake() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLake(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::GetLakeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::Lake>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListLakeActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListLakeActions() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListLakeActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakeActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLakeActions(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListActionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateZone() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateZone(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateZone() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateZone(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteZone() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeleteZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteZone(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListZones() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListZones(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListZonesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListZonesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetZone() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetZone(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::GetZoneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::Zone>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListZoneActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListZoneActions() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListZoneActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZoneActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListZoneActions(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListActionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAsset() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAsset(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAsset() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_UpdateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAsset(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAsset(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAssets() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssets(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListAssetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAsset() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAsset(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::GetAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::Asset>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAssetActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAssetActions() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_ListAssetActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssetActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssetActions(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListActionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTask() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CreateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTask(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTask() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_UpdateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTask(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTask() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_DeleteTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTask(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTasks() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTasks(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListTasksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListTasksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTask() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTask(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::GetTaskRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::Task>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobs() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RunTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RunTask() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_RunTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunTask(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::RunTaskRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::RunTaskResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJob() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::GetJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelJob() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelJob(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::CancelJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEnvironment(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEnvironment() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_UpdateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEnvironment(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEnvironment(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEnvironments(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEnvironment(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::Environment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSessions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSessions() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_ListSessions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSessions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSessions(::grpc::ServerContext* context, ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dataplex::v1::ListSessionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateLake<WithAsyncMethod_UpdateLake<WithAsyncMethod_DeleteLake<WithAsyncMethod_ListLakes<WithAsyncMethod_GetLake<WithAsyncMethod_ListLakeActions<WithAsyncMethod_CreateZone<WithAsyncMethod_UpdateZone<WithAsyncMethod_DeleteZone<WithAsyncMethod_ListZones<WithAsyncMethod_GetZone<WithAsyncMethod_ListZoneActions<WithAsyncMethod_CreateAsset<WithAsyncMethod_UpdateAsset<WithAsyncMethod_DeleteAsset<WithAsyncMethod_ListAssets<WithAsyncMethod_GetAsset<WithAsyncMethod_ListAssetActions<WithAsyncMethod_CreateTask<WithAsyncMethod_UpdateTask<WithAsyncMethod_DeleteTask<WithAsyncMethod_ListTasks<WithAsyncMethod_GetTask<WithAsyncMethod_ListJobs<WithAsyncMethod_RunTask<WithAsyncMethod_GetJob<WithAsyncMethod_CancelJob<WithAsyncMethod_CreateEnvironment<WithAsyncMethod_UpdateEnvironment<WithAsyncMethod_DeleteEnvironment<WithAsyncMethod_ListEnvironments<WithAsyncMethod_GetEnvironment<WithAsyncMethod_ListSessions<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateLake() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateLakeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::CreateLakeRequest* request, ::google::longrunning::Operation* response) { return this->CreateLake(context, request, response); }));}
    void SetMessageAllocatorFor_CreateLake(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::CreateLakeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateLakeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLake(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateLake() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateLakeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::UpdateLakeRequest* request, ::google::longrunning::Operation* response) { return this->UpdateLake(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateLake(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::UpdateLakeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateLakeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateLake(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteLake() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteLakeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::DeleteLakeRequest* request, ::google::longrunning::Operation* response) { return this->DeleteLake(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteLake(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::DeleteLakeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteLakeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLake(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListLakes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListLakes() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListLakesRequest, ::google::cloud::dataplex::v1::ListLakesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListLakesRequest* request, ::google::cloud::dataplex::v1::ListLakesResponse* response) { return this->ListLakes(context, request, response); }));}
    void SetMessageAllocatorFor_ListLakes(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListLakesRequest, ::google::cloud::dataplex::v1::ListLakesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListLakesRequest, ::google::cloud::dataplex::v1::ListLakesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListLakes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakes(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLakes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLake() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetLakeRequest, ::google::cloud::dataplex::v1::Lake>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::GetLakeRequest* request, ::google::cloud::dataplex::v1::Lake* response) { return this->GetLake(context, request, response); }));}
    void SetMessageAllocatorFor_GetLake(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::GetLakeRequest, ::google::cloud::dataplex::v1::Lake>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetLakeRequest, ::google::cloud::dataplex::v1::Lake>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLake(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListLakeActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListLakeActions() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListLakeActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response) { return this->ListLakeActions(context, request, response); }));}
    void SetMessageAllocatorFor_ListLakeActions(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListLakeActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListLakeActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListLakeActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakeActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLakeActions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateZone() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateZoneRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::CreateZoneRequest* request, ::google::longrunning::Operation* response) { return this->CreateZone(context, request, response); }));}
    void SetMessageAllocatorFor_CreateZone(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::CreateZoneRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateZoneRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateZone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateZone() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateZoneRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::UpdateZoneRequest* request, ::google::longrunning::Operation* response) { return this->UpdateZone(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateZone(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::UpdateZoneRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateZoneRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateZone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteZone() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteZoneRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::DeleteZoneRequest* request, ::google::longrunning::Operation* response) { return this->DeleteZone(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteZone(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::DeleteZoneRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteZoneRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteZone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListZones() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListZonesRequest, ::google::cloud::dataplex::v1::ListZonesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListZonesRequest* request, ::google::cloud::dataplex::v1::ListZonesResponse* response) { return this->ListZones(context, request, response); }));}
    void SetMessageAllocatorFor_ListZones(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListZonesRequest, ::google::cloud::dataplex::v1::ListZonesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListZonesRequest, ::google::cloud::dataplex::v1::ListZonesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListZones(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetZone() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetZoneRequest, ::google::cloud::dataplex::v1::Zone>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::GetZoneRequest* request, ::google::cloud::dataplex::v1::Zone* response) { return this->GetZone(context, request, response); }));}
    void SetMessageAllocatorFor_GetZone(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::GetZoneRequest, ::google::cloud::dataplex::v1::Zone>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetZoneRequest, ::google::cloud::dataplex::v1::Zone>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetZone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListZoneActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListZoneActions() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListZoneActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response) { return this->ListZoneActions(context, request, response); }));}
    void SetMessageAllocatorFor_ListZoneActions(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListZoneActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListZoneActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListZoneActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZoneActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListZoneActions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAsset() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateAssetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response) { return this->CreateAsset(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAsset(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::CreateAssetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateAssetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAsset() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateAssetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::UpdateAssetRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAsset(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAsset(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::UpdateAssetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateAssetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteAssetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAsset(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAsset(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::DeleteAssetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteAssetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAssets() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListAssetsRequest, ::google::cloud::dataplex::v1::ListAssetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListAssetsRequest* request, ::google::cloud::dataplex::v1::ListAssetsResponse* response) { return this->ListAssets(context, request, response); }));}
    void SetMessageAllocatorFor_ListAssets(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListAssetsRequest, ::google::cloud::dataplex::v1::ListAssetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListAssetsRequest, ::google::cloud::dataplex::v1::ListAssetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAsset() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetAssetRequest, ::google::cloud::dataplex::v1::Asset>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::GetAssetRequest* request, ::google::cloud::dataplex::v1::Asset* response) { return this->GetAsset(context, request, response); }));}
    void SetMessageAllocatorFor_GetAsset(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::GetAssetRequest, ::google::cloud::dataplex::v1::Asset>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetAssetRequest, ::google::cloud::dataplex::v1::Asset>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAssetActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAssetActions() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListAssetActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* request, ::google::cloud::dataplex::v1::ListActionsResponse* response) { return this->ListAssetActions(context, request, response); }));}
    void SetMessageAllocatorFor_ListAssetActions(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListAssetActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListAssetActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAssetActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssetActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssetActions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTask() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateTaskRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::CreateTaskRequest* request, ::google::longrunning::Operation* response) { return this->CreateTask(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTask(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::CreateTaskRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateTaskRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTask(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTask() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateTaskRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::UpdateTaskRequest* request, ::google::longrunning::Operation* response) { return this->UpdateTask(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTask(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::UpdateTaskRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateTaskRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTask(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTask() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteTaskRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::DeleteTaskRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTask(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTask(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::DeleteTaskRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteTaskRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTask(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTasks() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListTasksRequest, ::google::cloud::dataplex::v1::ListTasksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListTasksRequest* request, ::google::cloud::dataplex::v1::ListTasksResponse* response) { return this->ListTasks(context, request, response); }));}
    void SetMessageAllocatorFor_ListTasks(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListTasksRequest, ::google::cloud::dataplex::v1::ListTasksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListTasksRequest, ::google::cloud::dataplex::v1::ListTasksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTasks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTask() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetTaskRequest, ::google::cloud::dataplex::v1::Task>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::GetTaskRequest* request, ::google::cloud::dataplex::v1::Task* response) { return this->GetTask(context, request, response); }));}
    void SetMessageAllocatorFor_GetTask(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::GetTaskRequest, ::google::cloud::dataplex::v1::Task>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetTaskRequest, ::google::cloud::dataplex::v1::Task>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTask(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListJobsRequest, ::google::cloud::dataplex::v1::ListJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListJobsRequest* request, ::google::cloud::dataplex::v1::ListJobsResponse* response) { return this->ListJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobs(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListJobsRequest, ::google::cloud::dataplex::v1::ListJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListJobsRequest, ::google::cloud::dataplex::v1::ListJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RunTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RunTask() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::RunTaskRequest, ::google::cloud::dataplex::v1::RunTaskResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::RunTaskRequest* request, ::google::cloud::dataplex::v1::RunTaskResponse* response) { return this->RunTask(context, request, response); }));}
    void SetMessageAllocatorFor_RunTask(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::RunTaskRequest, ::google::cloud::dataplex::v1::RunTaskResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::RunTaskRequest, ::google::cloud::dataplex::v1::RunTaskResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RunTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunTask(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetJobRequest, ::google::cloud::dataplex::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::GetJobRequest* request, ::google::cloud::dataplex::v1::Job* response) { return this->GetJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetJob(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::GetJobRequest, ::google::cloud::dataplex::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetJobRequest, ::google::cloud::dataplex::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelJob() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CancelJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::CancelJobRequest* request, ::google::protobuf::Empty* response) { return this->CancelJob(context, request, response); }));}
    void SetMessageAllocatorFor_CancelJob(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::CancelJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CancelJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->CreateEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEnvironment() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->UpdateEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::UpdateEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::UpdateEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->DeleteEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListEnvironmentsRequest, ::google::cloud::dataplex::v1::ListEnvironmentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* request, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* response) { return this->ListEnvironments(context, request, response); }));}
    void SetMessageAllocatorFor_ListEnvironments(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListEnvironmentsRequest, ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListEnvironmentsRequest, ::google::cloud::dataplex::v1::ListEnvironmentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEnvironments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetEnvironmentRequest, ::google::cloud::dataplex::v1::Environment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* request, ::google::cloud::dataplex::v1::Environment* response) { return this->GetEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_GetEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::GetEnvironmentRequest, ::google::cloud::dataplex::v1::Environment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::GetEnvironmentRequest, ::google::cloud::dataplex::v1::Environment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSessions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSessions() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListSessionsRequest, ::google::cloud::dataplex::v1::ListSessionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dataplex::v1::ListSessionsRequest* request, ::google::cloud::dataplex::v1::ListSessionsResponse* response) { return this->ListSessions(context, request, response); }));}
    void SetMessageAllocatorFor_ListSessions(
        ::grpc::MessageAllocator< ::google::cloud::dataplex::v1::ListSessionsRequest, ::google::cloud::dataplex::v1::ListSessionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dataplex::v1::ListSessionsRequest, ::google::cloud::dataplex::v1::ListSessionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSessions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSessions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSessions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateLake<WithCallbackMethod_UpdateLake<WithCallbackMethod_DeleteLake<WithCallbackMethod_ListLakes<WithCallbackMethod_GetLake<WithCallbackMethod_ListLakeActions<WithCallbackMethod_CreateZone<WithCallbackMethod_UpdateZone<WithCallbackMethod_DeleteZone<WithCallbackMethod_ListZones<WithCallbackMethod_GetZone<WithCallbackMethod_ListZoneActions<WithCallbackMethod_CreateAsset<WithCallbackMethod_UpdateAsset<WithCallbackMethod_DeleteAsset<WithCallbackMethod_ListAssets<WithCallbackMethod_GetAsset<WithCallbackMethod_ListAssetActions<WithCallbackMethod_CreateTask<WithCallbackMethod_UpdateTask<WithCallbackMethod_DeleteTask<WithCallbackMethod_ListTasks<WithCallbackMethod_GetTask<WithCallbackMethod_ListJobs<WithCallbackMethod_RunTask<WithCallbackMethod_GetJob<WithCallbackMethod_CancelJob<WithCallbackMethod_CreateEnvironment<WithCallbackMethod_UpdateEnvironment<WithCallbackMethod_DeleteEnvironment<WithCallbackMethod_ListEnvironments<WithCallbackMethod_GetEnvironment<WithCallbackMethod_ListSessions<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateLake() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateLake() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteLake() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListLakes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListLakes() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListLakes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakes(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLake() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListLakeActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListLakeActions() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListLakeActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakeActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateZone() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateZone() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteZone() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeleteZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListZones() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetZone() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListZoneActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListZoneActions() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListZoneActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZoneActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAsset() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAsset() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_UpdateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAssets() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAsset() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAssetActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAssetActions() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_ListAssetActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssetActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTask() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CreateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTask() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_UpdateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTask() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_DeleteTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTasks() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTask() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobs() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RunTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RunTask() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_RunTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJob() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelJob() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEnvironment() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_UpdateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSessions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSessions() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_ListSessions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSessions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateLake() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLake(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateLake() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateLake(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteLake() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLake(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListLakes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListLakes() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListLakes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakes(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLakes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLake() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLake(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListLakeActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListLakeActions() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListLakeActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakeActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLakeActions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateZone() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateZone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateZone() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateZone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteZone() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeleteZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteZone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListZones() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListZones(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetZone() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetZone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListZoneActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListZoneActions() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListZoneActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZoneActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListZoneActions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAsset() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAsset() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_UpdateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAssets() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAsset() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAssetActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAssetActions() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_ListAssetActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssetActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssetActions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTask() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CreateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTask(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTask() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_UpdateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTask(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTask() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_DeleteTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTask(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTasks() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTasks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTask() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTask(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobs() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RunTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RunTask() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_RunTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunTask(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJob() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelJob() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEnvironment() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_UpdateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEnvironments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSessions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSessions() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_ListSessions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSessions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSessions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateLake() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateLake(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLake(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateLake() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateLake(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateLake(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteLake() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteLake(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLake(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListLakes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListLakes() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListLakes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListLakes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakes(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLakes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLake() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLake(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLake(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListLakeActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListLakeActions() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListLakeActions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListLakeActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLakeActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLakeActions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateZone() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateZone(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateZone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateZone() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateZone(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateZone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteZone() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteZone(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteZone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListZones() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListZones(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListZones(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetZone() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetZone(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetZone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListZoneActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListZoneActions() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListZoneActions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListZoneActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZoneActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListZoneActions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAsset() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAsset() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAssets() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAssets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAsset() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAssetActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAssetActions() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAssetActions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAssetActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssetActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssetActions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTask() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTask(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTask(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTask() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTask(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTask(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTask() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTask(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTask(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTasks() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTasks(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTasks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTask() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTask(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTask(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RunTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RunTask() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RunTask(context, request, response); }));
    }
    ~WithRawCallbackMethod_RunTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunTask(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelJob() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEnvironments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEnvironments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSessions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSessions() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSessions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSessions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSessions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSessions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateLake() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::CreateLakeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::CreateLakeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateLake(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateLake(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::CreateLakeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateLake() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::UpdateLakeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::UpdateLakeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateLake(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateLake(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::UpdateLakeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteLake() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::DeleteLakeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::DeleteLakeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteLake(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteLakeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteLake(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::DeleteLakeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListLakes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListLakes() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListLakesRequest, ::google::cloud::dataplex::v1::ListLakesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListLakesRequest, ::google::cloud::dataplex::v1::ListLakesResponse>* streamer) {
                       return this->StreamedListLakes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListLakes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListLakes(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakesRequest* /*request*/, ::google::cloud::dataplex::v1::ListLakesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListLakes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListLakesRequest,::google::cloud::dataplex::v1::ListLakesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLake : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLake() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::GetLakeRequest, ::google::cloud::dataplex::v1::Lake>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::GetLakeRequest, ::google::cloud::dataplex::v1::Lake>* streamer) {
                       return this->StreamedGetLake(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLake() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLake(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetLakeRequest* /*request*/, ::google::cloud::dataplex::v1::Lake* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLake(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::GetLakeRequest,::google::cloud::dataplex::v1::Lake>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListLakeActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListLakeActions() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListLakeActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListLakeActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>* streamer) {
                       return this->StreamedListLakeActions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListLakeActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListLakeActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListLakeActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListLakeActions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListLakeActionsRequest,::google::cloud::dataplex::v1::ListActionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateZone() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::CreateZoneRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::CreateZoneRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateZone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateZone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::CreateZoneRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateZone() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::UpdateZoneRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::UpdateZoneRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateZone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateZone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::UpdateZoneRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteZone() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::DeleteZoneRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::DeleteZoneRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteZone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteZoneRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteZone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::DeleteZoneRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListZones() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListZonesRequest, ::google::cloud::dataplex::v1::ListZonesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListZonesRequest, ::google::cloud::dataplex::v1::ListZonesResponse>* streamer) {
                       return this->StreamedListZones(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZonesRequest* /*request*/, ::google::cloud::dataplex::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListZones(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListZonesRequest,::google::cloud::dataplex::v1::ListZonesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetZone() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::GetZoneRequest, ::google::cloud::dataplex::v1::Zone>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::GetZoneRequest, ::google::cloud::dataplex::v1::Zone>* streamer) {
                       return this->StreamedGetZone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetZoneRequest* /*request*/, ::google::cloud::dataplex::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetZone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::GetZoneRequest,::google::cloud::dataplex::v1::Zone>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListZoneActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListZoneActions() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListZoneActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListZoneActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>* streamer) {
                       return this->StreamedListZoneActions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListZoneActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListZoneActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListZoneActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListZoneActions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListZoneActionsRequest,::google::cloud::dataplex::v1::ListActionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAsset() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::CreateAssetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::CreateAssetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::CreateAssetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAsset() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::UpdateAssetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::UpdateAssetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::UpdateAssetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::DeleteAssetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::DeleteAssetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::DeleteAssetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAssets() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListAssetsRequest, ::google::cloud::dataplex::v1::ListAssetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListAssetsRequest, ::google::cloud::dataplex::v1::ListAssetsResponse>* streamer) {
                       return this->StreamedListAssets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetsRequest* /*request*/, ::google::cloud::dataplex::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAssets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListAssetsRequest,::google::cloud::dataplex::v1::ListAssetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAsset() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::GetAssetRequest, ::google::cloud::dataplex::v1::Asset>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::GetAssetRequest, ::google::cloud::dataplex::v1::Asset>* streamer) {
                       return this->StreamedGetAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetAssetRequest* /*request*/, ::google::cloud::dataplex::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::GetAssetRequest,::google::cloud::dataplex::v1::Asset>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAssetActions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAssetActions() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListAssetActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListAssetActionsRequest, ::google::cloud::dataplex::v1::ListActionsResponse>* streamer) {
                       return this->StreamedListAssetActions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAssetActions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAssetActions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListAssetActionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListActionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAssetActions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListAssetActionsRequest,::google::cloud::dataplex::v1::ListActionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTask() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::CreateTaskRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::CreateTaskRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateTask(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTask(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::CreateTaskRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTask() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::UpdateTaskRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::UpdateTaskRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateTask(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTask(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::UpdateTaskRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTask() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::DeleteTaskRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::DeleteTaskRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTask(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteTaskRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTask(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::DeleteTaskRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTasks() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListTasksRequest, ::google::cloud::dataplex::v1::ListTasksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListTasksRequest, ::google::cloud::dataplex::v1::ListTasksResponse>* streamer) {
                       return this->StreamedListTasks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListTasksRequest* /*request*/, ::google::cloud::dataplex::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTasks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListTasksRequest,::google::cloud::dataplex::v1::ListTasksResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTask() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::GetTaskRequest, ::google::cloud::dataplex::v1::Task>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::GetTaskRequest, ::google::cloud::dataplex::v1::Task>* streamer) {
                       return this->StreamedGetTask(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetTaskRequest* /*request*/, ::google::cloud::dataplex::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTask(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::GetTaskRequest,::google::cloud::dataplex::v1::Task>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobs() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListJobsRequest, ::google::cloud::dataplex::v1::ListJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListJobsRequest, ::google::cloud::dataplex::v1::ListJobsResponse>* streamer) {
                       return this->StreamedListJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListJobsRequest* /*request*/, ::google::cloud::dataplex::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListJobsRequest,::google::cloud::dataplex::v1::ListJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RunTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RunTask() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::RunTaskRequest, ::google::cloud::dataplex::v1::RunTaskResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::RunTaskRequest, ::google::cloud::dataplex::v1::RunTaskResponse>* streamer) {
                       return this->StreamedRunTask(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RunTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RunTask(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::RunTaskRequest* /*request*/, ::google::cloud::dataplex::v1::RunTaskResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRunTask(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::RunTaskRequest,::google::cloud::dataplex::v1::RunTaskResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJob() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::GetJobRequest, ::google::cloud::dataplex::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::GetJobRequest, ::google::cloud::dataplex::v1::Job>* streamer) {
                       return this->StreamedGetJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetJobRequest* /*request*/, ::google::cloud::dataplex::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::GetJobRequest,::google::cloud::dataplex::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelJob() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::CancelJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::CancelJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedCancelJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CancelJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::CancelJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::CreateEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEnvironment() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::UpdateEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::UpdateEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::UpdateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::UpdateEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::DeleteEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListEnvironmentsRequest, ::google::cloud::dataplex::v1::ListEnvironmentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListEnvironmentsRequest, ::google::cloud::dataplex::v1::ListEnvironmentsResponse>* streamer) {
                       return this->StreamedListEnvironments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::dataplex::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEnvironments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListEnvironmentsRequest,::google::cloud::dataplex::v1::ListEnvironmentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::GetEnvironmentRequest, ::google::cloud::dataplex::v1::Environment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::GetEnvironmentRequest, ::google::cloud::dataplex::v1::Environment>* streamer) {
                       return this->StreamedGetEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::dataplex::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::GetEnvironmentRequest,::google::cloud::dataplex::v1::Environment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSessions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSessions() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dataplex::v1::ListSessionsRequest, ::google::cloud::dataplex::v1::ListSessionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dataplex::v1::ListSessionsRequest, ::google::cloud::dataplex::v1::ListSessionsResponse>* streamer) {
                       return this->StreamedListSessions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSessions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSessions(::grpc::ServerContext* /*context*/, const ::google::cloud::dataplex::v1::ListSessionsRequest* /*request*/, ::google::cloud::dataplex::v1::ListSessionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSessions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dataplex::v1::ListSessionsRequest,::google::cloud::dataplex::v1::ListSessionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateLake<WithStreamedUnaryMethod_UpdateLake<WithStreamedUnaryMethod_DeleteLake<WithStreamedUnaryMethod_ListLakes<WithStreamedUnaryMethod_GetLake<WithStreamedUnaryMethod_ListLakeActions<WithStreamedUnaryMethod_CreateZone<WithStreamedUnaryMethod_UpdateZone<WithStreamedUnaryMethod_DeleteZone<WithStreamedUnaryMethod_ListZones<WithStreamedUnaryMethod_GetZone<WithStreamedUnaryMethod_ListZoneActions<WithStreamedUnaryMethod_CreateAsset<WithStreamedUnaryMethod_UpdateAsset<WithStreamedUnaryMethod_DeleteAsset<WithStreamedUnaryMethod_ListAssets<WithStreamedUnaryMethod_GetAsset<WithStreamedUnaryMethod_ListAssetActions<WithStreamedUnaryMethod_CreateTask<WithStreamedUnaryMethod_UpdateTask<WithStreamedUnaryMethod_DeleteTask<WithStreamedUnaryMethod_ListTasks<WithStreamedUnaryMethod_GetTask<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_RunTask<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_CancelJob<WithStreamedUnaryMethod_CreateEnvironment<WithStreamedUnaryMethod_UpdateEnvironment<WithStreamedUnaryMethod_DeleteEnvironment<WithStreamedUnaryMethod_ListEnvironments<WithStreamedUnaryMethod_GetEnvironment<WithStreamedUnaryMethod_ListSessions<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateLake<WithStreamedUnaryMethod_UpdateLake<WithStreamedUnaryMethod_DeleteLake<WithStreamedUnaryMethod_ListLakes<WithStreamedUnaryMethod_GetLake<WithStreamedUnaryMethod_ListLakeActions<WithStreamedUnaryMethod_CreateZone<WithStreamedUnaryMethod_UpdateZone<WithStreamedUnaryMethod_DeleteZone<WithStreamedUnaryMethod_ListZones<WithStreamedUnaryMethod_GetZone<WithStreamedUnaryMethod_ListZoneActions<WithStreamedUnaryMethod_CreateAsset<WithStreamedUnaryMethod_UpdateAsset<WithStreamedUnaryMethod_DeleteAsset<WithStreamedUnaryMethod_ListAssets<WithStreamedUnaryMethod_GetAsset<WithStreamedUnaryMethod_ListAssetActions<WithStreamedUnaryMethod_CreateTask<WithStreamedUnaryMethod_UpdateTask<WithStreamedUnaryMethod_DeleteTask<WithStreamedUnaryMethod_ListTasks<WithStreamedUnaryMethod_GetTask<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_RunTask<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_CancelJob<WithStreamedUnaryMethod_CreateEnvironment<WithStreamedUnaryMethod_UpdateEnvironment<WithStreamedUnaryMethod_DeleteEnvironment<WithStreamedUnaryMethod_ListEnvironments<WithStreamedUnaryMethod_GetEnvironment<WithStreamedUnaryMethod_ListSessions<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace dataplex
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdataplex_2fv1_2fservice_2eproto__INCLUDED
