// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/deploy/v1/cloud_deploy.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdeploy_2fv1_2fcloud_5fdeploy_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdeploy_2fv1_2fcloud_5fdeploy_2eproto__INCLUDED

#include "google/cloud/deploy/v1/cloud_deploy.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace deploy {
namespace v1 {

// CloudDeploy service creates and manages Continuous Delivery operations
// on Google Cloud Platform via Skaffold (https://skaffold.dev).
class CloudDeploy final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.deploy.v1.CloudDeploy";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists DeliveryPipelines in a given project and location.
    virtual ::grpc::Status ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> AsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(AsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> PrepareAsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(PrepareAsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    // Gets details of a single DeliveryPipeline.
    virtual ::grpc::Status GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::google::cloud::deploy::v1::DeliveryPipeline* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>> AsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>>(AsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>> PrepareAsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>>(PrepareAsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    // Creates a new DeliveryPipeline in a given project and location.
    virtual ::grpc::Status CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    // Updates the parameters of a single DeliveryPipeline.
    virtual ::grpc::Status UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    // Deletes a single DeliveryPipeline.
    virtual ::grpc::Status DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    // Lists Targets in a given project and location.
    virtual ::grpc::Status ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::google::cloud::deploy::v1::ListTargetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>> AsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>>(AsyncListTargetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>> PrepareAsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>>(PrepareAsyncListTargetsRaw(context, request, cq));
    }
    // Gets details of a single Target.
    virtual ::grpc::Status GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::google::cloud::deploy::v1::Target* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>> AsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>>(AsyncGetTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>> PrepareAsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>>(PrepareAsyncGetTargetRaw(context, request, cq));
    }
    // Creates a new Target in a given project and location.
    virtual ::grpc::Status CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateTargetRaw(context, request, cq));
    }
    // Updates the parameters of a single Target.
    virtual ::grpc::Status UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateTargetRaw(context, request, cq));
    }
    // Deletes a single Target.
    virtual ::grpc::Status DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTargetRaw(context, request, cq));
    }
    // Lists Releases in a given project and location.
    virtual ::grpc::Status ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::google::cloud::deploy::v1::ListReleasesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>> AsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>>(AsyncListReleasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>> PrepareAsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>>(PrepareAsyncListReleasesRaw(context, request, cq));
    }
    // Gets details of a single Release.
    virtual ::grpc::Status GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::google::cloud::deploy::v1::Release* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>> AsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>>(AsyncGetReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>> PrepareAsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>>(PrepareAsyncGetReleaseRaw(context, request, cq));
    }
    // Creates a new Release in a given project and location.
    virtual ::grpc::Status CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateReleaseRaw(context, request, cq));
    }
    // Abandons a Release in the Delivery Pipeline.
    virtual ::grpc::Status AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>> AsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(AsyncAbandonReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>> PrepareAsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(PrepareAsyncAbandonReleaseRaw(context, request, cq));
    }
    // Approves a Rollout.
    virtual ::grpc::Status ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>> AsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(AsyncApproveRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>> PrepareAsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(PrepareAsyncApproveRolloutRaw(context, request, cq));
    }
    // Advances a Rollout in a given project and location.
    virtual ::grpc::Status AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> AsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(AsyncAdvanceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> PrepareAsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(PrepareAsyncAdvanceRolloutRaw(context, request, cq));
    }
    // Cancels a Rollout in a given project and location.
    virtual ::grpc::Status CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::google::cloud::deploy::v1::CancelRolloutResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>> AsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>>(AsyncCancelRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>> PrepareAsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>>(PrepareAsyncCancelRolloutRaw(context, request, cq));
    }
    // Lists Rollouts in a given project and location.
    virtual ::grpc::Status ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::google::cloud::deploy::v1::ListRolloutsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>> AsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>>(AsyncListRolloutsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>> PrepareAsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>>(PrepareAsyncListRolloutsRaw(context, request, cq));
    }
    // Gets details of a single Rollout.
    virtual ::grpc::Status GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::google::cloud::deploy::v1::Rollout* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>> AsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>>(AsyncGetRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>> PrepareAsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>>(PrepareAsyncGetRolloutRaw(context, request, cq));
    }
    // Creates a new Rollout in a given project and location.
    virtual ::grpc::Status CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateRolloutRaw(context, request, cq));
    }
    // Ignores the specified Job in a Rollout.
    virtual ::grpc::Status IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::google::cloud::deploy::v1::IgnoreJobResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>> AsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>>(AsyncIgnoreJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>> PrepareAsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>>(PrepareAsyncIgnoreJobRaw(context, request, cq));
    }
    // Retries the specified Job in a Rollout.
    virtual ::grpc::Status RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::google::cloud::deploy::v1::RetryJobResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>> AsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>>(AsyncRetryJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>> PrepareAsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>>(PrepareAsyncRetryJobRaw(context, request, cq));
    }
    // Lists JobRuns in a given project and location.
    virtual ::grpc::Status ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::google::cloud::deploy::v1::ListJobRunsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>> AsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>>(AsyncListJobRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>> PrepareAsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>>(PrepareAsyncListJobRunsRaw(context, request, cq));
    }
    // Gets details of a single JobRun.
    virtual ::grpc::Status GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::google::cloud::deploy::v1::JobRun* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>> AsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>>(AsyncGetJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>> PrepareAsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>>(PrepareAsyncGetJobRunRaw(context, request, cq));
    }
    // Terminates a Job Run in a given project and location.
    virtual ::grpc::Status TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>> AsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(AsyncTerminateJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>> PrepareAsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(PrepareAsyncTerminateJobRunRaw(context, request, cq));
    }
    // Gets the configuration for a location.
    virtual ::grpc::Status GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::google::cloud::deploy::v1::Config* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>> AsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>>(AsyncGetConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>> PrepareAsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>>(PrepareAsyncGetConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists DeliveryPipelines in a given project and location.
      virtual void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single DeliveryPipeline.
      virtual void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new DeliveryPipeline in a given project and location.
      virtual void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single DeliveryPipeline.
      virtual void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single DeliveryPipeline.
      virtual void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Targets in a given project and location.
      virtual void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Target.
      virtual void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Target in a given project and location.
      virtual void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single Target.
      virtual void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Target.
      virtual void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Releases in a given project and location.
      virtual void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Release.
      virtual void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Release in a given project and location.
      virtual void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Abandons a Release in the Delivery Pipeline.
      virtual void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Approves a Rollout.
      virtual void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Advances a Rollout in a given project and location.
      virtual void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels a Rollout in a given project and location.
      virtual void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Rollouts in a given project and location.
      virtual void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Rollout.
      virtual void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Rollout in a given project and location.
      virtual void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Ignores the specified Job in a Rollout.
      virtual void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retries the specified Job in a Rollout.
      virtual void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists JobRuns in a given project and location.
      virtual void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single JobRun.
      virtual void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Terminates a Job Run in a given project and location.
      virtual void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the configuration for a location.
      virtual void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* AsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* PrepareAsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>* AsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>* PrepareAsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>* AsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>* PrepareAsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>* AsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>* PrepareAsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>* AsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>* PrepareAsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>* AsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>* PrepareAsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>* AsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>* PrepareAsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>* AsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>* PrepareAsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* AsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* PrepareAsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>* AsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>* PrepareAsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>* AsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>* PrepareAsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>* AsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>* PrepareAsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>* AsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>* PrepareAsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>* AsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>* PrepareAsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>* AsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>* PrepareAsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>* AsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>* PrepareAsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>* AsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>* PrepareAsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>* AsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>* PrepareAsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> AsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(AsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> PrepareAsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(PrepareAsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    ::grpc::Status GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::google::cloud::deploy::v1::DeliveryPipeline* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>> AsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>>(AsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>> PrepareAsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>>(PrepareAsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::google::cloud::deploy::v1::ListTargetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>> AsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>>(AsyncListTargetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>> PrepareAsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>>(PrepareAsyncListTargetsRaw(context, request, cq));
    }
    ::grpc::Status GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::google::cloud::deploy::v1::Target* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>> AsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>>(AsyncGetTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>> PrepareAsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>>(PrepareAsyncGetTargetRaw(context, request, cq));
    }
    ::grpc::Status CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateTargetRaw(context, request, cq));
    }
    ::grpc::Status UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateTargetRaw(context, request, cq));
    }
    ::grpc::Status DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTargetRaw(context, request, cq));
    }
    ::grpc::Status ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::google::cloud::deploy::v1::ListReleasesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>> AsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>>(AsyncListReleasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>> PrepareAsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>>(PrepareAsyncListReleasesRaw(context, request, cq));
    }
    ::grpc::Status GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::google::cloud::deploy::v1::Release* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>> AsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>>(AsyncGetReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>> PrepareAsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>>(PrepareAsyncGetReleaseRaw(context, request, cq));
    }
    ::grpc::Status CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateReleaseRaw(context, request, cq));
    }
    ::grpc::Status AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>> AsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(AsyncAbandonReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>> PrepareAsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(PrepareAsyncAbandonReleaseRaw(context, request, cq));
    }
    ::grpc::Status ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>> AsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(AsyncApproveRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>> PrepareAsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(PrepareAsyncApproveRolloutRaw(context, request, cq));
    }
    ::grpc::Status AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> AsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(AsyncAdvanceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> PrepareAsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(PrepareAsyncAdvanceRolloutRaw(context, request, cq));
    }
    ::grpc::Status CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::google::cloud::deploy::v1::CancelRolloutResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>> AsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>>(AsyncCancelRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>> PrepareAsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>>(PrepareAsyncCancelRolloutRaw(context, request, cq));
    }
    ::grpc::Status ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::google::cloud::deploy::v1::ListRolloutsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>> AsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>>(AsyncListRolloutsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>> PrepareAsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>>(PrepareAsyncListRolloutsRaw(context, request, cq));
    }
    ::grpc::Status GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::google::cloud::deploy::v1::Rollout* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>> AsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>>(AsyncGetRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>> PrepareAsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>>(PrepareAsyncGetRolloutRaw(context, request, cq));
    }
    ::grpc::Status CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateRolloutRaw(context, request, cq));
    }
    ::grpc::Status IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::google::cloud::deploy::v1::IgnoreJobResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>> AsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>>(AsyncIgnoreJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>> PrepareAsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>>(PrepareAsyncIgnoreJobRaw(context, request, cq));
    }
    ::grpc::Status RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::google::cloud::deploy::v1::RetryJobResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>> AsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>>(AsyncRetryJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>> PrepareAsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>>(PrepareAsyncRetryJobRaw(context, request, cq));
    }
    ::grpc::Status ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::google::cloud::deploy::v1::ListJobRunsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>> AsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>>(AsyncListJobRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>> PrepareAsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>>(PrepareAsyncListJobRunsRaw(context, request, cq));
    }
    ::grpc::Status GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::google::cloud::deploy::v1::JobRun* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>> AsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>>(AsyncGetJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>> PrepareAsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>>(PrepareAsyncGetJobRunRaw(context, request, cq));
    }
    ::grpc::Status TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>> AsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(AsyncTerminateJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>> PrepareAsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(PrepareAsyncTerminateJobRunRaw(context, request, cq));
    }
    ::grpc::Status GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::google::cloud::deploy::v1::Config* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>> AsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>>(AsyncGetConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>> PrepareAsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>>(PrepareAsyncGetConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, std::function<void(::grpc::Status)>) override;
      void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, std::function<void(::grpc::Status)>) override;
      void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, std::function<void(::grpc::Status)>) override;
      void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, std::function<void(::grpc::Status)>) override;
      void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, std::function<void(::grpc::Status)>) override;
      void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, std::function<void(::grpc::Status)>) override;
      void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, std::function<void(::grpc::Status)>) override;
      void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, std::function<void(::grpc::Status)>) override;
      void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, std::function<void(::grpc::Status)>) override;
      void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, std::function<void(::grpc::Status)>) override;
      void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, std::function<void(::grpc::Status)>) override;
      void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, std::function<void(::grpc::Status)>) override;
      void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, std::function<void(::grpc::Status)>) override;
      void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* AsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* PrepareAsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>* AsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>* PrepareAsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>* AsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>* PrepareAsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>* AsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>* PrepareAsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>* AsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>* PrepareAsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>* AsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>* PrepareAsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>* AsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>* PrepareAsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>* AsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>* PrepareAsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* AsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* PrepareAsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>* AsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>* PrepareAsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>* AsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>* PrepareAsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>* AsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>* PrepareAsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>* AsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>* PrepareAsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>* AsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>* PrepareAsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>* AsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>* PrepareAsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>* AsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>* PrepareAsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>* AsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>* PrepareAsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>* AsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>* PrepareAsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListDeliveryPipelines_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTargets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_ListReleases_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRelease_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRelease_;
    const ::grpc::internal::RpcMethod rpcmethod_AbandonRelease_;
    const ::grpc::internal::RpcMethod rpcmethod_ApproveRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_AdvanceRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRollouts_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_IgnoreJob_;
    const ::grpc::internal::RpcMethod rpcmethod_RetryJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobRuns_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJobRun_;
    const ::grpc::internal::RpcMethod rpcmethod_TerminateJobRun_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists DeliveryPipelines in a given project and location.
    virtual ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response);
    // Gets details of a single DeliveryPipeline.
    virtual ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response);
    // Creates a new DeliveryPipeline in a given project and location.
    virtual ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single DeliveryPipeline.
    virtual ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single DeliveryPipeline.
    virtual ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response);
    // Lists Targets in a given project and location.
    virtual ::grpc::Status ListTargets(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response);
    // Gets details of a single Target.
    virtual ::grpc::Status GetTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response);
    // Creates a new Target in a given project and location.
    virtual ::grpc::Status CreateTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single Target.
    virtual ::grpc::Status UpdateTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Target.
    virtual ::grpc::Status DeleteTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response);
    // Lists Releases in a given project and location.
    virtual ::grpc::Status ListReleases(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response);
    // Gets details of a single Release.
    virtual ::grpc::Status GetRelease(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response);
    // Creates a new Release in a given project and location.
    virtual ::grpc::Status CreateRelease(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response);
    // Abandons a Release in the Delivery Pipeline.
    virtual ::grpc::Status AbandonRelease(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response);
    // Approves a Rollout.
    virtual ::grpc::Status ApproveRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response);
    // Advances a Rollout in a given project and location.
    virtual ::grpc::Status AdvanceRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response);
    // Cancels a Rollout in a given project and location.
    virtual ::grpc::Status CancelRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response);
    // Lists Rollouts in a given project and location.
    virtual ::grpc::Status ListRollouts(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response);
    // Gets details of a single Rollout.
    virtual ::grpc::Status GetRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response);
    // Creates a new Rollout in a given project and location.
    virtual ::grpc::Status CreateRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response);
    // Ignores the specified Job in a Rollout.
    virtual ::grpc::Status IgnoreJob(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response);
    // Retries the specified Job in a Rollout.
    virtual ::grpc::Status RetryJob(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response);
    // Lists JobRuns in a given project and location.
    virtual ::grpc::Status ListJobRuns(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response);
    // Gets details of a single JobRun.
    virtual ::grpc::Status GetJobRun(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response);
    // Terminates a Job Run in a given project and location.
    virtual ::grpc::Status TerminateJobRun(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response);
    // Gets the configuration for a location.
    virtual ::grpc::Status GetConfig(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeliveryPipelines(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::DeliveryPipeline>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTargets() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTargets(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListTargetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListTargetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTarget() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Target>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTarget() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListReleases() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReleases(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListReleasesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListReleasesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRelease() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRelease(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetReleaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Release>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRelease() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRelease(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAbandonRelease(::grpc::ServerContext* context, ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::AbandonReleaseResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ApproveRolloutResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAdvanceRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelRollout() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::CancelRolloutResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRollouts() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRollouts(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListRolloutsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRollout() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Rollout>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRollout() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestIgnoreJob(::grpc::ServerContext* context, ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::IgnoreJobResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RetryJob() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetryJob(::grpc::ServerContext* context, ::google::cloud::deploy::v1::RetryJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::RetryJobResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobRuns(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListJobRunsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJobRun() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobRun(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetJobRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::JobRun>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTerminateJobRun(::grpc::ServerContext* context, ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::TerminateJobRunResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConfig() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConfig(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Config>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListDeliveryPipelines<WithAsyncMethod_GetDeliveryPipeline<WithAsyncMethod_CreateDeliveryPipeline<WithAsyncMethod_UpdateDeliveryPipeline<WithAsyncMethod_DeleteDeliveryPipeline<WithAsyncMethod_ListTargets<WithAsyncMethod_GetTarget<WithAsyncMethod_CreateTarget<WithAsyncMethod_UpdateTarget<WithAsyncMethod_DeleteTarget<WithAsyncMethod_ListReleases<WithAsyncMethod_GetRelease<WithAsyncMethod_CreateRelease<WithAsyncMethod_AbandonRelease<WithAsyncMethod_ApproveRollout<WithAsyncMethod_AdvanceRollout<WithAsyncMethod_CancelRollout<WithAsyncMethod_ListRollouts<WithAsyncMethod_GetRollout<WithAsyncMethod_CreateRollout<WithAsyncMethod_IgnoreJob<WithAsyncMethod_RetryJob<WithAsyncMethod_ListJobRuns<WithAsyncMethod_GetJobRun<WithAsyncMethod_TerminateJobRun<WithAsyncMethod_GetConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response) { return this->ListDeliveryPipelines(context, request, response); }));}
    void SetMessageAllocatorFor_ListDeliveryPipelines(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeliveryPipelines(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response) { return this->GetDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_GetDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response) { return this->CreateDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTargets() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response) { return this->ListTargets(context, request, response); }));}
    void SetMessageAllocatorFor_ListTargets(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTargets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTarget() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response) { return this->GetTarget(context, request, response); }));}
    void SetMessageAllocatorFor_GetTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTarget() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response) { return this->CreateTarget(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response) { return this->UpdateTarget(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTarget(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListReleases() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response) { return this->ListReleases(context, request, response); }));}
    void SetMessageAllocatorFor_ListReleases(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReleases(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRelease() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response) { return this->GetRelease(context, request, response); }));}
    void SetMessageAllocatorFor_GetRelease(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRelease() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response) { return this->CreateRelease(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRelease(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response) { return this->AbandonRelease(context, request, response); }));}
    void SetMessageAllocatorFor_AbandonRelease(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AbandonRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response) { return this->ApproveRollout(context, request, response); }));}
    void SetMessageAllocatorFor_ApproveRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response) { return this->AdvanceRollout(context, request, response); }));}
    void SetMessageAllocatorFor_AdvanceRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AdvanceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelRollout() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response) { return this->CancelRollout(context, request, response); }));}
    void SetMessageAllocatorFor_CancelRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRollouts() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response) { return this->ListRollouts(context, request, response); }));}
    void SetMessageAllocatorFor_ListRollouts(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRollouts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRollout() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response) { return this->GetRollout(context, request, response); }));}
    void SetMessageAllocatorFor_GetRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRollout() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response) { return this->CreateRollout(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response) { return this->IgnoreJob(context, request, response); }));}
    void SetMessageAllocatorFor_IgnoreJob(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* IgnoreJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RetryJob() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response) { return this->RetryJob(context, request, response); }));}
    void SetMessageAllocatorFor_RetryJob(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetryJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response) { return this->ListJobRuns(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobRuns(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJobRun() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response) { return this->GetJobRun(context, request, response); }));}
    void SetMessageAllocatorFor_GetJobRun(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response) { return this->TerminateJobRun(context, request, response); }));}
    void SetMessageAllocatorFor_TerminateJobRun(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TerminateJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConfig() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response) { return this->GetConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetConfig(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListDeliveryPipelines<WithCallbackMethod_GetDeliveryPipeline<WithCallbackMethod_CreateDeliveryPipeline<WithCallbackMethod_UpdateDeliveryPipeline<WithCallbackMethod_DeleteDeliveryPipeline<WithCallbackMethod_ListTargets<WithCallbackMethod_GetTarget<WithCallbackMethod_CreateTarget<WithCallbackMethod_UpdateTarget<WithCallbackMethod_DeleteTarget<WithCallbackMethod_ListReleases<WithCallbackMethod_GetRelease<WithCallbackMethod_CreateRelease<WithCallbackMethod_AbandonRelease<WithCallbackMethod_ApproveRollout<WithCallbackMethod_AdvanceRollout<WithCallbackMethod_CancelRollout<WithCallbackMethod_ListRollouts<WithCallbackMethod_GetRollout<WithCallbackMethod_CreateRollout<WithCallbackMethod_IgnoreJob<WithCallbackMethod_RetryJob<WithCallbackMethod_ListJobRuns<WithCallbackMethod_GetJobRun<WithCallbackMethod_TerminateJobRun<WithCallbackMethod_GetConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTargets() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTarget() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTarget() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListReleases() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRelease() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRelease() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelRollout() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRollouts() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRollout() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRollout() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RetryJob() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJobRun() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConfig() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeliveryPipelines(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTargets() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTargets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTarget() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTarget() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListReleases() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReleases(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRelease() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRelease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRelease() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRelease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAbandonRelease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAdvanceRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelRollout() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRollouts() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRollouts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRollout() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRollout() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestIgnoreJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RetryJob() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetryJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobRuns(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJobRun() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTerminateJobRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConfig() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDeliveryPipelines(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeliveryPipelines(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTargets() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTargets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTargets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTarget() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTarget() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListReleases() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListReleases(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReleases(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRelease() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRelease(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRelease() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRelease(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AbandonRelease(context, request, response); }));
    }
    ~WithRawCallbackMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AbandonRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApproveRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AdvanceRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AdvanceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelRollout() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRollouts() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRollouts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRollouts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRollout() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRollout() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->IgnoreJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* IgnoreJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RetryJob() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RetryJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetryJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobRuns(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJobRun() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJobRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TerminateJobRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TerminateJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConfig() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* streamer) {
                       return this->StreamedListDeliveryPipelines(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDeliveryPipelines(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest,::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>* streamer) {
                       return this->StreamedGetDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest,::google::cloud::deploy::v1::DeliveryPipeline>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTargets() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>* streamer) {
                       return this->StreamedListTargets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTargets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListTargetsRequest,::google::cloud::deploy::v1::ListTargetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTarget() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>* streamer) {
                       return this->StreamedGetTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetTargetRequest,::google::cloud::deploy::v1::Target>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTarget() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateTargetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::UpdateTargetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::DeleteTargetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListReleases() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>* streamer) {
                       return this->StreamedListReleases(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListReleases(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListReleasesRequest,::google::cloud::deploy::v1::ListReleasesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRelease() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>* streamer) {
                       return this->StreamedGetRelease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRelease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetReleaseRequest,::google::cloud::deploy::v1::Release>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRelease() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRelease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRelease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateReleaseRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>* streamer) {
                       return this->StreamedAbandonRelease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAbandonRelease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::AbandonReleaseRequest,::google::cloud::deploy::v1::AbandonReleaseResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>* streamer) {
                       return this->StreamedApproveRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApproveRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ApproveRolloutRequest,::google::cloud::deploy::v1::ApproveRolloutResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>* streamer) {
                       return this->StreamedAdvanceRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAdvanceRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::AdvanceRolloutRequest,::google::cloud::deploy::v1::AdvanceRolloutResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelRollout() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>* streamer) {
                       return this->StreamedCancelRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CancelRolloutRequest,::google::cloud::deploy::v1::CancelRolloutResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRollouts() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>* streamer) {
                       return this->StreamedListRollouts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRollouts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListRolloutsRequest,::google::cloud::deploy::v1::ListRolloutsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRollout() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>* streamer) {
                       return this->StreamedGetRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetRolloutRequest,::google::cloud::deploy::v1::Rollout>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRollout() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateRolloutRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>* streamer) {
                       return this->StreamedIgnoreJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedIgnoreJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::IgnoreJobRequest,::google::cloud::deploy::v1::IgnoreJobResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RetryJob() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>* streamer) {
                       return this->StreamedRetryJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRetryJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::RetryJobRequest,::google::cloud::deploy::v1::RetryJobResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>* streamer) {
                       return this->StreamedListJobRuns(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobRuns(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListJobRunsRequest,::google::cloud::deploy::v1::ListJobRunsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJobRun() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>* streamer) {
                       return this->StreamedGetJobRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJobRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetJobRunRequest,::google::cloud::deploy::v1::JobRun>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>* streamer) {
                       return this->StreamedTerminateJobRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTerminateJobRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::TerminateJobRunRequest,::google::cloud::deploy::v1::TerminateJobRunResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConfig() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>* streamer) {
                       return this->StreamedGetConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetConfigRequest,::google::cloud::deploy::v1::Config>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListDeliveryPipelines<WithStreamedUnaryMethod_GetDeliveryPipeline<WithStreamedUnaryMethod_CreateDeliveryPipeline<WithStreamedUnaryMethod_UpdateDeliveryPipeline<WithStreamedUnaryMethod_DeleteDeliveryPipeline<WithStreamedUnaryMethod_ListTargets<WithStreamedUnaryMethod_GetTarget<WithStreamedUnaryMethod_CreateTarget<WithStreamedUnaryMethod_UpdateTarget<WithStreamedUnaryMethod_DeleteTarget<WithStreamedUnaryMethod_ListReleases<WithStreamedUnaryMethod_GetRelease<WithStreamedUnaryMethod_CreateRelease<WithStreamedUnaryMethod_AbandonRelease<WithStreamedUnaryMethod_ApproveRollout<WithStreamedUnaryMethod_AdvanceRollout<WithStreamedUnaryMethod_CancelRollout<WithStreamedUnaryMethod_ListRollouts<WithStreamedUnaryMethod_GetRollout<WithStreamedUnaryMethod_CreateRollout<WithStreamedUnaryMethod_IgnoreJob<WithStreamedUnaryMethod_RetryJob<WithStreamedUnaryMethod_ListJobRuns<WithStreamedUnaryMethod_GetJobRun<WithStreamedUnaryMethod_TerminateJobRun<WithStreamedUnaryMethod_GetConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListDeliveryPipelines<WithStreamedUnaryMethod_GetDeliveryPipeline<WithStreamedUnaryMethod_CreateDeliveryPipeline<WithStreamedUnaryMethod_UpdateDeliveryPipeline<WithStreamedUnaryMethod_DeleteDeliveryPipeline<WithStreamedUnaryMethod_ListTargets<WithStreamedUnaryMethod_GetTarget<WithStreamedUnaryMethod_CreateTarget<WithStreamedUnaryMethod_UpdateTarget<WithStreamedUnaryMethod_DeleteTarget<WithStreamedUnaryMethod_ListReleases<WithStreamedUnaryMethod_GetRelease<WithStreamedUnaryMethod_CreateRelease<WithStreamedUnaryMethod_AbandonRelease<WithStreamedUnaryMethod_ApproveRollout<WithStreamedUnaryMethod_AdvanceRollout<WithStreamedUnaryMethod_CancelRollout<WithStreamedUnaryMethod_ListRollouts<WithStreamedUnaryMethod_GetRollout<WithStreamedUnaryMethod_CreateRollout<WithStreamedUnaryMethod_IgnoreJob<WithStreamedUnaryMethod_RetryJob<WithStreamedUnaryMethod_ListJobRuns<WithStreamedUnaryMethod_GetJobRun<WithStreamedUnaryMethod_TerminateJobRun<WithStreamedUnaryMethod_GetConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace deploy
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdeploy_2fv1_2fcloud_5fdeploy_2eproto__INCLUDED
