// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/devtools/cloudbuild/v1/cloudbuild.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fdevtools_2fcloudbuild_2fv1_2fcloudbuild_2eproto__INCLUDED
#define GRPC_google_2fdevtools_2fcloudbuild_2fv1_2fcloudbuild_2eproto__INCLUDED

#include "google/devtools/cloudbuild/v1/cloudbuild.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace devtools {
namespace cloudbuild {
namespace v1 {

// Creates and manages builds on Google Cloud Platform.
//
// The main concept used by this API is a `Build`, which describes the location
// of the source to build, how to build the source, and where to store the
// built artifacts, if any.
//
// A user can list previously-requested builds or get builds by their ID to
// determine the status of the build.
class CloudBuild final {
 public:
  static constexpr char const* service_full_name() {
    return "google.devtools.cloudbuild.v1.CloudBuild";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Starts a build with the specified configuration.
    //
    // This method returns a long-running `Operation`, which includes the build
    // ID. Pass the build ID to `GetBuild` to determine the build status (such as
    // `SUCCESS` or `FAILURE`).
    virtual ::grpc::Status CreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateBuildRaw(context, request, cq));
    }
    // Returns information about a previously requested build.
    //
    // The `Build` that is returned includes its status (such as `SUCCESS`,
    // `FAILURE`, or `WORKING`), and timing information.
    virtual ::grpc::Status GetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::google::devtools::cloudbuild::v1::Build* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>> AsyncGetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>>(AsyncGetBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>> PrepareAsyncGetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>>(PrepareAsyncGetBuildRaw(context, request, cq));
    }
    // Lists previously requested builds.
    //
    // Previously requested builds may still be in-progress, or may have finished
    // successfully or unsuccessfully.
    virtual ::grpc::Status ListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildsResponse>> AsyncListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildsResponse>>(AsyncListBuildsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildsResponse>> PrepareAsyncListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildsResponse>>(PrepareAsyncListBuildsRaw(context, request, cq));
    }
    // Cancels a build in progress.
    virtual ::grpc::Status CancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::google::devtools::cloudbuild::v1::Build* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>> AsyncCancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>>(AsyncCancelBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>> PrepareAsyncCancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>>(PrepareAsyncCancelBuildRaw(context, request, cq));
    }
    // Creates a new build based on the specified build.
    //
    // This method creates a new build using the original build request, which may
    // or may not result in an identical build.
    //
    // For triggered builds:
    //
    // * Triggered builds resolve to a precise revision; therefore a retry of a
    // triggered build will result in a build that uses the same revision.
    //
    // For non-triggered builds that specify `RepoSource`:
    //
    // * If the original build built from the tip of a branch, the retried build
    // will build from the tip of that branch, which may not be the same revision
    // as the original build.
    // * If the original build specified a commit sha or revision ID, the retried
    // build will use the identical source.
    //
    // For builds that specify `StorageSource`:
    //
    // * If the original build pulled source from Cloud Storage without
    // specifying the generation of the object, the new build will use the current
    // object, which may be different from the original build source.
    // * If the original build pulled source from Cloud Storage and specified the
    // generation of the object, the new build will attempt to use the same
    // object, which may or may not be available depending on the bucket's
    // lifecycle management settings.
    virtual ::grpc::Status RetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRetryBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRetryBuildRaw(context, request, cq));
    }
    // Approves or rejects a pending build.
    //
    // If approved, the returned LRO will be analogous to the LRO returned from
    // a CreateBuild call.
    //
    // If rejected, the returned LRO will be immediately done.
    virtual ::grpc::Status ApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncApproveBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncApproveBuildRaw(context, request, cq));
    }
    // Creates a new `BuildTrigger`.
    //
    // This API is experimental.
    virtual ::grpc::Status CreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>> AsyncCreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>>(AsyncCreateBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>> PrepareAsyncCreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>>(PrepareAsyncCreateBuildTriggerRaw(context, request, cq));
    }
    // Returns information about a `BuildTrigger`.
    //
    // This API is experimental.
    virtual ::grpc::Status GetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>> AsyncGetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>>(AsyncGetBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>> PrepareAsyncGetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>>(PrepareAsyncGetBuildTriggerRaw(context, request, cq));
    }
    // Lists existing `BuildTrigger`s.
    //
    // This API is experimental.
    virtual ::grpc::Status ListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>> AsyncListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>>(AsyncListBuildTriggersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>> PrepareAsyncListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>>(PrepareAsyncListBuildTriggersRaw(context, request, cq));
    }
    // Deletes a `BuildTrigger` by its project ID and trigger ID.
    //
    // This API is experimental.
    virtual ::grpc::Status DeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteBuildTriggerRaw(context, request, cq));
    }
    // Updates a `BuildTrigger` by its project ID and trigger ID.
    //
    // This API is experimental.
    virtual ::grpc::Status UpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>> AsyncUpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>>(AsyncUpdateBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>> PrepareAsyncUpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>>(PrepareAsyncUpdateBuildTriggerRaw(context, request, cq));
    }
    // Runs a `BuildTrigger` at a particular source revision.
    //
    // To run a regional or global trigger, use the POST request
    // that includes the location endpoint in the path (ex.
    // v1/projects/{projectId}/locations/{region}/triggers/{triggerId}:run). The
    // POST request that does not include the location endpoint in the path can
    // only be used when running global triggers.
    virtual ::grpc::Status RunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRunBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRunBuildTriggerRaw(context, request, cq));
    }
    // ReceiveTriggerWebhook [Experimental] is called when the API receives a
    // webhook request targeted at a specific trigger.
    virtual ::grpc::Status ReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>> AsyncReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>>(AsyncReceiveTriggerWebhookRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>> PrepareAsyncReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>>(PrepareAsyncReceiveTriggerWebhookRaw(context, request, cq));
    }
    // Creates a `WorkerPool`.
    virtual ::grpc::Status CreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateWorkerPoolRaw(context, request, cq));
    }
    // Returns details of a `WorkerPool`.
    virtual ::grpc::Status GetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::google::devtools::cloudbuild::v1::WorkerPool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::WorkerPool>> AsyncGetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::WorkerPool>>(AsyncGetWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::WorkerPool>> PrepareAsyncGetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::WorkerPool>>(PrepareAsyncGetWorkerPoolRaw(context, request, cq));
    }
    // Deletes a `WorkerPool`.
    virtual ::grpc::Status DeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteWorkerPoolRaw(context, request, cq));
    }
    // Updates a `WorkerPool`.
    virtual ::grpc::Status UpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateWorkerPoolRaw(context, request, cq));
    }
    // Lists `WorkerPool`s.
    virtual ::grpc::Status ListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>> AsyncListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>>(AsyncListWorkerPoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>> PrepareAsyncListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>>(PrepareAsyncListWorkerPoolsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Starts a build with the specified configuration.
      //
      // This method returns a long-running `Operation`, which includes the build
      // ID. Pass the build ID to `GetBuild` to determine the build status (such as
      // `SUCCESS` or `FAILURE`).
      virtual void CreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns information about a previously requested build.
      //
      // The `Build` that is returned includes its status (such as `SUCCESS`,
      // `FAILURE`, or `WORKING`), and timing information.
      virtual void GetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists previously requested builds.
      //
      // Previously requested builds may still be in-progress, or may have finished
      // successfully or unsuccessfully.
      virtual void ListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels a build in progress.
      virtual void CancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new build based on the specified build.
      //
      // This method creates a new build using the original build request, which may
      // or may not result in an identical build.
      //
      // For triggered builds:
      //
      // * Triggered builds resolve to a precise revision; therefore a retry of a
      // triggered build will result in a build that uses the same revision.
      //
      // For non-triggered builds that specify `RepoSource`:
      //
      // * If the original build built from the tip of a branch, the retried build
      // will build from the tip of that branch, which may not be the same revision
      // as the original build.
      // * If the original build specified a commit sha or revision ID, the retried
      // build will use the identical source.
      //
      // For builds that specify `StorageSource`:
      //
      // * If the original build pulled source from Cloud Storage without
      // specifying the generation of the object, the new build will use the current
      // object, which may be different from the original build source.
      // * If the original build pulled source from Cloud Storage and specified the
      // generation of the object, the new build will attempt to use the same
      // object, which may or may not be available depending on the bucket's
      // lifecycle management settings.
      virtual void RetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Approves or rejects a pending build.
      //
      // If approved, the returned LRO will be analogous to the LRO returned from
      // a CreateBuild call.
      //
      // If rejected, the returned LRO will be immediately done.
      virtual void ApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new `BuildTrigger`.
      //
      // This API is experimental.
      virtual void CreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns information about a `BuildTrigger`.
      //
      // This API is experimental.
      virtual void GetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists existing `BuildTrigger`s.
      //
      // This API is experimental.
      virtual void ListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `BuildTrigger` by its project ID and trigger ID.
      //
      // This API is experimental.
      virtual void DeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a `BuildTrigger` by its project ID and trigger ID.
      //
      // This API is experimental.
      virtual void UpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Runs a `BuildTrigger` at a particular source revision.
      //
      // To run a regional or global trigger, use the POST request
      // that includes the location endpoint in the path (ex.
      // v1/projects/{projectId}/locations/{region}/triggers/{triggerId}:run). The
      // POST request that does not include the location endpoint in the path can
      // only be used when running global triggers.
      virtual void RunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // ReceiveTriggerWebhook [Experimental] is called when the API receives a
      // webhook request targeted at a specific trigger.
      virtual void ReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a `WorkerPool`.
      virtual void CreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns details of a `WorkerPool`.
      virtual void GetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::google::devtools::cloudbuild::v1::WorkerPool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::google::devtools::cloudbuild::v1::WorkerPool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `WorkerPool`.
      virtual void DeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a `WorkerPool`.
      virtual void UpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `WorkerPool`s.
      virtual void ListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>* AsyncGetBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>* PrepareAsyncGetBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildsResponse>* AsyncListBuildsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildsResponse>* PrepareAsyncListBuildsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>* AsyncCancelBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::Build>* PrepareAsyncCancelBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRetryBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRetryBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncApproveBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncApproveBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>* AsyncCreateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>* PrepareAsyncCreateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>* AsyncGetBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>* PrepareAsyncGetBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* AsyncListBuildTriggersRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* PrepareAsyncListBuildTriggersRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>* AsyncUpdateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::BuildTrigger>* PrepareAsyncUpdateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRunBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRunBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* AsyncReceiveTriggerWebhookRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* PrepareAsyncReceiveTriggerWebhookRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::WorkerPool>* AsyncGetWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::WorkerPool>* PrepareAsyncGetWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* AsyncListWorkerPoolsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* PrepareAsyncListWorkerPoolsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateBuildRaw(context, request, cq));
    }
    ::grpc::Status GetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::google::devtools::cloudbuild::v1::Build* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>> AsyncGetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>>(AsyncGetBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>> PrepareAsyncGetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>>(PrepareAsyncGetBuildRaw(context, request, cq));
    }
    ::grpc::Status ListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildsResponse>> AsyncListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildsResponse>>(AsyncListBuildsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildsResponse>> PrepareAsyncListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildsResponse>>(PrepareAsyncListBuildsRaw(context, request, cq));
    }
    ::grpc::Status CancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::google::devtools::cloudbuild::v1::Build* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>> AsyncCancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>>(AsyncCancelBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>> PrepareAsyncCancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>>(PrepareAsyncCancelBuildRaw(context, request, cq));
    }
    ::grpc::Status RetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRetryBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRetryBuildRaw(context, request, cq));
    }
    ::grpc::Status ApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncApproveBuildRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncApproveBuildRaw(context, request, cq));
    }
    ::grpc::Status CreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>> AsyncCreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>>(AsyncCreateBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>> PrepareAsyncCreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>>(PrepareAsyncCreateBuildTriggerRaw(context, request, cq));
    }
    ::grpc::Status GetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>> AsyncGetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>>(AsyncGetBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>> PrepareAsyncGetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>>(PrepareAsyncGetBuildTriggerRaw(context, request, cq));
    }
    ::grpc::Status ListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>> AsyncListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>>(AsyncListBuildTriggersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>> PrepareAsyncListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>>(PrepareAsyncListBuildTriggersRaw(context, request, cq));
    }
    ::grpc::Status DeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteBuildTriggerRaw(context, request, cq));
    }
    ::grpc::Status UpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>> AsyncUpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>>(AsyncUpdateBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>> PrepareAsyncUpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>>(PrepareAsyncUpdateBuildTriggerRaw(context, request, cq));
    }
    ::grpc::Status RunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRunBuildTriggerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRunBuildTriggerRaw(context, request, cq));
    }
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>> AsyncReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>>(AsyncReceiveTriggerWebhookRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>> PrepareAsyncReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>>(PrepareAsyncReceiveTriggerWebhookRaw(context, request, cq));
    }
    ::grpc::Status CreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateWorkerPoolRaw(context, request, cq));
    }
    ::grpc::Status GetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::google::devtools::cloudbuild::v1::WorkerPool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::WorkerPool>> AsyncGetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::WorkerPool>>(AsyncGetWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::WorkerPool>> PrepareAsyncGetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::WorkerPool>>(PrepareAsyncGetWorkerPoolRaw(context, request, cq));
    }
    ::grpc::Status DeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteWorkerPoolRaw(context, request, cq));
    }
    ::grpc::Status UpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateWorkerPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateWorkerPoolRaw(context, request, cq));
    }
    ::grpc::Status ListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>> AsyncListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>>(AsyncListWorkerPoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>> PrepareAsyncListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>>(PrepareAsyncListWorkerPoolsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, std::function<void(::grpc::Status)>) override;
      void GetBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBuilds(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, std::function<void(::grpc::Status)>) override;
      void CancelBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RetryBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ApproveBuild(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, std::function<void(::grpc::Status)>) override;
      void CreateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, std::function<void(::grpc::Status)>) override;
      void GetBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBuildTriggers(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, std::function<void(::grpc::Status)>) override;
      void UpdateBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RunBuildTrigger(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response, std::function<void(::grpc::Status)>) override;
      void ReceiveTriggerWebhook(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::google::devtools::cloudbuild::v1::WorkerPool* response, std::function<void(::grpc::Status)>) override;
      void GetWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::google::devtools::cloudbuild::v1::WorkerPool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateWorkerPool(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListWorkerPools(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>* AsyncGetBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>* PrepareAsyncGetBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildsResponse>* AsyncListBuildsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildsResponse>* PrepareAsyncListBuildsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>* AsyncCancelBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::Build>* PrepareAsyncCancelBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRetryBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRetryBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncApproveBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncApproveBuildRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>* AsyncCreateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>* PrepareAsyncCreateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>* AsyncGetBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>* PrepareAsyncGetBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* AsyncListBuildTriggersRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* PrepareAsyncListBuildTriggersRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>* AsyncUpdateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::BuildTrigger>* PrepareAsyncUpdateBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRunBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRunBuildTriggerRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* AsyncReceiveTriggerWebhookRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* PrepareAsyncReceiveTriggerWebhookRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::WorkerPool>* AsyncGetWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::WorkerPool>* PrepareAsyncGetWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateWorkerPoolRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* AsyncListWorkerPoolsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* PrepareAsyncListWorkerPoolsRaw(::grpc::ClientContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBuild_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBuild_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBuilds_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelBuild_;
    const ::grpc::internal::RpcMethod rpcmethod_RetryBuild_;
    const ::grpc::internal::RpcMethod rpcmethod_ApproveBuild_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBuildTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBuildTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBuildTriggers_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBuildTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateBuildTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_RunBuildTrigger_;
    const ::grpc::internal::RpcMethod rpcmethod_ReceiveTriggerWebhook_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateWorkerPool_;
    const ::grpc::internal::RpcMethod rpcmethod_GetWorkerPool_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteWorkerPool_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateWorkerPool_;
    const ::grpc::internal::RpcMethod rpcmethod_ListWorkerPools_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Starts a build with the specified configuration.
    //
    // This method returns a long-running `Operation`, which includes the build
    // ID. Pass the build ID to `GetBuild` to determine the build status (such as
    // `SUCCESS` or `FAILURE`).
    virtual ::grpc::Status CreateBuild(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::google::longrunning::Operation* response);
    // Returns information about a previously requested build.
    //
    // The `Build` that is returned includes its status (such as `SUCCESS`,
    // `FAILURE`, or `WORKING`), and timing information.
    virtual ::grpc::Status GetBuild(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response);
    // Lists previously requested builds.
    //
    // Previously requested builds may still be in-progress, or may have finished
    // successfully or unsuccessfully.
    virtual ::grpc::Status ListBuilds(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response);
    // Cancels a build in progress.
    virtual ::grpc::Status CancelBuild(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response);
    // Creates a new build based on the specified build.
    //
    // This method creates a new build using the original build request, which may
    // or may not result in an identical build.
    //
    // For triggered builds:
    //
    // * Triggered builds resolve to a precise revision; therefore a retry of a
    // triggered build will result in a build that uses the same revision.
    //
    // For non-triggered builds that specify `RepoSource`:
    //
    // * If the original build built from the tip of a branch, the retried build
    // will build from the tip of that branch, which may not be the same revision
    // as the original build.
    // * If the original build specified a commit sha or revision ID, the retried
    // build will use the identical source.
    //
    // For builds that specify `StorageSource`:
    //
    // * If the original build pulled source from Cloud Storage without
    // specifying the generation of the object, the new build will use the current
    // object, which may be different from the original build source.
    // * If the original build pulled source from Cloud Storage and specified the
    // generation of the object, the new build will attempt to use the same
    // object, which may or may not be available depending on the bucket's
    // lifecycle management settings.
    virtual ::grpc::Status RetryBuild(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::google::longrunning::Operation* response);
    // Approves or rejects a pending build.
    //
    // If approved, the returned LRO will be analogous to the LRO returned from
    // a CreateBuild call.
    //
    // If rejected, the returned LRO will be immediately done.
    virtual ::grpc::Status ApproveBuild(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::google::longrunning::Operation* response);
    // Creates a new `BuildTrigger`.
    //
    // This API is experimental.
    virtual ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response);
    // Returns information about a `BuildTrigger`.
    //
    // This API is experimental.
    virtual ::grpc::Status GetBuildTrigger(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response);
    // Lists existing `BuildTrigger`s.
    //
    // This API is experimental.
    virtual ::grpc::Status ListBuildTriggers(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response);
    // Deletes a `BuildTrigger` by its project ID and trigger ID.
    //
    // This API is experimental.
    virtual ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::google::protobuf::Empty* response);
    // Updates a `BuildTrigger` by its project ID and trigger ID.
    //
    // This API is experimental.
    virtual ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response);
    // Runs a `BuildTrigger` at a particular source revision.
    //
    // To run a regional or global trigger, use the POST request
    // that includes the location endpoint in the path (ex.
    // v1/projects/{projectId}/locations/{region}/triggers/{triggerId}:run). The
    // POST request that does not include the location endpoint in the path can
    // only be used when running global triggers.
    virtual ::grpc::Status RunBuildTrigger(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::google::longrunning::Operation* response);
    // ReceiveTriggerWebhook [Experimental] is called when the API receives a
    // webhook request targeted at a specific trigger.
    virtual ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response);
    // Creates a `WorkerPool`.
    virtual ::grpc::Status CreateWorkerPool(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::google::longrunning::Operation* response);
    // Returns details of a `WorkerPool`.
    virtual ::grpc::Status GetWorkerPool(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::google::devtools::cloudbuild::v1::WorkerPool* response);
    // Deletes a `WorkerPool`.
    virtual ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::google::longrunning::Operation* response);
    // Updates a `WorkerPool`.
    virtual ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::google::longrunning::Operation* response);
    // Lists `WorkerPool`s.
    virtual ::grpc::Status ListWorkerPools(::grpc::ServerContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBuild() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBuild(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBuild() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBuild(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::Build>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBuilds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBuilds() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListBuilds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuilds(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBuilds(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::ListBuildsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelBuild() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CancelBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelBuild(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::Build>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RetryBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RetryBuild() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_RetryBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetryBuild(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApproveBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApproveBuild() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ApproveBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveBuild(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBuildTrigger() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBuildTrigger(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::BuildTrigger>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBuildTrigger() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBuildTrigger(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::BuildTrigger>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBuildTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBuildTriggers() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListBuildTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuildTriggers(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBuildTriggers(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBuildTrigger() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBuildTrigger(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateBuildTrigger() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_UpdateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBuildTrigger(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::BuildTrigger>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RunBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RunBuildTrigger() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_RunBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunBuildTrigger(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReceiveTriggerWebhook : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReceiveTriggerWebhook() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ReceiveTriggerWebhook() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReceiveTriggerWebhook(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateWorkerPool() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkerPool(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetWorkerPool() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_GetWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkerPool(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::WorkerPool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteWorkerPool() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_DeleteWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkerPool(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateWorkerPool() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_UpdateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkerPool(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListWorkerPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListWorkerPools() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_ListWorkerPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkerPools(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkerPools(::grpc::ServerContext* context, ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateBuild<WithAsyncMethod_GetBuild<WithAsyncMethod_ListBuilds<WithAsyncMethod_CancelBuild<WithAsyncMethod_RetryBuild<WithAsyncMethod_ApproveBuild<WithAsyncMethod_CreateBuildTrigger<WithAsyncMethod_GetBuildTrigger<WithAsyncMethod_ListBuildTriggers<WithAsyncMethod_DeleteBuildTrigger<WithAsyncMethod_UpdateBuildTrigger<WithAsyncMethod_RunBuildTrigger<WithAsyncMethod_ReceiveTriggerWebhook<WithAsyncMethod_CreateWorkerPool<WithAsyncMethod_GetWorkerPool<WithAsyncMethod_DeleteWorkerPool<WithAsyncMethod_UpdateWorkerPool<WithAsyncMethod_ListWorkerPools<Service > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBuild() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CreateBuildRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* request, ::google::longrunning::Operation* response) { return this->CreateBuild(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBuild(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::CreateBuildRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CreateBuildRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBuild() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::GetBuildRequest, ::google::devtools::cloudbuild::v1::Build>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::GetBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response) { return this->GetBuild(context, request, response); }));}
    void SetMessageAllocatorFor_GetBuild(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::GetBuildRequest, ::google::devtools::cloudbuild::v1::Build>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::GetBuildRequest, ::google::devtools::cloudbuild::v1::Build>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBuilds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBuilds() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ListBuildsRequest, ::google::devtools::cloudbuild::v1::ListBuildsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* request, ::google::devtools::cloudbuild::v1::ListBuildsResponse* response) { return this->ListBuilds(context, request, response); }));}
    void SetMessageAllocatorFor_ListBuilds(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::ListBuildsRequest, ::google::devtools::cloudbuild::v1::ListBuildsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ListBuildsRequest, ::google::devtools::cloudbuild::v1::ListBuildsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBuilds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuilds(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBuilds(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelBuild() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CancelBuildRequest, ::google::devtools::cloudbuild::v1::Build>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* request, ::google::devtools::cloudbuild::v1::Build* response) { return this->CancelBuild(context, request, response); }));}
    void SetMessageAllocatorFor_CancelBuild(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::CancelBuildRequest, ::google::devtools::cloudbuild::v1::Build>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CancelBuildRequest, ::google::devtools::cloudbuild::v1::Build>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RetryBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RetryBuild() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::RetryBuildRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* request, ::google::longrunning::Operation* response) { return this->RetryBuild(context, request, response); }));}
    void SetMessageAllocatorFor_RetryBuild(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::RetryBuildRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::RetryBuildRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RetryBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetryBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApproveBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApproveBuild() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ApproveBuildRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* request, ::google::longrunning::Operation* response) { return this->ApproveBuild(context, request, response); }));}
    void SetMessageAllocatorFor_ApproveBuild(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::ApproveBuildRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ApproveBuildRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApproveBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBuildTrigger() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) { return this->CreateBuildTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBuildTrigger(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBuildTrigger() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) { return this->GetBuildTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_GetBuildTrigger(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBuildTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBuildTriggers() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* request, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* response) { return this->ListBuildTriggers(context, request, response); }));}
    void SetMessageAllocatorFor_ListBuildTriggers(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBuildTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuildTriggers(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBuildTriggers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBuildTrigger() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* request, ::google::protobuf::Empty* response) { return this->DeleteBuildTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBuildTrigger(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateBuildTrigger() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* request, ::google::devtools::cloudbuild::v1::BuildTrigger* response) { return this->UpdateBuildTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateBuildTrigger(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RunBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RunBuildTrigger() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* request, ::google::longrunning::Operation* response) { return this->RunBuildTrigger(context, request, response); }));}
    void SetMessageAllocatorFor_RunBuildTrigger(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RunBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReceiveTriggerWebhook : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReceiveTriggerWebhook() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* request, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* response) { return this->ReceiveTriggerWebhook(context, request, response); }));}
    void SetMessageAllocatorFor_ReceiveTriggerWebhook(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReceiveTriggerWebhook() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReceiveTriggerWebhook(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateWorkerPool() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* request, ::google::longrunning::Operation* response) { return this->CreateWorkerPool(context, request, response); }));}
    void SetMessageAllocatorFor_CreateWorkerPool(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetWorkerPool() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest, ::google::devtools::cloudbuild::v1::WorkerPool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* request, ::google::devtools::cloudbuild::v1::WorkerPool* response) { return this->GetWorkerPool(context, request, response); }));}
    void SetMessageAllocatorFor_GetWorkerPool(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest, ::google::devtools::cloudbuild::v1::WorkerPool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest, ::google::devtools::cloudbuild::v1::WorkerPool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteWorkerPool() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* request, ::google::longrunning::Operation* response) { return this->DeleteWorkerPool(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteWorkerPool(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateWorkerPool() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* request, ::google::longrunning::Operation* response) { return this->UpdateWorkerPool(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateWorkerPool(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListWorkerPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListWorkerPools() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* request, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* response) { return this->ListWorkerPools(context, request, response); }));}
    void SetMessageAllocatorFor_ListWorkerPools(
        ::grpc::MessageAllocator< ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListWorkerPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkerPools(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkerPools(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateBuild<WithCallbackMethod_GetBuild<WithCallbackMethod_ListBuilds<WithCallbackMethod_CancelBuild<WithCallbackMethod_RetryBuild<WithCallbackMethod_ApproveBuild<WithCallbackMethod_CreateBuildTrigger<WithCallbackMethod_GetBuildTrigger<WithCallbackMethod_ListBuildTriggers<WithCallbackMethod_DeleteBuildTrigger<WithCallbackMethod_UpdateBuildTrigger<WithCallbackMethod_RunBuildTrigger<WithCallbackMethod_ReceiveTriggerWebhook<WithCallbackMethod_CreateWorkerPool<WithCallbackMethod_GetWorkerPool<WithCallbackMethod_DeleteWorkerPool<WithCallbackMethod_UpdateWorkerPool<WithCallbackMethod_ListWorkerPools<Service > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBuild() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBuild() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBuilds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBuilds() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListBuilds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuilds(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelBuild() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CancelBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RetryBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RetryBuild() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_RetryBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApproveBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApproveBuild() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ApproveBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBuildTrigger() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBuildTrigger() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBuildTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBuildTriggers() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListBuildTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuildTriggers(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBuildTrigger() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateBuildTrigger() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_UpdateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RunBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RunBuildTrigger() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_RunBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReceiveTriggerWebhook : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReceiveTriggerWebhook() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ReceiveTriggerWebhook() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateWorkerPool() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetWorkerPool() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_GetWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteWorkerPool() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_DeleteWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateWorkerPool() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_UpdateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListWorkerPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListWorkerPools() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_ListWorkerPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkerPools(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBuild() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBuild(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBuild() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBuild(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBuilds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBuilds() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListBuilds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuilds(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBuilds(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelBuild() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CancelBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelBuild(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RetryBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RetryBuild() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_RetryBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetryBuild(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApproveBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApproveBuild() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ApproveBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveBuild(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBuildTrigger() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBuildTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBuildTrigger() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBuildTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBuildTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBuildTriggers() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListBuildTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuildTriggers(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBuildTriggers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBuildTrigger() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBuildTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateBuildTrigger() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_UpdateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBuildTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RunBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RunBuildTrigger() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_RunBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunBuildTrigger(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReceiveTriggerWebhook : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReceiveTriggerWebhook() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ReceiveTriggerWebhook() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReceiveTriggerWebhook(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateWorkerPool() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkerPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetWorkerPool() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_GetWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkerPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteWorkerPool() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_DeleteWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkerPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateWorkerPool() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_UpdateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkerPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListWorkerPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListWorkerPools() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_ListWorkerPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkerPools(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkerPools(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBuild() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBuild(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBuild() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBuild(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBuilds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBuilds() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBuilds(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBuilds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuilds(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBuilds(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelBuild() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelBuild(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RetryBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RetryBuild() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RetryBuild(context, request, response); }));
    }
    ~WithRawCallbackMethod_RetryBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetryBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApproveBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApproveBuild() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApproveBuild(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApproveBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveBuild(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBuildTrigger() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBuildTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBuildTrigger() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBuildTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBuildTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBuildTriggers() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBuildTriggers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBuildTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBuildTriggers(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBuildTriggers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBuildTrigger() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBuildTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateBuildTrigger() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateBuildTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RunBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RunBuildTrigger() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RunBuildTrigger(context, request, response); }));
    }
    ~WithRawCallbackMethod_RunBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunBuildTrigger(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReceiveTriggerWebhook : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReceiveTriggerWebhook() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReceiveTriggerWebhook(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReceiveTriggerWebhook() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReceiveTriggerWebhook(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateWorkerPool() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateWorkerPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetWorkerPool() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetWorkerPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteWorkerPool() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteWorkerPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateWorkerPool() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateWorkerPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkerPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListWorkerPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListWorkerPools() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListWorkerPools(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListWorkerPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkerPools(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkerPools(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBuild() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::CreateBuildRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::CreateBuildRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateBuild(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBuild(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::CreateBuildRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBuild() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::GetBuildRequest, ::google::devtools::cloudbuild::v1::Build>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::GetBuildRequest, ::google::devtools::cloudbuild::v1::Build>* streamer) {
                       return this->StreamedGetBuild(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBuild(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::GetBuildRequest,::google::devtools::cloudbuild::v1::Build>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBuilds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBuilds() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::ListBuildsRequest, ::google::devtools::cloudbuild::v1::ListBuildsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::ListBuildsRequest, ::google::devtools::cloudbuild::v1::ListBuildsResponse>* streamer) {
                       return this->StreamedListBuilds(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBuilds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBuilds(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBuilds(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::ListBuildsRequest,::google::devtools::cloudbuild::v1::ListBuildsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelBuild() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::CancelBuildRequest, ::google::devtools::cloudbuild::v1::Build>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::CancelBuildRequest, ::google::devtools::cloudbuild::v1::Build>* streamer) {
                       return this->StreamedCancelBuild(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CancelBuildRequest* /*request*/, ::google::devtools::cloudbuild::v1::Build* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelBuild(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::CancelBuildRequest,::google::devtools::cloudbuild::v1::Build>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RetryBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RetryBuild() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::RetryBuildRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::RetryBuildRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRetryBuild(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RetryBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RetryBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RetryBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRetryBuild(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::RetryBuildRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApproveBuild : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApproveBuild() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::ApproveBuildRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::ApproveBuildRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedApproveBuild(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApproveBuild() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApproveBuild(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ApproveBuildRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApproveBuild(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::ApproveBuildRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBuildTrigger() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>* streamer) {
                       return this->StreamedCreateBuildTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBuildTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::CreateBuildTriggerRequest,::google::devtools::cloudbuild::v1::BuildTrigger>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBuildTrigger() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>* streamer) {
                       return this->StreamedGetBuildTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBuildTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::GetBuildTriggerRequest,::google::devtools::cloudbuild::v1::BuildTrigger>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBuildTriggers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBuildTriggers() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* streamer) {
                       return this->StreamedListBuildTriggers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBuildTriggers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBuildTriggers(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListBuildTriggersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBuildTriggers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::ListBuildTriggersRequest,::google::devtools::cloudbuild::v1::ListBuildTriggersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBuildTrigger() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteBuildTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBuildTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::DeleteBuildTriggerRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateBuildTrigger() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest, ::google::devtools::cloudbuild::v1::BuildTrigger>* streamer) {
                       return this->StreamedUpdateBuildTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest* /*request*/, ::google::devtools::cloudbuild::v1::BuildTrigger* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateBuildTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::UpdateBuildTriggerRequest,::google::devtools::cloudbuild::v1::BuildTrigger>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RunBuildTrigger : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RunBuildTrigger() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRunBuildTrigger(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RunBuildTrigger() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RunBuildTrigger(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRunBuildTrigger(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::RunBuildTriggerRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReceiveTriggerWebhook : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReceiveTriggerWebhook() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* streamer) {
                       return this->StreamedReceiveTriggerWebhook(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReceiveTriggerWebhook() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReceiveTriggerWebhook(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest* /*request*/, ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReceiveTriggerWebhook(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookRequest,::google::devtools::cloudbuild::v1::ReceiveTriggerWebhookResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateWorkerPool() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateWorkerPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateWorkerPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::CreateWorkerPoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetWorkerPool() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest, ::google::devtools::cloudbuild::v1::WorkerPool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest, ::google::devtools::cloudbuild::v1::WorkerPool>* streamer) {
                       return this->StreamedGetWorkerPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest* /*request*/, ::google::devtools::cloudbuild::v1::WorkerPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetWorkerPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::GetWorkerPoolRequest,::google::devtools::cloudbuild::v1::WorkerPool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteWorkerPool() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteWorkerPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteWorkerPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::DeleteWorkerPoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateWorkerPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateWorkerPool() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateWorkerPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateWorkerPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateWorkerPool(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateWorkerPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::UpdateWorkerPoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListWorkerPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListWorkerPools() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* streamer) {
                       return this->StreamedListWorkerPools(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListWorkerPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListWorkerPools(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest* /*request*/, ::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListWorkerPools(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudbuild::v1::ListWorkerPoolsRequest,::google::devtools::cloudbuild::v1::ListWorkerPoolsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateBuild<WithStreamedUnaryMethod_GetBuild<WithStreamedUnaryMethod_ListBuilds<WithStreamedUnaryMethod_CancelBuild<WithStreamedUnaryMethod_RetryBuild<WithStreamedUnaryMethod_ApproveBuild<WithStreamedUnaryMethod_CreateBuildTrigger<WithStreamedUnaryMethod_GetBuildTrigger<WithStreamedUnaryMethod_ListBuildTriggers<WithStreamedUnaryMethod_DeleteBuildTrigger<WithStreamedUnaryMethod_UpdateBuildTrigger<WithStreamedUnaryMethod_RunBuildTrigger<WithStreamedUnaryMethod_ReceiveTriggerWebhook<WithStreamedUnaryMethod_CreateWorkerPool<WithStreamedUnaryMethod_GetWorkerPool<WithStreamedUnaryMethod_DeleteWorkerPool<WithStreamedUnaryMethod_UpdateWorkerPool<WithStreamedUnaryMethod_ListWorkerPools<Service > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateBuild<WithStreamedUnaryMethod_GetBuild<WithStreamedUnaryMethod_ListBuilds<WithStreamedUnaryMethod_CancelBuild<WithStreamedUnaryMethod_RetryBuild<WithStreamedUnaryMethod_ApproveBuild<WithStreamedUnaryMethod_CreateBuildTrigger<WithStreamedUnaryMethod_GetBuildTrigger<WithStreamedUnaryMethod_ListBuildTriggers<WithStreamedUnaryMethod_DeleteBuildTrigger<WithStreamedUnaryMethod_UpdateBuildTrigger<WithStreamedUnaryMethod_RunBuildTrigger<WithStreamedUnaryMethod_ReceiveTriggerWebhook<WithStreamedUnaryMethod_CreateWorkerPool<WithStreamedUnaryMethod_GetWorkerPool<WithStreamedUnaryMethod_DeleteWorkerPool<WithStreamedUnaryMethod_UpdateWorkerPool<WithStreamedUnaryMethod_ListWorkerPools<Service > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace cloudbuild
}  // namespace devtools
}  // namespace google


#endif  // GRPC_google_2fdevtools_2fcloudbuild_2fv1_2fcloudbuild_2eproto__INCLUDED
